
#include <torch/csrc/inductor/aoti_torch/tensor_converter.h>
#include <torch/csrc/inductor/aoti_torch/utils.h>
#include <torch/csrc/inductor/aoti_torch/generated/c_shim_cpu.h>

#ifndef AT_PER_OPERATOR_HEADERS
#include <ATen/CPUFunctions.h>
#include <ATen/CompositeExplicitAutogradFunctions.h>
#include <ATen/CompositeExplicitAutogradNonFunctionalFunctions.h>
#else
#include <ATen/ops/_adaptive_avg_pool2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool2d_backward_cpu_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool2d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool2d_cpu_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_backward_cpu_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_adaptive_avg_pool3d_cpu_dispatch.h>
#include <ATen/ops/_add_relu_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_add_relu_cpu_dispatch.h>
#include <ATen/ops/_addmm_activation_cpu_dispatch.h>
#include <ATen/ops/_aminmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_aminmax_cpu_dispatch.h>
#include <ATen/ops/_amp_foreach_non_finite_check_and_unscale_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_amp_foreach_non_finite_check_and_unscale_cpu_dispatch.h>
#include <ATen/ops/_amp_update_scale_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_amp_update_scale_cpu_dispatch.h>
#include <ATen/ops/_assert_async_cpu_dispatch.h>
#include <ATen/ops/_assert_scalar_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cdist_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cdist_backward_cpu_dispatch.h>
#include <ATen/ops/_cdist_forward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cdist_forward_cpu_dispatch.h>
#include <ATen/ops/_cholesky_solve_helper_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cholesky_solve_helper_cpu_dispatch.h>
#include <ATen/ops/_chunk_cat_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_coalesce_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_coalesced_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_compute_linear_combination_cpu_dispatch.h>
#include <ATen/ops/_conj_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_conj_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_conj_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_conj_physical_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_convert_indices_from_coo_to_csr_cpu_dispatch.h>
#include <ATen/ops/_convert_indices_from_csr_to_coo_cpu_dispatch.h>
#include <ATen/ops/_convert_weight_to_int4pack_cpu_dispatch.h>
#include <ATen/ops/_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_copy_from_and_resize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_copy_from_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_ctc_loss_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_ctc_loss_backward_cpu_dispatch.h>
#include <ATen/ops/_ctc_loss_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_ctc_loss_cpu_dispatch.h>
#include <ATen/ops/_cudnn_ctc_loss_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cudnn_init_dropout_state_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cudnn_rnn_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cudnn_rnn_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cudnn_rnn_flatten_weight_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_cummax_helper_cpu_dispatch.h>
#include <ATen/ops/_cummin_helper_cpu_dispatch.h>
#include <ATen/ops/_dirichlet_grad_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_dirichlet_grad_cpu_dispatch.h>
#include <ATen/ops/_efficientzerotensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_efficientzerotensor_cpu_dispatch.h>
#include <ATen/ops/_embedding_bag_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_embedding_bag_cpu_dispatch.h>
#include <ATen/ops/_embedding_bag_dense_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_embedding_bag_dense_backward_cpu_dispatch.h>
#include <ATen/ops/_embedding_bag_forward_only_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_embedding_bag_forward_only_cpu_dispatch.h>
#include <ATen/ops/_embedding_bag_per_sample_weights_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_embedding_bag_per_sample_weights_backward_cpu_dispatch.h>
#include <ATen/ops/_empty_affine_quantized_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_empty_affine_quantized_cpu_dispatch.h>
#include <ATen/ops/_empty_per_channel_affine_quantized_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_empty_per_channel_affine_quantized_cpu_dispatch.h>
#include <ATen/ops/_euclidean_dist_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_channel_affine_backward_cpu_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_channel_affine_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_channel_affine_cpu_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_tensor_affine_backward_cpu_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_tensor_affine_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fake_quantize_learnable_per_tensor_affine_cpu_dispatch.h>
#include <ATen/ops/_fake_quantize_per_tensor_affine_cachemask_tensor_qparams_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fake_quantize_per_tensor_affine_cachemask_tensor_qparams_cpu_dispatch.h>
#include <ATen/ops/_fft_c2c_cpu_dispatch.h>
#include <ATen/ops/_fft_c2r_cpu_dispatch.h>
#include <ATen/ops/_fft_r2c_cpu_dispatch.h>
#include <ATen/ops/_foobar_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foobar_cpu_dispatch.h>
#include <ATen/ops/_foreach_abs_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_abs_cpu_dispatch.h>
#include <ATen/ops/_foreach_acos_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_acos_cpu_dispatch.h>
#include <ATen/ops/_foreach_add_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_add_cpu_dispatch.h>
#include <ATen/ops/_foreach_addcdiv_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_addcdiv_cpu_dispatch.h>
#include <ATen/ops/_foreach_addcmul_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_addcmul_cpu_dispatch.h>
#include <ATen/ops/_foreach_asin_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_asin_cpu_dispatch.h>
#include <ATen/ops/_foreach_atan_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_atan_cpu_dispatch.h>
#include <ATen/ops/_foreach_ceil_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_ceil_cpu_dispatch.h>
#include <ATen/ops/_foreach_clamp_max_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_clamp_max_cpu_dispatch.h>
#include <ATen/ops/_foreach_clamp_min_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_clamp_min_cpu_dispatch.h>
#include <ATen/ops/_foreach_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_copy_cpu_dispatch.h>
#include <ATen/ops/_foreach_cos_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_cos_cpu_dispatch.h>
#include <ATen/ops/_foreach_cosh_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_cosh_cpu_dispatch.h>
#include <ATen/ops/_foreach_div_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_div_cpu_dispatch.h>
#include <ATen/ops/_foreach_erf_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_erf_cpu_dispatch.h>
#include <ATen/ops/_foreach_erfc_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_erfc_cpu_dispatch.h>
#include <ATen/ops/_foreach_exp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_exp_cpu_dispatch.h>
#include <ATen/ops/_foreach_expm1_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_expm1_cpu_dispatch.h>
#include <ATen/ops/_foreach_floor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_floor_cpu_dispatch.h>
#include <ATen/ops/_foreach_frac_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_frac_cpu_dispatch.h>
#include <ATen/ops/_foreach_lerp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_lerp_cpu_dispatch.h>
#include <ATen/ops/_foreach_lgamma_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_lgamma_cpu_dispatch.h>
#include <ATen/ops/_foreach_log10_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_log10_cpu_dispatch.h>
#include <ATen/ops/_foreach_log1p_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_log1p_cpu_dispatch.h>
#include <ATen/ops/_foreach_log2_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_log2_cpu_dispatch.h>
#include <ATen/ops/_foreach_log_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_log_cpu_dispatch.h>
#include <ATen/ops/_foreach_maximum_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_maximum_cpu_dispatch.h>
#include <ATen/ops/_foreach_minimum_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_minimum_cpu_dispatch.h>
#include <ATen/ops/_foreach_mul_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_mul_cpu_dispatch.h>
#include <ATen/ops/_foreach_neg_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_neg_cpu_dispatch.h>
#include <ATen/ops/_foreach_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_norm_cpu_dispatch.h>
#include <ATen/ops/_foreach_pow_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_pow_cpu_dispatch.h>
#include <ATen/ops/_foreach_reciprocal_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_reciprocal_cpu_dispatch.h>
#include <ATen/ops/_foreach_round_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_round_cpu_dispatch.h>
#include <ATen/ops/_foreach_sigmoid_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sigmoid_cpu_dispatch.h>
#include <ATen/ops/_foreach_sign_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sign_cpu_dispatch.h>
#include <ATen/ops/_foreach_sin_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sin_cpu_dispatch.h>
#include <ATen/ops/_foreach_sinh_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sinh_cpu_dispatch.h>
#include <ATen/ops/_foreach_sqrt_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sqrt_cpu_dispatch.h>
#include <ATen/ops/_foreach_sub_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_sub_cpu_dispatch.h>
#include <ATen/ops/_foreach_tan_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_tan_cpu_dispatch.h>
#include <ATen/ops/_foreach_tanh_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_tanh_cpu_dispatch.h>
#include <ATen/ops/_foreach_trunc_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_trunc_cpu_dispatch.h>
#include <ATen/ops/_foreach_zero_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_foreach_zero_cpu_dispatch.h>
#include <ATen/ops/_functional_assert_async_cpu_dispatch.h>
#include <ATen/ops/_functional_assert_scalar_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_functional_sym_constrain_range_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_functional_sym_constrain_range_for_size_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fused_adam_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fused_adamw_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fused_dropout_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fused_moving_avg_obs_fq_helper_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fused_moving_avg_obs_fq_helper_cpu_dispatch.h>
#include <ATen/ops/_fused_sdp_choice_cpu_dispatch.h>
#include <ATen/ops/_fused_sgd_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fw_primal_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fw_primal_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_fw_primal_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_grid_sampler_2d_cpu_fallback_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_has_same_storage_numel_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_histogramdd_bin_edges_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_histogramdd_bin_edges_cpu_dispatch.h>
#include <ATen/ops/_histogramdd_from_bin_cts_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_histogramdd_from_bin_cts_cpu_dispatch.h>
#include <ATen/ops/_histogramdd_from_bin_tensors_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_histogramdd_from_bin_tensors_cpu_dispatch.h>
#include <ATen/ops/_index_put_impl_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_index_put_impl_cpu_dispatch.h>
#include <ATen/ops/_indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_is_all_true_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_is_any_true_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_lazy_clone_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_linalg_check_errors_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_linalg_det_cpu_dispatch.h>
#include <ATen/ops/_linalg_eigh_cpu_dispatch.h>
#include <ATen/ops/_linalg_eigvals_cpu_dispatch.h>
#include <ATen/ops/_linalg_slogdet_cpu_dispatch.h>
#include <ATen/ops/_linalg_solve_ex_cpu_dispatch.h>
#include <ATen/ops/_linalg_svd_cpu_dispatch.h>
#include <ATen/ops/_local_scalar_dense_cpu_dispatch.h>
#include <ATen/ops/_log_softmax_backward_data_cpu_dispatch.h>
#include <ATen/ops/_log_softmax_cpu_dispatch.h>
#include <ATen/ops/_logcumsumexp_cpu_dispatch.h>
#include <ATen/ops/_lstm_mps_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_make_dep_token_cpu_dispatch.h>
#include <ATen/ops/_make_dual_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_make_dual_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_make_dual_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_make_per_channel_quantized_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_make_per_channel_quantized_tensor_cpu_dispatch.h>
#include <ATen/ops/_make_per_tensor_quantized_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_make_per_tensor_quantized_tensor_cpu_dispatch.h>
#include <ATen/ops/_masked_scale_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_masked_softmax_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_masked_softmax_backward_cpu_dispatch.h>
#include <ATen/ops/_masked_softmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_masked_softmax_cpu_dispatch.h>
#include <ATen/ops/_mkldnn_reshape_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_mkldnn_transpose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_mps_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_mps_convolution_transpose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_native_batch_norm_legit_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_native_batch_norm_legit_cpu_dispatch.h>
#include <ATen/ops/_native_batch_norm_legit_no_training_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_native_multi_head_attention_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_native_multi_head_attention_cpu_dispatch.h>
#include <ATen/ops/_neg_view_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_neg_view_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_neg_view_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_nested_from_padded_and_nested_example_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_from_padded_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_from_padded_cpu_dispatch.h>
#include <ATen/ops/_nested_get_values_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_get_values_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_nested_tensor_from_mask_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_tensor_from_mask_cpu_dispatch.h>
#include <ATen/ops/_nested_tensor_from_mask_left_aligned_cpu_dispatch.h>
#include <ATen/ops/_nested_tensor_from_tensor_list_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_tensor_size_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_tensor_storage_offsets_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_tensor_strides_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_view_from_buffer_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_view_from_buffer_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_nested_view_from_buffer_cpu_dispatch.h>
#include <ATen/ops/_nested_view_from_jagged_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nested_view_from_jagged_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_new_zeros_with_same_feature_meta_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_nnpack_spatial_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_pack_padded_sequence_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_pdist_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_pdist_backward_cpu_dispatch.h>
#include <ATen/ops/_pdist_forward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_pdist_forward_cpu_dispatch.h>
#include <ATen/ops/_pin_memory_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_prelu_kernel_backward_cpu_dispatch.h>
#include <ATen/ops/_prelu_kernel_cpu_dispatch.h>
#include <ATen/ops/_print_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_reshape_alias_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_reshape_alias_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_reshape_alias_cpu_dispatch.h>
#include <ATen/ops/_reshape_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_resize_output_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sample_dirichlet_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sample_dirichlet_cpu_dispatch.h>
#include <ATen/ops/_scaled_dot_product_flash_attention_for_cpu_backward_cpu_dispatch.h>
#include <ATen/ops/_scaled_dot_product_flash_attention_for_cpu_cpu_dispatch.h>
#include <ATen/ops/_segment_reduce_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_segment_reduce_backward_cpu_dispatch.h>
#include <ATen/ops/_slow_conv2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_slow_conv2d_backward_cpu_dispatch.h>
#include <ATen/ops/_slow_conv2d_forward_cpu_dispatch.h>
#include <ATen/ops/_softmax_backward_data_cpu_dispatch.h>
#include <ATen/ops/_softmax_cpu_dispatch.h>
#include <ATen/ops/_sparse_addmm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_broadcast_to_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_broadcast_to_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_sparse_coo_tensor_with_dims_and_tensors_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_coo_tensor_with_dims_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_csr_prod_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_csr_sum_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_log_softmax_backward_data_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_log_softmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_mask_projection_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_softmax_backward_data_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_softmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_sparse_matmul_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_sum_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_sparse_sum_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_spdiags_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_spdiags_cpu_dispatch.h>
#include <ATen/ops/_stack_cpu_dispatch.h>
#include <ATen/ops/_standard_gamma_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_standard_gamma_cpu_dispatch.h>
#include <ATen/ops/_standard_gamma_grad_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_standard_gamma_grad_cpu_dispatch.h>
#include <ATen/ops/_test_autograd_multiple_dispatch_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_autograd_multiple_dispatch_view_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_autograd_multiple_dispatch_view_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_autograd_multiple_dispatch_view_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_test_functorch_fallback_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_functorch_fallback_cpu_dispatch.h>
#include <ATen/ops/_test_optional_filled_intlist_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_optional_filled_intlist_cpu_dispatch.h>
#include <ATen/ops/_test_optional_floatlist_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_optional_floatlist_cpu_dispatch.h>
#include <ATen/ops/_test_optional_intlist_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_optional_intlist_cpu_dispatch.h>
#include <ATen/ops/_test_parallel_materialize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_test_warn_in_autograd_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_thnn_fused_gru_cell_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_thnn_fused_gru_cell_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_thnn_fused_lstm_cell_backward_impl_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_thnn_fused_lstm_cell_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_dense_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_bsc_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_bsc_cpu_dispatch.h>
#include <ATen/ops/_to_sparse_bsr_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_bsr_cpu_dispatch.h>
#include <ATen/ops/_to_sparse_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_cpu_dispatch.h>
#include <ATen/ops/_to_sparse_csc_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_csc_cpu_dispatch.h>
#include <ATen/ops/_to_sparse_csr_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_to_sparse_csr_cpu_dispatch.h>
#include <ATen/ops/_transform_bias_rescale_qkv_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_transform_bias_rescale_qkv_cpu_dispatch.h>
#include <ATen/ops/_transformer_encoder_layer_fwd_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_transformer_encoder_layer_fwd_cpu_dispatch.h>
#include <ATen/ops/_trilinear_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_trilinear_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_triton_multi_head_attention_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_triton_scaled_dot_attention_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_unique2_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_unique2_cpu_dispatch.h>
#include <ATen/ops/_unique_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_unique_cpu_dispatch.h>
#include <ATen/ops/_unsafe_index_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_unsafe_index_put_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_unsafe_view_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_upsample_bicubic2d_aa_backward_cpu_dispatch.h>
#include <ATen/ops/_upsample_bicubic2d_aa_cpu_dispatch.h>
#include <ATen/ops/_upsample_bilinear2d_aa_backward_cpu_dispatch.h>
#include <ATen/ops/_upsample_bilinear2d_aa_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact1d_backward_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact1d_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact2d_backward_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact2d_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact3d_backward_cpu_dispatch.h>
#include <ATen/ops/_upsample_nearest_exact3d_cpu_dispatch.h>
#include <ATen/ops/_validate_compressed_sparse_indices_cpu_dispatch.h>
#include <ATen/ops/_values_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_values_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/_weight_int4pack_mm_cpu_dispatch.h>
#include <ATen/ops/_weight_int8pack_mm_cpu_dispatch.h>
#include <ATen/ops/_weight_norm_interface_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_weight_norm_interface_backward_cpu_dispatch.h>
#include <ATen/ops/_weight_norm_interface_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/_weight_norm_interface_cpu_dispatch.h>
#include <ATen/ops/abs_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/adaptive_avg_pool2d_cpu_dispatch.h>
#include <ATen/ops/adaptive_avg_pool3d_backward_cpu_dispatch.h>
#include <ATen/ops/adaptive_avg_pool3d_cpu_dispatch.h>
#include <ATen/ops/adaptive_max_pool2d_backward_cpu_dispatch.h>
#include <ATen/ops/adaptive_max_pool2d_cpu_dispatch.h>
#include <ATen/ops/adaptive_max_pool3d_backward_cpu_dispatch.h>
#include <ATen/ops/adaptive_max_pool3d_cpu_dispatch.h>
#include <ATen/ops/add_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/addbmm_cpu_dispatch.h>
#include <ATen/ops/addmm_cpu_dispatch.h>
#include <ATen/ops/addmv_cpu_dispatch.h>
#include <ATen/ops/addr_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/addr_cpu_dispatch.h>
#include <ATen/ops/affine_grid_generator_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/alias_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/alias_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/alias_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/all_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/all_cpu_dispatch.h>
#include <ATen/ops/allclose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/amax_cpu_dispatch.h>
#include <ATen/ops/amin_cpu_dispatch.h>
#include <ATen/ops/aminmax_cpu_dispatch.h>
#include <ATen/ops/any_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/any_cpu_dispatch.h>
#include <ATen/ops/arange_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/arange_cpu_dispatch.h>
#include <ATen/ops/argmax_cpu_dispatch.h>
#include <ATen/ops/argmin_cpu_dispatch.h>
#include <ATen/ops/argsort_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/argsort_cpu_dispatch.h>
#include <ATen/ops/as_strided_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/as_strided_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/as_strided_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/as_strided_cpu_dispatch.h>
#include <ATen/ops/as_strided_scatter_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/as_strided_scatter_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/avg_pool2d_backward_cpu_dispatch.h>
#include <ATen/ops/avg_pool2d_cpu_dispatch.h>
#include <ATen/ops/avg_pool3d_backward_cpu_dispatch.h>
#include <ATen/ops/avg_pool3d_cpu_dispatch.h>
#include <ATen/ops/baddbmm_cpu_dispatch.h>
#include <ATen/ops/bartlett_window_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_backward_elemt_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_backward_reduce_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_gather_stats_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_gather_stats_with_counts_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_stats_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_update_stats_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/batch_norm_update_stats_cpu_dispatch.h>
#include <ATen/ops/bernoulli_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bernoulli_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/bernoulli_cpu_dispatch.h>
#include <ATen/ops/binary_cross_entropy_backward_cpu_dispatch.h>
#include <ATen/ops/binary_cross_entropy_cpu_dispatch.h>
#include <ATen/ops/binary_cross_entropy_with_logits_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bincount_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bincount_cpu_dispatch.h>
#include <ATen/ops/binomial_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/binomial_cpu_dispatch.h>
#include <ATen/ops/bitwise_and_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bitwise_left_shift_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bitwise_or_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bitwise_right_shift_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bitwise_xor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/blackman_window_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/block_diag_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bmm_cpu_dispatch.h>
#include <ATen/ops/bucketize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/bucketize_cpu_dispatch.h>
#include <ATen/ops/cat_cpu_dispatch.h>
#include <ATen/ops/cauchy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cauchy_cpu_dispatch.h>
#include <ATen/ops/ccol_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/ccol_indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/ccol_indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/celu_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/channel_shuffle_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/channel_shuffle_cpu_dispatch.h>
#include <ATen/ops/cholesky_cpu_dispatch.h>
#include <ATen/ops/cholesky_inverse_cpu_dispatch.h>
#include <ATen/ops/cholesky_solve_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/clone_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/col2im_cpu_dispatch.h>
#include <ATen/ops/col_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/col_indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/col_indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/complex_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/complex_cpu_dispatch.h>
#include <ATen/ops/constant_pad_nd_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/conv_depthwise3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/conv_tbc_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/convolution_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/convolution_backward_overrideable_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/convolution_overrideable_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/copy_sparse_to_sparse_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/copysign_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/count_nonzero_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/count_nonzero_cpu_dispatch.h>
#include <ATen/ops/crow_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/crow_indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/crow_indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/cudnn_affine_grid_generator_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_affine_grid_generator_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_batch_norm_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_batch_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_convolution_add_relu_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_convolution_relu_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_convolution_transpose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_grid_sampler_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cudnn_grid_sampler_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cummax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cummin_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/cumprod_cpu_dispatch.h>
#include <ATen/ops/cumsum_cpu_dispatch.h>
#include <ATen/ops/dense_dim_cpu_dispatch.h>
#include <ATen/ops/dequantize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/dequantize_cpu_dispatch.h>
#include <ATen/ops/detach_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/detach_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/detach_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/diag_embed_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/diag_embed_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/diagonal_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/diagonal_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/diagonal_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/diagonal_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/diagonal_scatter_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/diagonal_scatter_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/dist_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/div_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/dot_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/dot_cpu_dispatch.h>
#include <ATen/ops/elu_backward_cpu_dispatch.h>
#include <ATen/ops/elu_cpu_dispatch.h>
#include <ATen/ops/embedding_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/embedding_dense_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/embedding_dense_backward_cpu_dispatch.h>
#include <ATen/ops/embedding_renorm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/embedding_renorm_cpu_dispatch.h>
#include <ATen/ops/empty_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/empty_cpu_dispatch.h>
#include <ATen/ops/empty_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/empty_permuted_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/empty_quantized_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/empty_strided_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/empty_strided_cpu_dispatch.h>
#include <ATen/ops/expand_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/expand_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/expand_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/exponential_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/exponential_cpu_dispatch.h>
#include <ATen/ops/eye_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/eye_cpu_dispatch.h>
#include <ATen/ops/fake_quantize_per_channel_affine_cachemask_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/fake_quantize_per_channel_affine_cachemask_cpu_dispatch.h>
#include <ATen/ops/fake_quantize_per_tensor_affine_cachemask_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/fake_quantize_per_tensor_affine_cachemask_cpu_dispatch.h>
#include <ATen/ops/fft_fftfreq_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/fft_rfftfreq_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/fill_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/fill_cpu_dispatch.h>
#include <ATen/ops/flip_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/flip_cpu_dispatch.h>
#include <ATen/ops/floor_divide_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/floor_divide_cpu_dispatch.h>
#include <ATen/ops/fractional_max_pool2d_backward_cpu_dispatch.h>
#include <ATen/ops/fractional_max_pool2d_cpu_dispatch.h>
#include <ATen/ops/fractional_max_pool3d_backward_cpu_dispatch.h>
#include <ATen/ops/fractional_max_pool3d_cpu_dispatch.h>
#include <ATen/ops/from_file_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/from_file_cpu_dispatch.h>
#include <ATen/ops/full_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/full_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/gather_cpu_dispatch.h>
#include <ATen/ops/gelu_backward_cpu_dispatch.h>
#include <ATen/ops/gelu_cpu_dispatch.h>
#include <ATen/ops/geometric_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/geometric_cpu_dispatch.h>
#include <ATen/ops/geqrf_cpu_dispatch.h>
#include <ATen/ops/glu_backward_cpu_dispatch.h>
#include <ATen/ops/glu_backward_jvp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/glu_backward_jvp_cpu_dispatch.h>
#include <ATen/ops/glu_cpu_dispatch.h>
#include <ATen/ops/glu_jvp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/glu_jvp_cpu_dispatch.h>
#include <ATen/ops/grid_sampler_2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/grid_sampler_2d_backward_cpu_dispatch.h>
#include <ATen/ops/grid_sampler_2d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/grid_sampler_2d_cpu_dispatch.h>
#include <ATen/ops/grid_sampler_3d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/grid_sampler_3d_backward_cpu_dispatch.h>
#include <ATen/ops/grid_sampler_3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/grid_sampler_3d_cpu_dispatch.h>
#include <ATen/ops/hamming_window_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/hann_window_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/hardshrink_backward_cpu_dispatch.h>
#include <ATen/ops/hardshrink_cpu_dispatch.h>
#include <ATen/ops/hardsigmoid_backward_cpu_dispatch.h>
#include <ATen/ops/hardsigmoid_cpu_dispatch.h>
#include <ATen/ops/hardswish_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/hardswish_backward_cpu_dispatch.h>
#include <ATen/ops/hardswish_cpu_dispatch.h>
#include <ATen/ops/hardtanh_backward_cpu_dispatch.h>
#include <ATen/ops/hardtanh_cpu_dispatch.h>
#include <ATen/ops/histc_cpu_dispatch.h>
#include <ATen/ops/histogram_cpu_dispatch.h>
#include <ATen/ops/huber_loss_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/huber_loss_backward_cpu_dispatch.h>
#include <ATen/ops/huber_loss_cpu_dispatch.h>
#include <ATen/ops/im2col_cpu_dispatch.h>
#include <ATen/ops/index_add_cpu_dispatch.h>
#include <ATen/ops/index_copy_cpu_dispatch.h>
#include <ATen/ops/index_cpu_dispatch.h>
#include <ATen/ops/index_fill_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/index_fill_cpu_dispatch.h>
#include <ATen/ops/index_put_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/index_reduce_cpu_dispatch.h>
#include <ATen/ops/index_select_cpu_dispatch.h>
#include <ATen/ops/indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/int_repr_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/is_coalesced_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/is_pinned_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/is_same_size_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/is_set_to_cpu_dispatch.h>
#include <ATen/ops/isin_cpu_dispatch.h>
#include <ATen/ops/isinf_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/isnan_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/kaiser_window_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/kthvalue_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/kthvalue_cpu_dispatch.h>
#include <ATen/ops/leaky_relu_backward_cpu_dispatch.h>
#include <ATen/ops/leaky_relu_cpu_dispatch.h>
#include <ATen/ops/lift_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/lift_fresh_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/lift_fresh_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/lift_fresh_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/linalg_cholesky_ex_cpu_dispatch.h>
#include <ATen/ops/linalg_cross_cpu_dispatch.h>
#include <ATen/ops/linalg_eig_cpu_dispatch.h>
#include <ATen/ops/linalg_eigvals_cpu_dispatch.h>
#include <ATen/ops/linalg_householder_product_cpu_dispatch.h>
#include <ATen/ops/linalg_inv_ex_cpu_dispatch.h>
#include <ATen/ops/linalg_ldl_factor_ex_cpu_dispatch.h>
#include <ATen/ops/linalg_ldl_solve_cpu_dispatch.h>
#include <ATen/ops/linalg_lstsq_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linalg_lstsq_cpu_dispatch.h>
#include <ATen/ops/linalg_lu_cpu_dispatch.h>
#include <ATen/ops/linalg_lu_factor_ex_cpu_dispatch.h>
#include <ATen/ops/linalg_lu_solve_cpu_dispatch.h>
#include <ATen/ops/linalg_matrix_exp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linalg_matrix_exp_cpu_dispatch.h>
#include <ATen/ops/linalg_pinv_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linalg_pinv_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/linalg_qr_cpu_dispatch.h>
#include <ATen/ops/linalg_solve_triangular_cpu_dispatch.h>
#include <ATen/ops/linalg_vector_norm_cpu_dispatch.h>
#include <ATen/ops/linear_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linear_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linspace_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/linspace_cpu_dispatch.h>
#include <ATen/ops/log_normal_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/log_normal_cpu_dispatch.h>
#include <ATen/ops/log_sigmoid_backward_cpu_dispatch.h>
#include <ATen/ops/log_sigmoid_forward_cpu_dispatch.h>
#include <ATen/ops/log_softmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/logcumsumexp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/logspace_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/logspace_cpu_dispatch.h>
#include <ATen/ops/logsumexp_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/logsumexp_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/lshift_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/lstm_mps_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/lu_unpack_cpu_dispatch.h>
#include <ATen/ops/masked_fill_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/masked_fill_cpu_dispatch.h>
#include <ATen/ops/masked_scatter_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/masked_scatter_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/masked_scatter_cpu_dispatch.h>
#include <ATen/ops/masked_select_cpu_dispatch.h>
#include <ATen/ops/matmul_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/max_cpu_dispatch.h>
#include <ATen/ops/max_pool2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/max_pool2d_with_indices_backward_cpu_dispatch.h>
#include <ATen/ops/max_pool2d_with_indices_cpu_dispatch.h>
#include <ATen/ops/max_pool3d_with_indices_backward_cpu_dispatch.h>
#include <ATen/ops/max_pool3d_with_indices_cpu_dispatch.h>
#include <ATen/ops/max_unpool2d_cpu_dispatch.h>
#include <ATen/ops/max_unpool3d_cpu_dispatch.h>
#include <ATen/ops/mean_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mean_cpu_dispatch.h>
#include <ATen/ops/median_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/median_cpu_dispatch.h>
#include <ATen/ops/min_cpu_dispatch.h>
#include <ATen/ops/miopen_batch_norm_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_batch_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_convolution_transpose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_depthwise_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_rnn_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/miopen_rnn_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mish_backward_cpu_dispatch.h>
#include <ATen/ops/mish_cpu_dispatch.h>
#include <ATen/ops/mkldnn_adaptive_avg_pool2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_convolution_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_linear_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_linear_backward_input_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_linear_backward_weights_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_linear_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_max_pool2d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_max_pool2d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_max_pool3d_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_max_pool3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_reorder_conv2d_weight_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_reorder_conv3d_weight_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_rnn_layer_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_rnn_layer_backward_cpu_dispatch.h>
#include <ATen/ops/mkldnn_rnn_layer_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mkldnn_rnn_layer_cpu_dispatch.h>
#include <ATen/ops/mm_cpu_dispatch.h>
#include <ATen/ops/mode_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mode_cpu_dispatch.h>
#include <ATen/ops/mps_convolution_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mps_convolution_transpose_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/mse_loss_backward_cpu_dispatch.h>
#include <ATen/ops/mse_loss_cpu_dispatch.h>
#include <ATen/ops/mul_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/multi_margin_loss_backward_cpu_dispatch.h>
#include <ATen/ops/multi_margin_loss_cpu_dispatch.h>
#include <ATen/ops/multilabel_margin_loss_backward_cpu_dispatch.h>
#include <ATen/ops/multilabel_margin_loss_forward_cpu_dispatch.h>
#include <ATen/ops/multinomial_cpu_dispatch.h>
#include <ATen/ops/mv_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/nanmedian_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/nanmedian_cpu_dispatch.h>
#include <ATen/ops/nansum_cpu_dispatch.h>
#include <ATen/ops/narrow_copy_cpu_dispatch.h>
#include <ATen/ops/native_batch_norm_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_batch_norm_backward_cpu_dispatch.h>
#include <ATen/ops/native_batch_norm_cpu_dispatch.h>
#include <ATen/ops/native_channel_shuffle_cpu_dispatch.h>
#include <ATen/ops/native_dropout_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_dropout_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_dropout_cpu_dispatch.h>
#include <ATen/ops/native_group_norm_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_group_norm_backward_cpu_dispatch.h>
#include <ATen/ops/native_group_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_group_norm_cpu_dispatch.h>
#include <ATen/ops/native_layer_norm_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_layer_norm_backward_cpu_dispatch.h>
#include <ATen/ops/native_layer_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/native_layer_norm_cpu_dispatch.h>
#include <ATen/ops/native_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/new_empty_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/new_empty_strided_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/new_empty_strided_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/new_full_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/new_ones_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/new_zeros_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/nll_loss2d_backward_cpu_dispatch.h>
#include <ATen/ops/nll_loss2d_forward_cpu_dispatch.h>
#include <ATen/ops/nll_loss_backward_cpu_dispatch.h>
#include <ATen/ops/nll_loss_forward_cpu_dispatch.h>
#include <ATen/ops/nonzero_cpu_dispatch.h>
#include <ATen/ops/nonzero_static_cpu_dispatch.h>
#include <ATen/ops/norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/norm_cpu_dispatch.h>
#include <ATen/ops/normal_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/normal_cpu_dispatch.h>
#include <ATen/ops/ones_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/ones_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/ormqr_cpu_dispatch.h>
#include <ATen/ops/permute_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/permute_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/permute_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/pixel_shuffle_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/pixel_shuffle_cpu_dispatch.h>
#include <ATen/ops/pixel_unshuffle_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/pixel_unshuffle_cpu_dispatch.h>
#include <ATen/ops/poisson_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/poisson_cpu_dispatch.h>
#include <ATen/ops/polar_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/polar_cpu_dispatch.h>
#include <ATen/ops/prod_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/prod_cpu_dispatch.h>
#include <ATen/ops/put_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/put_cpu_dispatch.h>
#include <ATen/ops/q_per_channel_scales_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/q_per_channel_zero_points_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantize_per_channel_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantize_per_channel_cpu_dispatch.h>
#include <ATen/ops/quantize_per_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantize_per_tensor_cpu_dispatch.h>
#include <ATen/ops/quantize_per_tensor_dynamic_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantize_per_tensor_dynamic_cpu_dispatch.h>
#include <ATen/ops/quantized_batch_norm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantized_max_pool1d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantized_max_pool2d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/quantized_max_pool3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rad2deg_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rand_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rand_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/randint_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/randint_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/randn_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/randn_like_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/random_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/random_cpu_dispatch.h>
#include <ATen/ops/randperm_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/randperm_cpu_dispatch.h>
#include <ATen/ops/range_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/range_cpu_dispatch.h>
#include <ATen/ops/reflection_pad1d_backward_cpu_dispatch.h>
#include <ATen/ops/reflection_pad1d_cpu_dispatch.h>
#include <ATen/ops/reflection_pad2d_backward_cpu_dispatch.h>
#include <ATen/ops/reflection_pad2d_cpu_dispatch.h>
#include <ATen/ops/reflection_pad3d_backward_cpu_dispatch.h>
#include <ATen/ops/reflection_pad3d_cpu_dispatch.h>
#include <ATen/ops/relu_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/remainder_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/renorm_cpu_dispatch.h>
#include <ATen/ops/repeat_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/repeat_interleave_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/repeat_interleave_cpu_dispatch.h>
#include <ATen/ops/replication_pad1d_backward_cpu_dispatch.h>
#include <ATen/ops/replication_pad1d_cpu_dispatch.h>
#include <ATen/ops/replication_pad2d_backward_cpu_dispatch.h>
#include <ATen/ops/replication_pad2d_cpu_dispatch.h>
#include <ATen/ops/replication_pad3d_backward_cpu_dispatch.h>
#include <ATen/ops/replication_pad3d_cpu_dispatch.h>
#include <ATen/ops/resize_as_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/resize_as_sparse_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/resize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/resize_cpu_dispatch.h>
#include <ATen/ops/roll_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/roll_cpu_dispatch.h>
#include <ATen/ops/rot90_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/row_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/row_indices_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/row_indices_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/rrelu_with_noise_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rrelu_with_noise_cpu_dispatch.h>
#include <ATen/ops/rshift_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rshift_cpu_dispatch.h>
#include <ATen/ops/rsub_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/rsub_cpu_dispatch.h>
#include <ATen/ops/scalar_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/scatter_add_cpu_dispatch.h>
#include <ATen/ops/scatter_cpu_dispatch.h>
#include <ATen/ops/scatter_reduce_cpu_dispatch.h>
#include <ATen/ops/searchsorted_cpu_dispatch.h>
#include <ATen/ops/segment_reduce_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/segment_reduce_cpu_dispatch.h>
#include <ATen/ops/select_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/select_backward_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/select_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/select_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/select_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/select_scatter_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/select_scatter_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/set_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/set_cpu_dispatch.h>
#include <ATen/ops/slice_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slice_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slice_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slice_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/slice_inverse_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slice_scatter_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slice_scatter_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/slow_conv3d_forward_cpu_dispatch.h>
#include <ATen/ops/slow_conv_dilated2d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slow_conv_dilated2d_cpu_dispatch.h>
#include <ATen/ops/slow_conv_dilated3d_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/slow_conv_dilated3d_cpu_dispatch.h>
#include <ATen/ops/slow_conv_transpose2d_cpu_dispatch.h>
#include <ATen/ops/slow_conv_transpose3d_cpu_dispatch.h>
#include <ATen/ops/smooth_l1_loss_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/smooth_l1_loss_backward_cpu_dispatch.h>
#include <ATen/ops/smooth_l1_loss_cpu_dispatch.h>
#include <ATen/ops/soft_margin_loss_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/soft_margin_loss_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/softmax_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/softplus_backward_cpu_dispatch.h>
#include <ATen/ops/softplus_cpu_dispatch.h>
#include <ATen/ops/softshrink_backward_cpu_dispatch.h>
#include <ATen/ops/softshrink_cpu_dispatch.h>
#include <ATen/ops/sort_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sort_cpu_dispatch.h>
#include <ATen/ops/sparse_compressed_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sparse_coo_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sparse_dim_cpu_dispatch.h>
#include <ATen/ops/sparse_mask_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sparse_resize_and_clear_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sparse_resize_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/split_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/split_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/split_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/split_with_sizes_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/split_with_sizes_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/split_with_sizes_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/squeeze_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/squeeze_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/squeeze_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/sspaddmm_cpu_dispatch.h>
#include <ATen/ops/stack_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/std_cpu_dispatch.h>
#include <ATen/ops/std_mean_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/std_mean_cpu_dispatch.h>
#include <ATen/ops/sub_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sum_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sum_cpu_dispatch.h>
#include <ATen/ops/sym_constrain_range_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/sym_constrain_range_for_size_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/t_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/t_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/t_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/take_cpu_dispatch.h>
#include <ATen/ops/threshold_backward_cpu_dispatch.h>
#include <ATen/ops/threshold_cpu_dispatch.h>
#include <ATen/ops/to_mkldnn_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/to_mkldnn_cpu_dispatch.h>
#include <ATen/ops/to_padded_tensor_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/topk_cpu_dispatch.h>
#include <ATen/ops/trace_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/trace_cpu_dispatch.h>
#include <ATen/ops/transpose_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/transpose_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/transpose_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/triangular_solve_cpu_dispatch.h>
#include <ATen/ops/tril_cpu_dispatch.h>
#include <ATen/ops/tril_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/tril_indices_cpu_dispatch.h>
#include <ATen/ops/triu_cpu_dispatch.h>
#include <ATen/ops/triu_indices_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/triu_indices_cpu_dispatch.h>
#include <ATen/ops/unbind_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unbind_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unbind_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/unfold_backward_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unfold_backward_cpu_dispatch.h>
#include <ATen/ops/unfold_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unfold_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/unfold_cpu_dispatch.h>
#include <ATen/ops/uniform_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/uniform_cpu_dispatch.h>
#include <ATen/ops/unique_consecutive_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unique_consecutive_cpu_dispatch.h>
#include <ATen/ops/unique_dim_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unique_dim_consecutive_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unique_dim_consecutive_cpu_dispatch.h>
#include <ATen/ops/unique_dim_cpu_dispatch.h>
#include <ATen/ops/unsafe_split_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unsafe_split_with_sizes_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unsqueeze_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unsqueeze_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/unsqueeze_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/upsample_bicubic2d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_bicubic2d_cpu_dispatch.h>
#include <ATen/ops/upsample_bilinear2d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_bilinear2d_cpu_dispatch.h>
#include <ATen/ops/upsample_linear1d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_linear1d_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest1d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest1d_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest2d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest2d_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest3d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_nearest3d_cpu_dispatch.h>
#include <ATen/ops/upsample_trilinear3d_backward_cpu_dispatch.h>
#include <ATen/ops/upsample_trilinear3d_cpu_dispatch.h>
#include <ATen/ops/values_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/values_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/values_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/var_cpu_dispatch.h>
#include <ATen/ops/var_mean_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/var_mean_cpu_dispatch.h>
#include <ATen/ops/vdot_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/vdot_cpu_dispatch.h>
#include <ATen/ops/view_as_complex_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/view_as_complex_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/view_as_complex_cpu_dispatch.h>
#include <ATen/ops/view_as_real_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/view_as_real_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/view_as_real_cpu_dispatch.h>
#include <ATen/ops/view_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/view_copy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/view_copy_compositeexplicitautogradnonfunctional_dispatch.h>
#include <ATen/ops/view_cpu_dispatch.h>
#include <ATen/ops/where_cpu_dispatch.h>
#include <ATen/ops/xlogy_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/zero_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/zero_cpu_dispatch.h>
#include <ATen/ops/zeros_compositeexplicitautograd_dispatch.h>
#include <ATen/ops/zeros_like_compositeexplicitautograd_dispatch.h>

#endif

using namespace torch::aot_inductor;


AOTITorchError aoti_torch_cpu__fw_primal(AtenTensorHandle self, int64_t level, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_fw_primal(
            *tensor_handle_to_tensor_pointer(self), level
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__make_dual(AtenTensorHandle primal, AtenTensorHandle tangent, int64_t level, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_make_dual(
            *tensor_handle_to_tensor_pointer(primal), *tensor_handle_to_tensor_pointer(tangent), level
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__new_zeros_with_same_feature_meta(AtenTensorHandle self, AtenTensorHandle other, int64_t self_num_batch_dims, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_new_zeros_with_same_feature_meta(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), self_num_batch_dims
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__has_same_storage_numel(AtenTensorHandle self, AtenTensorHandle other, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_has_same_storage_numel(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu__assert_async(AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_assert_async(
            *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__assert_async_msg(AtenTensorHandle self, const char* assert_msg) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_assert_async(
            *tensor_handle_to_tensor_pointer(self), assert_msg
        );
    });
}


AOTITorchError aoti_torch_cpu__assert_scalar(double self, const char* assert_msg) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_assert_scalar(
            self, assert_msg
        );
    });
}


AOTITorchError aoti_torch_cpu__functional_assert_scalar(double self, const char* assert_msg, AtenTensorHandle dep_token, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_functional_assert_scalar(
            self, assert_msg, *tensor_handle_to_tensor_pointer(dep_token)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__functional_assert_async_msg(AtenTensorHandle self, const char* assert_msg, AtenTensorHandle dep_token, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_functional_assert_async(
            *tensor_handle_to_tensor_pointer(self), assert_msg, *tensor_handle_to_tensor_pointer(dep_token)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__print(const char* s) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_print(
            s
        );
    });
}


AOTITorchError aoti_torch_cpu_sym_constrain_range(double size, int64_t* min, int64_t* max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sym_constrain_range(
            size, pointer_to_optional<int64_t>(min), pointer_to_optional<int64_t>(max)
        );
    });
}


AOTITorchError aoti_torch_cpu_sym_constrain_range_for_size(double size, int64_t* min, int64_t* max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sym_constrain_range_for_size(
            size, pointer_to_optional<int64_t>(min), pointer_to_optional<int64_t>(max)
        );
    });
}


AOTITorchError aoti_torch_cpu__functional_sym_constrain_range(double size, int64_t* min, int64_t* max, AtenTensorHandle dep_token, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_functional_sym_constrain_range(
            size, pointer_to_optional<int64_t>(min), pointer_to_optional<int64_t>(max), *tensor_handle_to_tensor_pointer(dep_token)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__functional_sym_constrain_range_for_size(double size, int64_t* min, int64_t* max, AtenTensorHandle dep_token, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_functional_sym_constrain_range_for_size(
            size, pointer_to_optional<int64_t>(min), pointer_to_optional<int64_t>(max), *tensor_handle_to_tensor_pointer(dep_token)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__make_dep_token(int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_make_dep_token(
            pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_native_dropout(AtenTensorHandle input, double p, int32_t* train, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_dropout(
            *tensor_handle_to_tensor_pointer(input), p, pointer_to_optional<bool>(train)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_abs_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::abs_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_as_real(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::view_as_real(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_as_complex(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::view_as_complex(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__conj(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_conj(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__conj_physical(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_conj_physical(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__neg_view(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_neg_view(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__add_relu_Tensor(AtenTensorHandle self, AtenTensorHandle other, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_add_relu(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__add_relu__Tensor(AtenTensorHandle self, AtenTensorHandle other, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_add_relu_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__add_relu_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_add_relu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__add_relu_Scalar(AtenTensorHandle self, double other, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_add_relu(
            *tensor_handle_to_tensor_pointer(self), other, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__add_relu__Scalar(AtenTensorHandle self, double other, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_add_relu_(
            *tensor_handle_to_tensor_pointer(self), other, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addmv_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat, AtenTensorHandle vec, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::addmv_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat), *tensor_handle_to_tensor_pointer(vec), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_addr(AtenTensorHandle self, AtenTensorHandle vec1, AtenTensorHandle vec2, double beta, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::addr(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(vec1), *tensor_handle_to_tensor_pointer(vec2), beta, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addr_(AtenTensorHandle self, AtenTensorHandle vec1, AtenTensorHandle vec2, double beta, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::addr_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(vec1), *tensor_handle_to_tensor_pointer(vec2), beta, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addr_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle vec1, AtenTensorHandle vec2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::addr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(vec1), *tensor_handle_to_tensor_pointer(vec2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_affine_grid_generator(AtenTensorHandle theta, const int64_t* size, int64_t size_len_, int32_t align_corners, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::affine_grid_generator_symint(
            *tensor_handle_to_tensor_pointer(theta), pointer_to_list<c10::SymInt>(size, size_len_), align_corners
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__is_all_true(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_is_all_true(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__is_any_true(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_is_any_true(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_functorch_fallback(AtenTensorHandle self, AtenTensorHandle other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_test_functorch_fallback(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_all_dims(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::all(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_all_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::all_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_all_dims_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::all_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_allclose(AtenTensorHandle self, AtenTensorHandle other, double rtol, double atol, int32_t equal_nan, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::allclose(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), rtol, atol, equal_nan
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_any_dims(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::any(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_any_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::any_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_any_dims_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::any_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_arange(double end, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::arange(
            end, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_arange_start(double start, double end, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::arange(
            start, end, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_arange_start_step(double start, double end, double step, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::arange(
            start, end, step, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_arange_out(AtenTensorHandle out, double end) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::arange_out(
            *tensor_handle_to_tensor_pointer(out), end
        );
    });
}


AOTITorchError aoti_torch_cpu_arange_start_out(AtenTensorHandle out, double start, double end, double step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::arange_out(
            *tensor_handle_to_tensor_pointer(out), start, end, step
        );
    });
}


AOTITorchError aoti_torch_cpu_argmax_out(AtenTensorHandle out, AtenTensorHandle self, int64_t* dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::argmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dim), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_argmin_out(AtenTensorHandle out, AtenTensorHandle self, int64_t* dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::argmin_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dim), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_as_strided(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::as_strided_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_as_strided_(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::as_strided__symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_baddbmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle batch1, AtenTensorHandle batch2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::baddbmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(batch1), *tensor_handle_to_tensor_pointer(batch2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_bartlett_window(int64_t window_length, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::bartlett_window(
            window_length, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_bartlett_window_periodic(int64_t window_length, int32_t periodic, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::bartlett_window(
            window_length, periodic, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy(AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::binary_cross_entropy(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::binary_cross_entropy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::binary_cross_entropy_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::binary_cross_entropy_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy_with_logits(AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, AtenTensorHandle* pos_weight, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::binary_cross_entropy_with_logits(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(pos_weight), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_bincount(AtenTensorHandle self, AtenTensorHandle* weights, int64_t minlength, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::bincount(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<at::Tensor>(weights), minlength
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_copysign__Scalar(AtenTensorHandle self, double other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::copysign_(
            *tensor_handle_to_tensor_pointer(self), other
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__lazy_clone(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_lazy_clone(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_blackman_window(int64_t window_length, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::blackman_window(
            window_length, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_blackman_window_periodic(int64_t window_length, int32_t periodic, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::blackman_window(
            window_length, periodic, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_bmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::bmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat2)
        );
    });
}


AOTITorchError aoti_torch_cpu_cat_out(AtenTensorHandle out, const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::cat_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(tensors, tensors_len_), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_block_diag(const AtenTensorHandle* tensors, int64_t tensors_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::block_diag(
            pointer_to_list<at::Tensor>(tensors, tensors_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_complex(AtenTensorHandle real, AtenTensorHandle imag, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::complex(
            *tensor_handle_to_tensor_pointer(real), *tensor_handle_to_tensor_pointer(imag)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_complex_out(AtenTensorHandle out, AtenTensorHandle real, AtenTensorHandle imag) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::complex_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(real), *tensor_handle_to_tensor_pointer(imag)
        );
    });
}


AOTITorchError aoti_torch_cpu_polar(AtenTensorHandle abs, AtenTensorHandle angle, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::polar(
            *tensor_handle_to_tensor_pointer(abs), *tensor_handle_to_tensor_pointer(angle)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_polar_out(AtenTensorHandle out, AtenTensorHandle abs, AtenTensorHandle angle) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::polar_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(abs), *tensor_handle_to_tensor_pointer(angle)
        );
    });
}


AOTITorchError aoti_torch_cpu_constant_pad_nd(AtenTensorHandle self, const int64_t* pad, int64_t pad_len_, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::constant_pad_nd_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(pad, pad_len_), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_convolution(AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::convolution_symint(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_convolution_backward(AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle weight, const int64_t** bias_sizes, int64_t bias_sizes_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::convolution_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional_list<c10::SymInt>(bias_sizes, bias_sizes_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_convolution_overrideable(AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::convolution_overrideable_symint(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_convolution_backward_overrideable(AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle weight, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::convolution_backward_overrideable_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__convolution(AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, int32_t benchmark, int32_t deterministic, int32_t cudnn_enabled, int32_t allow_tf32, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_convolution_symint(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, benchmark, deterministic, cudnn_enabled, allow_tf32
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_conv_tbc(AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle bias, int64_t pad, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::conv_tbc(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(bias), pad
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_copy(AtenTensorHandle self, AtenTensorHandle src, int32_t non_blocking, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::copy(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), non_blocking
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_copy_(AtenTensorHandle self, AtenTensorHandle src, int32_t non_blocking, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::copy_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), non_blocking
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_count_nonzero_dim_IntList(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::count_nonzero(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_count_nonzero(AtenTensorHandle self, int64_t* dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::count_nonzero(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_cummax(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::cummax(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_cummax_out(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cummax_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__cummax_helper(AtenTensorHandle self, AtenTensorHandle values, AtenTensorHandle indices, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_cummax_helper(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_cummin(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::cummin(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_cummin_out(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cummin_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__cummin_helper(AtenTensorHandle self, AtenTensorHandle values, AtenTensorHandle indices, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_cummin_helper(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_cumprod_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::cumprod_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_cumsum_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::cumsum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss(AtenTensorHandle log_probs, AtenTensorHandle targets, const int64_t* input_lengths, int64_t input_lengths_len_, const int64_t* target_lengths, int64_t target_lengths_len_, int64_t blank, int32_t zero_infinity, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_ctc_loss(
            *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), pointer_to_list<int64_t>(input_lengths, input_lengths_len_), pointer_to_list<int64_t>(target_lengths, target_lengths_len_), blank, zero_infinity
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_Tensor(AtenTensorHandle log_probs, AtenTensorHandle targets, AtenTensorHandle input_lengths, AtenTensorHandle target_lengths, int64_t blank, int32_t zero_infinity, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_ctc_loss(
            *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), *tensor_handle_to_tensor_pointer(input_lengths), *tensor_handle_to_tensor_pointer(target_lengths), blank, zero_infinity
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_backward(AtenTensorHandle grad, AtenTensorHandle log_probs, AtenTensorHandle targets, const int64_t* input_lengths, int64_t input_lengths_len_, const int64_t* target_lengths, int64_t target_lengths_len_, AtenTensorHandle neg_log_likelihood, AtenTensorHandle log_alpha, int64_t blank, int32_t zero_infinity, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_ctc_loss_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), pointer_to_list<int64_t>(input_lengths, input_lengths_len_), pointer_to_list<int64_t>(target_lengths, target_lengths_len_), *tensor_handle_to_tensor_pointer(neg_log_likelihood), *tensor_handle_to_tensor_pointer(log_alpha), blank, zero_infinity
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_backward_Tensor(AtenTensorHandle grad, AtenTensorHandle log_probs, AtenTensorHandle targets, AtenTensorHandle input_lengths, AtenTensorHandle target_lengths, AtenTensorHandle neg_log_likelihood, AtenTensorHandle log_alpha, int64_t blank, int32_t zero_infinity, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_ctc_loss_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), *tensor_handle_to_tensor_pointer(input_lengths), *tensor_handle_to_tensor_pointer(target_lengths), *tensor_handle_to_tensor_pointer(neg_log_likelihood), *tensor_handle_to_tensor_pointer(log_alpha), blank, zero_infinity
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_diag_embed(AtenTensorHandle self, int64_t offset, int64_t dim1, int64_t dim2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::diag_embed(
            *tensor_handle_to_tensor_pointer(self), offset, dim1, dim2
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_diagonal(AtenTensorHandle self, int64_t offset, int64_t dim1, int64_t dim2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::diagonal(
            *tensor_handle_to_tensor_pointer(self), offset, dim1, dim2
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_diagonal_backward(AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t offset, int64_t dim1, int64_t dim2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::diagonal_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), offset, dim1, dim2
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_dot(AtenTensorHandle self, AtenTensorHandle tensor, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::dot(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(tensor)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_dot_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle tensor) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::dot_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(tensor)
        );
    });
}


AOTITorchError aoti_torch_cpu_vdot(AtenTensorHandle self, AtenTensorHandle other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::vdot(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_vdot_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::vdot_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_embedding(AtenTensorHandle weight, AtenTensorHandle indices, int64_t padding_idx, int32_t scale_grad_by_freq, int32_t sparse, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::embedding_symint(
            *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), padding_idx, scale_grad_by_freq, sparse
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_embedding_dense_backward(AtenTensorHandle grad_output, AtenTensorHandle indices, int64_t num_weights, int64_t padding_idx, int32_t scale_grad_by_freq, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::embedding_dense_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(indices), num_weights, padding_idx, scale_grad_by_freq
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_embedding_renorm_(AtenTensorHandle self, AtenTensorHandle indices, double max_norm, double norm_type, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::embedding_renorm_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), max_norm, norm_type
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_forward_only(AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, int32_t scale_grad_by_freq, int64_t mode, int32_t sparse, AtenTensorHandle* per_sample_weights, int32_t include_last_offset, int64_t padding_idx, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_embedding_bag_forward_only(
            *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), scale_grad_by_freq, mode, sparse, pointer_to_optional<at::Tensor>(per_sample_weights), include_last_offset, padding_idx
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag(AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, int32_t scale_grad_by_freq, int64_t mode, int32_t sparse, AtenTensorHandle* per_sample_weights, int32_t include_last_offset, int64_t padding_idx, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_embedding_bag(
            *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), scale_grad_by_freq, mode, sparse, pointer_to_optional<at::Tensor>(per_sample_weights), include_last_offset, padding_idx
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_dense_backward(AtenTensorHandle grad, AtenTensorHandle indices, AtenTensorHandle offset2bag, AtenTensorHandle bag_size, AtenTensorHandle maximum_indices, int64_t num_weights, int32_t scale_grad_by_freq, int64_t mode, AtenTensorHandle* per_sample_weights, int64_t padding_idx, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_embedding_bag_dense_backward_symint(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offset2bag), *tensor_handle_to_tensor_pointer(bag_size), *tensor_handle_to_tensor_pointer(maximum_indices), num_weights, scale_grad_by_freq, mode, pointer_to_optional<at::Tensor>(per_sample_weights), padding_idx
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_per_sample_weights_backward(AtenTensorHandle grad, AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, AtenTensorHandle offset2bag, int64_t mode, int64_t padding_idx, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_embedding_bag_per_sample_weights_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), *tensor_handle_to_tensor_pointer(offset2bag), mode, padding_idx
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_empty_memory_format(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::empty_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_empty_permuted(const int64_t* size, int64_t size_len_, const int64_t* physical_layout, int64_t physical_layout_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::empty_permuted_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<int64_t>(physical_layout, physical_layout_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_new_empty(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::new_empty_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_new_empty_strided(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::new_empty_strided_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_new_full(AtenTensorHandle self, const int64_t* size, int64_t size_len_, double fill_value, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::new_full_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), fill_value, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_new_zeros(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::new_zeros_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_new_ones(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::new_ones_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__empty_affine_quantized(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, double scale, int64_t zero_point, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_empty_affine_quantized_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), scale, zero_point, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__empty_per_channel_affine_quantized(const int64_t* size, int64_t size_len_, AtenTensorHandle scales, AtenTensorHandle zero_points, int64_t axis, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_empty_per_channel_affine_quantized_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), *tensor_handle_to_tensor_pointer(scales), *tensor_handle_to_tensor_pointer(zero_points), axis, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_resize_(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::resize__symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_empty_like(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::empty_like(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_empty_strided(const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::empty_strided_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_expand(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t implicit, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::expand_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), implicit
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_eye(int64_t n, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::eye_symint(
            n, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_eye_m(int64_t n, int64_t m, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::eye_symint(
            n, m, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_eye_out(AtenTensorHandle out, int64_t n) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::eye_symint_out(
            *tensor_handle_to_tensor_pointer(out), n
        );
    });
}


AOTITorchError aoti_torch_cpu_eye_m_out(AtenTensorHandle out, int64_t n, int64_t m) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::eye_symint_out(
            *tensor_handle_to_tensor_pointer(out), n, m
        );
    });
}


AOTITorchError aoti_torch_cpu_fill_Scalar(AtenTensorHandle self, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::fill(
            *tensor_handle_to_tensor_pointer(self), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fill_Tensor(AtenTensorHandle self, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::fill(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fill__Scalar(AtenTensorHandle self, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::fill_(
            *tensor_handle_to_tensor_pointer(self), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fill__Tensor(AtenTensorHandle self, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::fill_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_floor_divide(AtenTensorHandle self, AtenTensorHandle other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::floor_divide(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_floor_divide__Tensor(AtenTensorHandle self, AtenTensorHandle other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::floor_divide_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_floor_divide_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::floor_divide_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_floor_divide_Scalar(AtenTensorHandle self, double other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::floor_divide(
            *tensor_handle_to_tensor_pointer(self), other
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_floor_divide__Scalar(AtenTensorHandle self, double other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::floor_divide_(
            *tensor_handle_to_tensor_pointer(self), other
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_full(const int64_t* size, int64_t size_len_, double fill_value, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::full_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), fill_value, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_full_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, double fill_value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::full_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_), fill_value
        );
    });
}


AOTITorchError aoti_torch_cpu_full_like(AtenTensorHandle self, double fill_value, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::full_like(
            *tensor_handle_to_tensor_pointer(self), fill_value, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_from_file(const char* filename, int32_t* shared, int64_t* size, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::from_file(
            filename, pointer_to_optional<bool>(shared), pointer_to_optional<int64_t>(size), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_2d(AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::grid_sampler_2d(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_2d_backward(AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::grid_sampler_2d_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners, pointer_to_list<2>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__grid_sampler_2d_cpu_fallback(AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_grid_sampler_2d_cpu_fallback(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_3d(AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::grid_sampler_3d(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_3d_backward(AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::grid_sampler_3d_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners, pointer_to_list<2>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_hann_window(int64_t window_length, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hann_window(
            window_length, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hann_window_periodic(int64_t window_length, int32_t periodic, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hann_window(
            window_length, periodic, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hamming_window(int64_t window_length, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hamming_window(
            window_length, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic(int64_t window_length, int32_t periodic, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hamming_window(
            window_length, periodic, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic_alpha(int64_t window_length, int32_t periodic, double alpha, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hamming_window(
            window_length, periodic, alpha, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic_alpha_beta(int64_t window_length, int32_t periodic, double alpha, double beta, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::hamming_window(
            window_length, periodic, alpha, beta, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window(int64_t window_length, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::kaiser_window(
            window_length, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window_periodic(int64_t window_length, int32_t periodic, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::kaiser_window(
            window_length, periodic, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window_beta(int64_t window_length, int32_t periodic, double beta, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::kaiser_window(
            window_length, periodic, beta, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_native_group_norm(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, int64_t N, int64_t C, int64_t HxW, int64_t group, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_group_norm_symint(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), N, C, HxW, group, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_native_group_norm_backward(AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle rstd, AtenTensorHandle* weight, int64_t N, int64_t C, int64_t HxW, int64_t group, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_group_norm_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(rstd), pointer_to_optional<at::Tensor>(weight), N, C, HxW, group, pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fft_r2c(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int32_t onesided, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fft_r2c(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), normalization, onesided
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fft_r2c_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int32_t onesided) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_fft_r2c_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), normalization, onesided
        );
    });
}


AOTITorchError aoti_torch_cpu__fft_c2r(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int64_t last_dim_size, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fft_c2r_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), normalization, last_dim_size
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fft_c2r_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int64_t last_dim_size) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_fft_c2r_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), normalization, last_dim_size
        );
    });
}


AOTITorchError aoti_torch_cpu__fft_c2c(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int32_t forward, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fft_c2c_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(dim, dim_len_), normalization, forward
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fft_c2c_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int64_t normalization, int32_t forward) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_fft_c2c_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(dim, dim_len_), normalization, forward
        );
    });
}


AOTITorchError aoti_torch_cpu__validate_compressed_sparse_indices(int32_t is_crow, AtenTensorHandle compressed_idx, AtenTensorHandle plain_idx, int64_t cdim, int64_t dim, int64_t nnz) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_validate_compressed_sparse_indices(
            is_crow, *tensor_handle_to_tensor_pointer(compressed_idx), *tensor_handle_to_tensor_pointer(plain_idx), cdim, dim, nnz
        );
    });
}


AOTITorchError aoti_torch_cpu_index_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::index_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_)))
        );
    });
}


AOTITorchError aoti_torch_cpu__unsafe_index_Tensor(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_unsafe_index(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_)))
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle source) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::index_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source)
        );
    });
}


AOTITorchError aoti_torch_cpu_index_put_(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::index_put_(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_put(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::index_put(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__unsafe_index_put(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_unsafe_index_put(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__index_put_impl_(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, int32_t unsafe, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_index_put_impl_(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate, unsafe
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_isin_Tensor_Tensor_out(AtenTensorHandle out, AtenTensorHandle elements, AtenTensorHandle test_elements, int32_t assume_unique, int32_t invert) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::isin_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(elements), *tensor_handle_to_tensor_pointer(test_elements), assume_unique, invert
        );
    });
}


AOTITorchError aoti_torch_cpu_isin_Tensor_Scalar_out(AtenTensorHandle out, AtenTensorHandle elements, double test_element, int32_t assume_unique, int32_t invert) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::isin_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(elements), test_element, assume_unique, invert
        );
    });
}


AOTITorchError aoti_torch_cpu_isin_Scalar_Tensor_out(AtenTensorHandle out, double element, AtenTensorHandle test_elements, int32_t assume_unique, int32_t invert) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::isin_out(
            *tensor_handle_to_tensor_pointer(out), element, *tensor_handle_to_tensor_pointer(test_elements), assume_unique, invert
        );
    });
}


AOTITorchError aoti_torch_cpu_is_same_size(AtenTensorHandle self, AtenTensorHandle other, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::is_same_size(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_kthvalue(AtenTensorHandle self, int64_t k, int64_t dim, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::kthvalue(
            *tensor_handle_to_tensor_pointer(self), k, dim, keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_kthvalue_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t k, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::kthvalue_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), k, dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_native_layer_norm(AtenTensorHandle input, const int64_t* normalized_shape, int64_t normalized_shape_len_, AtenTensorHandle* weight, AtenTensorHandle* bias, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_layer_norm_symint(
            *tensor_handle_to_tensor_pointer(input), pointer_to_list<c10::SymInt>(normalized_shape, normalized_shape_len_), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_native_layer_norm_backward(AtenTensorHandle grad_out, AtenTensorHandle input, const int64_t* normalized_shape, int64_t normalized_shape_len_, AtenTensorHandle mean, AtenTensorHandle rstd, AtenTensorHandle* weight, AtenTensorHandle* bias, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_layer_norm_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), pointer_to_list<c10::SymInt>(normalized_shape, normalized_shape_len_), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(rstd), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_linear_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linear_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias)
        );
    });
}


AOTITorchError aoti_torch_cpu_linspace(double start, double end, int64_t steps, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::linspace(
            start, end, steps, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linspace_Tensor_Tensor(AtenTensorHandle start, AtenTensorHandle end, int64_t steps, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::linspace(
            *tensor_handle_to_tensor_pointer(start), *tensor_handle_to_tensor_pointer(end), steps, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linspace_Tensor_Scalar(AtenTensorHandle start, double end, int64_t steps, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::linspace(
            *tensor_handle_to_tensor_pointer(start), end, steps, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linspace_Scalar_Tensor(double start, AtenTensorHandle end, int64_t steps, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::linspace(
            start, *tensor_handle_to_tensor_pointer(end), steps, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linspace_out(AtenTensorHandle out, double start, double end, int64_t steps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linspace_out(
            *tensor_handle_to_tensor_pointer(out), start, end, steps
        );
    });
}


AOTITorchError aoti_torch_cpu_linspace_Tensor_Tensor_out(AtenTensorHandle out, AtenTensorHandle start, AtenTensorHandle end, int64_t steps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linspace_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(start), *tensor_handle_to_tensor_pointer(end), steps
        );
    });
}


AOTITorchError aoti_torch_cpu_linspace_Tensor_Scalar_out(AtenTensorHandle out, AtenTensorHandle start, double end, int64_t steps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linspace_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(start), end, steps
        );
    });
}


AOTITorchError aoti_torch_cpu_linspace_Scalar_Tensor_out(AtenTensorHandle out, double start, AtenTensorHandle end, int64_t steps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linspace_out(
            *tensor_handle_to_tensor_pointer(out), start, *tensor_handle_to_tensor_pointer(end), steps
        );
    });
}


AOTITorchError aoti_torch_cpu_xlogy__Scalar_Other(AtenTensorHandle self, double other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::xlogy_(
            *tensor_handle_to_tensor_pointer(self), other
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logspace(double start, double end, int64_t steps, double base, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logspace(
            start, end, steps, base, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logspace_Tensor_Tensor(AtenTensorHandle start, AtenTensorHandle end, int64_t steps, double base, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logspace(
            *tensor_handle_to_tensor_pointer(start), *tensor_handle_to_tensor_pointer(end), steps, base, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logspace_Tensor_Scalar(AtenTensorHandle start, double end, int64_t steps, double base, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logspace(
            *tensor_handle_to_tensor_pointer(start), end, steps, base, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logspace_Scalar_Tensor(double start, AtenTensorHandle end, int64_t steps, double base, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logspace(
            start, *tensor_handle_to_tensor_pointer(end), steps, base, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logspace_out(AtenTensorHandle out, double start, double end, int64_t steps, double base) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::logspace_out(
            *tensor_handle_to_tensor_pointer(out), start, end, steps, base
        );
    });
}


AOTITorchError aoti_torch_cpu_logspace_Tensor_Tensor_out(AtenTensorHandle out, AtenTensorHandle start, AtenTensorHandle end, int64_t steps, double base) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::logspace_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(start), *tensor_handle_to_tensor_pointer(end), steps, base
        );
    });
}


AOTITorchError aoti_torch_cpu_logspace_Tensor_Scalar_out(AtenTensorHandle out, AtenTensorHandle start, double end, int64_t steps, double base) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::logspace_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(start), end, steps, base
        );
    });
}


AOTITorchError aoti_torch_cpu_logspace_Scalar_Tensor_out(AtenTensorHandle out, double start, AtenTensorHandle end, int64_t steps, double base) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::logspace_out(
            *tensor_handle_to_tensor_pointer(out), start, *tensor_handle_to_tensor_pointer(end), steps, base
        );
    });
}


AOTITorchError aoti_torch_cpu_log_softmax_int_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::log_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__log_softmax_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t half_to_float) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_log_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, half_to_float
        );
    });
}


AOTITorchError aoti_torch_cpu__log_softmax_backward_data_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, int64_t dim, int32_t input_dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_log_softmax_backward_data_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), dim, static_cast<c10::ScalarType>(input_dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__logcumsumexp(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_logcumsumexp(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__logcumsumexp_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_logcumsumexp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_logcumsumexp(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logcumsumexp(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logcumsumexp_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::logcumsumexp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_logsumexp(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::logsumexp(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_logsumexp_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautogradnonfunctional::logsumexp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu__aminmax(AtenTensorHandle self, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_aminmax(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__aminmax_dim(AtenTensorHandle self, int64_t dim, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_aminmax(
            *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_aminmax_out(AtenTensorHandle min, AtenTensorHandle max, AtenTensorHandle self, int64_t* dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::aminmax_out(
            *tensor_handle_to_tensor_pointer(min), *tensor_handle_to_tensor_pointer(max), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dim), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu__compute_linear_combination(AtenTensorHandle input, AtenTensorHandle coefficients, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_compute_linear_combination(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(coefficients)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__compute_linear_combination_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle coefficients) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_compute_linear_combination_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(coefficients)
        );
    });
}


AOTITorchError aoti_torch_cpu_max_dim_max(AtenTensorHandle max, AtenTensorHandle max_values, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_out(
            *tensor_handle_to_tensor_pointer(max), *tensor_handle_to_tensor_pointer(max_values), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_amax_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::amax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_mean(AtenTensorHandle self, int32_t* dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::mean(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_mean_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::mean_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_median(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::median(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_median_dim(AtenTensorHandle self, int64_t dim, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::median(
            *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_median_dim_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::median_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_nanmedian(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nanmedian(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_nanmedian_dim(AtenTensorHandle self, int64_t dim, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::nanmedian(
            *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_nanmedian_dim_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nanmedian_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_min_dim_min(AtenTensorHandle min, AtenTensorHandle min_indices, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::min_out(
            *tensor_handle_to_tensor_pointer(min), *tensor_handle_to_tensor_pointer(min_indices), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_amin_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::amin_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_convolution(AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::mkldnn_convolution_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_rnn_layer(AtenTensorHandle input, AtenTensorHandle weight0, AtenTensorHandle weight1, AtenTensorHandle weight2, AtenTensorHandle weight3, AtenTensorHandle hx_, AtenTensorHandle cx_, int32_t reverse, const int64_t* batch_sizes, int64_t batch_sizes_len_, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t has_biases, int32_t bidirectional, int32_t batch_first, int32_t train, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::mkldnn_rnn_layer(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight0), *tensor_handle_to_tensor_pointer(weight1), *tensor_handle_to_tensor_pointer(weight2), *tensor_handle_to_tensor_pointer(weight3), *tensor_handle_to_tensor_pointer(hx_), *tensor_handle_to_tensor_pointer(cx_), reverse, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), mode, hidden_size, num_layers, has_biases, bidirectional, batch_first, train
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_rnn_layer_backward(AtenTensorHandle input, AtenTensorHandle weight1, AtenTensorHandle weight2, AtenTensorHandle weight3, AtenTensorHandle weight4, AtenTensorHandle hx_, AtenTensorHandle cx_tmp, AtenTensorHandle output, AtenTensorHandle hy_, AtenTensorHandle cy_, AtenTensorHandle* grad_output, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, int32_t reverse, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t has_biases, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, int32_t batch_first, AtenTensorHandle workspace, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3, AtenTensorHandle* ret4, AtenTensorHandle* ret5, AtenTensorHandle* ret6) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::mkldnn_rnn_layer_backward(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight1), *tensor_handle_to_tensor_pointer(weight2), *tensor_handle_to_tensor_pointer(weight3), *tensor_handle_to_tensor_pointer(weight4), *tensor_handle_to_tensor_pointer(hx_), *tensor_handle_to_tensor_pointer(cx_tmp), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(hy_), *tensor_handle_to_tensor_pointer(cy_), pointer_to_optional<at::Tensor>(grad_output), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), reverse, mode, hidden_size, num_layers, has_biases, train, bidirectional, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), batch_first, *tensor_handle_to_tensor_pointer(workspace)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
        *ret4 = new_tensor_handle(std::move(std::get<4>(tmp_result)));;
        *ret5 = new_tensor_handle(std::move(std::get<5>(tmp_result)));;
        *ret6 = new_tensor_handle(std::move(std::get<6>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_mm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::mm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat2)
        );
    });
}


AOTITorchError aoti_torch_cpu__convert_weight_to_int4pack(AtenTensorHandle self, int64_t innerKTiles, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_convert_weight_to_int4pack(
            *tensor_handle_to_tensor_pointer(self), innerKTiles
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__weight_int4pack_mm(AtenTensorHandle self, AtenTensorHandle mat2, int64_t qGroupSize, AtenTensorHandle qScaleAndZeros, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_weight_int4pack_mm(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat2), qGroupSize, *tensor_handle_to_tensor_pointer(qScaleAndZeros)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__weight_int8pack_mm(AtenTensorHandle self, AtenTensorHandle mat2, AtenTensorHandle scales, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_weight_int8pack_mm(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat2), *tensor_handle_to_tensor_pointer(scales)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_mode(AtenTensorHandle self, int64_t dim, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::mode(
            *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_mode_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mode_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_mv(AtenTensorHandle self, AtenTensorHandle vec, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::mv(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(vec)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_mv_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle vec) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mv_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(vec)
        );
    });
}


AOTITorchError aoti_torch_cpu_narrow_copy(AtenTensorHandle self, int64_t dim, int64_t start, int64_t length, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::narrow_copy_symint(
            *tensor_handle_to_tensor_pointer(self), dim, start, length
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_narrow_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int64_t start, int64_t length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::narrow_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, start, length
        );
    });
}


AOTITorchError aoti_torch_cpu_native_batch_norm(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, int32_t training, double momentum, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_batch_norm(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), training, momentum, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_native_batch_norm_out(AtenTensorHandle out, AtenTensorHandle save_mean, AtenTensorHandle save_invstd, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, int32_t training, double momentum, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::native_batch_norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(save_mean), *tensor_handle_to_tensor_pointer(save_invstd), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), training, momentum, eps
        );
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle running_mean, AtenTensorHandle running_var, int32_t training, double momentum, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_native_batch_norm_legit(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(running_mean), *tensor_handle_to_tensor_pointer(running_var), training, momentum, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_no_training(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle running_mean, AtenTensorHandle running_var, double momentum, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_native_batch_norm_legit_no_training(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(running_mean), *tensor_handle_to_tensor_pointer(running_var), momentum, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_out(AtenTensorHandle out, AtenTensorHandle save_mean, AtenTensorHandle save_invstd, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle running_mean, AtenTensorHandle running_var, int32_t training, double momentum, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_native_batch_norm_legit_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(save_mean), *tensor_handle_to_tensor_pointer(save_invstd), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(running_mean), *tensor_handle_to_tensor_pointer(running_var), training, momentum, eps
        );
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_no_stats(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, int32_t training, double momentum, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_native_batch_norm_legit(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), training, momentum, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_no_stats_out(AtenTensorHandle out, AtenTensorHandle save_mean, AtenTensorHandle save_invstd, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, int32_t training, double momentum, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_native_batch_norm_legit_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(save_mean), *tensor_handle_to_tensor_pointer(save_invstd), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), training, momentum, eps
        );
    });
}


AOTITorchError aoti_torch_cpu_native_batch_norm_backward(AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, AtenTensorHandle* save_mean, AtenTensorHandle* save_invstd, int32_t train, double eps, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_batch_norm_backward(
            *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), pointer_to_optional<at::Tensor>(save_mean), pointer_to_optional<at::Tensor>(save_invstd), train, eps, pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_update_stats(AtenTensorHandle input, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, double momentum, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::batch_norm_update_stats(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), momentum
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__nnpack_spatial_convolution(AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_nnpack_spatial_convolution_symint(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_ones(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::ones_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_ones_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::ones_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_ones_like(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::ones_like(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__euclidean_dist(AtenTensorHandle x1, AtenTensorHandle x2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_euclidean_dist(
            *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__cdist_forward(AtenTensorHandle x1, AtenTensorHandle x2, double p, int64_t* compute_mode, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_cdist_forward(
            *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2), p, pointer_to_optional<int64_t>(compute_mode)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__cdist_backward(AtenTensorHandle grad, AtenTensorHandle x1, AtenTensorHandle x2, double p, AtenTensorHandle cdist, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_cdist_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2), p, *tensor_handle_to_tensor_pointer(cdist)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__pdist_forward(AtenTensorHandle self, double p, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_pdist_forward(
            *tensor_handle_to_tensor_pointer(self), p
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__pdist_backward(AtenTensorHandle grad, AtenTensorHandle self, double p, AtenTensorHandle pdist, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_pdist_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), p, *tensor_handle_to_tensor_pointer(pdist)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_permute(AtenTensorHandle self, const int64_t* dims, int64_t dims_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::permute(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dims, dims_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_pixel_shuffle(AtenTensorHandle self, int64_t upscale_factor, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::pixel_shuffle(
            *tensor_handle_to_tensor_pointer(self), upscale_factor
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_pixel_unshuffle(AtenTensorHandle self, int64_t downscale_factor, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::pixel_unshuffle(
            *tensor_handle_to_tensor_pointer(self), downscale_factor
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_channel_shuffle(AtenTensorHandle self, int64_t groups, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::channel_shuffle_symint(
            *tensor_handle_to_tensor_pointer(self), groups
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_native_channel_shuffle(AtenTensorHandle self, int64_t groups, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::native_channel_shuffle_symint(
            *tensor_handle_to_tensor_pointer(self), groups
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_is_pinned(AtenTensorHandle self, int32_t* device, int32_t device_index_, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::is_pinned(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_device(device, device_index_)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_rad2deg(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rad2deg(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rad2deg_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rad2deg_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rad2deg_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rad2deg_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_scalar_tensor(double s, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::scalar_tensor(
            s, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rand(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rand_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rand_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rand_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_rand_like(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rand_like(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randint(int64_t high, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randint_symint(
            high, pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randint_low(int64_t low, int64_t high, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randint_symint(
            low, high, pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randint_out(AtenTensorHandle out, int64_t high, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randint_symint_out(
            *tensor_handle_to_tensor_pointer(out), high, pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_randint_low_out(AtenTensorHandle out, int64_t low, int64_t high, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randint_symint_out(
            *tensor_handle_to_tensor_pointer(out), low, high, pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_randint_like(AtenTensorHandle self, int64_t high, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randint_like_symint(
            *tensor_handle_to_tensor_pointer(self), high, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randint_like_low_dtype(AtenTensorHandle self, int64_t low, int64_t high, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randint_like_symint(
            *tensor_handle_to_tensor_pointer(self), low, high, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randn(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randn_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randn_like(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randn_like(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randperm(int64_t n, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::randperm_symint(
            n, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_randperm_out(AtenTensorHandle out, int64_t n) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randperm_symint_out(
            *tensor_handle_to_tensor_pointer(out), n
        );
    });
}


AOTITorchError aoti_torch_cpu_range_step(double start, double end, double step, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::range(
            start, end, step, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_range(double start, double end, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::range(
            start, end, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_range_out_(AtenTensorHandle out, double start, double end) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::range_out(
            *tensor_handle_to_tensor_pointer(out), start, end
        );
    });
}


AOTITorchError aoti_torch_cpu_range_out(AtenTensorHandle out, double start, double end, double step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::range_out(
            *tensor_handle_to_tensor_pointer(out), start, end, step
        );
    });
}


AOTITorchError aoti_torch_cpu_repeat(AtenTensorHandle self, const int64_t* repeats, int64_t repeats_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::repeat_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(repeats, repeats_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_repeat_interleave_Tensor(AtenTensorHandle repeats, int64_t* output_size, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::repeat_interleave_symint(
            *tensor_handle_to_tensor_pointer(repeats), pointer_to_optional<c10::SymInt>(output_size)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__reshape_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_reshape_copy_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__reshape_alias(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_reshape_alias_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__prelu_kernel(AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_prelu_kernel(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__prelu_kernel_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_prelu_kernel_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_gelu_out(AtenTensorHandle out, AtenTensorHandle self, const char* approximate) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::gelu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), approximate
        );
    });
}


AOTITorchError aoti_torch_cpu_gelu_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const char* approximate) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::gelu_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), approximate
        );
    });
}


AOTITorchError aoti_torch_cpu_hardshrink_out(AtenTensorHandle out, AtenTensorHandle self, double lambd) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardshrink_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), lambd
        );
    });
}


AOTITorchError aoti_torch_cpu_hardshrink_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_out, AtenTensorHandle self, double lambd) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardshrink_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(self), lambd
        );
    });
}


AOTITorchError aoti_torch_cpu_select_int(AtenTensorHandle self, int64_t dim, int64_t index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::select_symint(
            *tensor_handle_to_tensor_pointer(self), dim, index
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_select_backward(AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::select_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, index
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_celu(AtenTensorHandle self, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::celu(
            *tensor_handle_to_tensor_pointer(self), alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_celu_(AtenTensorHandle self, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::celu_(
            *tensor_handle_to_tensor_pointer(self), alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_mish_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::mish_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_mish_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::mish_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_detach(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::detach(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_detach_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::detach_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slice_Tensor(AtenTensorHandle self, int64_t dim, int64_t* start, int64_t* end, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::slice_symint(
            *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slice_backward(AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t start, int64_t end, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::slice_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, start, end, step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slice_inverse(AtenTensorHandle self, AtenTensorHandle src, int64_t dim, int64_t* start, int64_t* end, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::slice_inverse_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slice_scatter(AtenTensorHandle self, AtenTensorHandle src, int64_t dim, int64_t* start, int64_t* end, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::slice_scatter_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_select_scatter(AtenTensorHandle self, AtenTensorHandle src, int64_t dim, int64_t index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::select_scatter_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), dim, index
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_diagonal_scatter(AtenTensorHandle self, AtenTensorHandle src, int64_t offset, int64_t dim1, int64_t dim2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::diagonal_scatter(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), offset, dim1, dim2
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_as_strided_scatter(AtenTensorHandle self, AtenTensorHandle src, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::as_strided_scatter_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_softmax_int_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__softmax_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t half_to_float) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, half_to_float
        );
    });
}


AOTITorchError aoti_torch_cpu__softmax_backward_data_out(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle output, int64_t dim, int32_t input_dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_softmax_backward_data_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), dim, static_cast<c10::ScalarType>(input_dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_squeeze(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_dim(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_dims(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze__dim(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze_(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze__dims(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::squeeze_(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sspaddmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat1, AtenTensorHandle mat2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::sspaddmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat1), *tensor_handle_to_tensor_pointer(mat2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__chunk_cat(const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim, int64_t num_chunks, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_chunk_cat(
            pointer_to_list<at::Tensor>(tensors, tensors_len_), dim, num_chunks
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__chunk_cat_out(AtenTensorHandle out, const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim, int64_t num_chunks) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_chunk_cat_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(tensors, tensors_len_), dim, num_chunks
        );
    });
}


AOTITorchError aoti_torch_cpu_stack(const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::stack(
            pointer_to_list<at::Tensor>(tensors, tensors_len_), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_stack_out(AtenTensorHandle out, const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::stack_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(tensors, tensors_len_), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__stack(const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_stack(
            pointer_to_list<at::Tensor>(tensors, tensors_len_), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__stack_out(AtenTensorHandle out, const AtenTensorHandle* tensors, int64_t tensors_len_, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_stack_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(tensors, tensors_len_), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_sum(AtenTensorHandle self, int32_t* dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sum(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sum_IntList_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::sum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_nansum(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nansum(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_nansum_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nansum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_std_correction(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::std(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_std_mean_correction(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::std_mean(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_std_correction_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::std_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_prod(AtenTensorHandle self, int32_t* dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::prod(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_prod_int_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::prod_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_t(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::t(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_t_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::t_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_threshold_out(AtenTensorHandle out, AtenTensorHandle self, double threshold, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::threshold_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), threshold, value
        );
    });
}


AOTITorchError aoti_torch_cpu_threshold_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, double threshold) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::threshold_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), threshold
        );
    });
}


AOTITorchError aoti_torch_cpu_transpose_int(AtenTensorHandle self, int64_t dim0, int64_t dim1, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::transpose(
            *tensor_handle_to_tensor_pointer(self), dim0, dim1
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_transpose_(AtenTensorHandle self, int64_t dim0, int64_t dim1, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::transpose_(
            *tensor_handle_to_tensor_pointer(self), dim0, dim1
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_flip(AtenTensorHandle self, const int64_t* dims, int64_t dims_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::flip(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dims, dims_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_roll(AtenTensorHandle self, const int64_t* shifts, int64_t shifts_len_, const int64_t* dims, int64_t dims_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::roll_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(shifts, shifts_len_), pointer_to_list<int64_t>(dims, dims_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rot90(AtenTensorHandle self, int64_t k, const int64_t* dims, int64_t dims_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rot90(
            *tensor_handle_to_tensor_pointer(self), k, pointer_to_list<int64_t>(dims, dims_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__transform_bias_rescale_qkv(AtenTensorHandle qkv, AtenTensorHandle qkv_bias, int64_t num_heads, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_transform_bias_rescale_qkv(
            *tensor_handle_to_tensor_pointer(qkv), *tensor_handle_to_tensor_pointer(qkv_bias), num_heads
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_from_mask(AtenTensorHandle t, AtenTensorHandle mask, int32_t mask_check, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_nested_tensor_from_mask(
            *tensor_handle_to_tensor_pointer(t), *tensor_handle_to_tensor_pointer(mask), mask_check
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_from_mask_left_aligned(AtenTensorHandle t, AtenTensorHandle mask, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_nested_tensor_from_mask_left_aligned(
            *tensor_handle_to_tensor_pointer(t), *tensor_handle_to_tensor_pointer(mask)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu__nested_from_padded(AtenTensorHandle padded, AtenTensorHandle cpu_nested_shape_example, int32_t fuse_transform_0213, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_nested_from_padded(
            *tensor_handle_to_tensor_pointer(padded), *tensor_handle_to_tensor_pointer(cpu_nested_shape_example), fuse_transform_0213
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_view_from_buffer(AtenTensorHandle self, AtenTensorHandle nested_size, AtenTensorHandle nested_strides, AtenTensorHandle offsets, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_nested_view_from_buffer(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(nested_size), *tensor_handle_to_tensor_pointer(nested_strides), *tensor_handle_to_tensor_pointer(offsets)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_view_from_buffer_copy(AtenTensorHandle self, AtenTensorHandle nested_size, AtenTensorHandle nested_strides, AtenTensorHandle offsets, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_nested_view_from_buffer_copy(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(nested_size), *tensor_handle_to_tensor_pointer(nested_strides), *tensor_handle_to_tensor_pointer(offsets)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_view_from_jagged_copy(AtenTensorHandle self, AtenTensorHandle offsets, AtenTensorHandle dummy, AtenTensorHandle* lengths, int64_t ragged_idx, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_nested_view_from_jagged_copy(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(offsets), *tensor_handle_to_tensor_pointer(dummy), pointer_to_optional<at::Tensor>(lengths), ragged_idx
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_get_values_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_nested_get_values_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__trilinear(AtenTensorHandle i1, AtenTensorHandle i2, AtenTensorHandle i3, const int64_t* expand1, int64_t expand1_len_, const int64_t* expand2, int64_t expand2_len_, const int64_t* expand3, int64_t expand3_len_, const int64_t* sumdim, int64_t sumdim_len_, int64_t unroll_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_trilinear(
            *tensor_handle_to_tensor_pointer(i1), *tensor_handle_to_tensor_pointer(i2), *tensor_handle_to_tensor_pointer(i3), pointer_to_list<int64_t>(expand1, expand1_len_), pointer_to_list<int64_t>(expand2, expand2_len_), pointer_to_list<int64_t>(expand3, expand3_len_), pointer_to_list<int64_t>(sumdim, sumdim_len_), unroll_dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__unique(AtenTensorHandle self, int32_t sorted, int32_t return_inverse, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_unique(
            *tensor_handle_to_tensor_pointer(self), sorted, return_inverse
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_unique_dim(AtenTensorHandle self, int64_t dim, int32_t sorted, int32_t return_inverse, int32_t return_counts, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::unique_dim(
            *tensor_handle_to_tensor_pointer(self), dim, sorted, return_inverse, return_counts
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_unique_consecutive(AtenTensorHandle self, int32_t return_inverse, int32_t return_counts, int64_t* dim, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::unique_consecutive(
            *tensor_handle_to_tensor_pointer(self), return_inverse, return_counts, pointer_to_optional<int64_t>(dim)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_unique_dim_consecutive(AtenTensorHandle self, int64_t dim, int32_t return_inverse, int32_t return_counts, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::unique_dim_consecutive(
            *tensor_handle_to_tensor_pointer(self), dim, return_inverse, return_counts
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__unique2(AtenTensorHandle self, int32_t sorted, int32_t return_inverse, int32_t return_counts, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_unique2(
            *tensor_handle_to_tensor_pointer(self), sorted, return_inverse, return_counts
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__unsafe_view(AtenTensorHandle self, const int64_t* size, int64_t size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_unsafe_view_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unsqueeze(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::unsqueeze(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unsqueeze_(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::unsqueeze_(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_var_correction(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::var(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_var_correction_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::var_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_var_mean_correction(AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::var_mean(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_where_self_out(AtenTensorHandle out, AtenTensorHandle condition, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::where_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(condition), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu__weight_norm_interface(AtenTensorHandle v, AtenTensorHandle g, int64_t dim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_weight_norm_interface(
            *tensor_handle_to_tensor_pointer(v), *tensor_handle_to_tensor_pointer(g), dim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__weight_norm_interface_backward(AtenTensorHandle grad_w, AtenTensorHandle saved_v, AtenTensorHandle saved_g, AtenTensorHandle saved_norms, int64_t dim, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_weight_norm_interface_backward(
            *tensor_handle_to_tensor_pointer(grad_w), *tensor_handle_to_tensor_pointer(saved_v), *tensor_handle_to_tensor_pointer(saved_g), *tensor_handle_to_tensor_pointer(saved_norms), dim
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__efficientzerotensor(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_efficientzerotensor_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_zeros(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::zeros_symint(
            pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_zeros_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::zeros_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_zeros_like(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::zeros_like(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__standard_gamma_grad(AtenTensorHandle self, AtenTensorHandle output, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_standard_gamma_grad(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(output)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__dirichlet_grad(AtenTensorHandle x, AtenTensorHandle alpha, AtenTensorHandle total, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_dirichlet_grad(
            *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(alpha), *tensor_handle_to_tensor_pointer(total)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__sparse_sum_dim(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_sparse_sum(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__spdiags(AtenTensorHandle diagonals, AtenTensorHandle offsets, const int64_t* shape, int64_t shape_len_, int32_t* layout, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_spdiags(
            *tensor_handle_to_tensor_pointer(diagonals), *tensor_handle_to_tensor_pointer(offsets), pointer_to_list<int64_t>(shape, shape_len_), pointer_to_optional<c10::Layout>(layout)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_norm_ScalarOpt_dtype(AtenTensorHandle self, double* p, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::norm(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Scalar>(p), static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_norm_Scalar(AtenTensorHandle self, double p, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::norm(
            *tensor_handle_to_tensor_pointer(self), p
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_norm_dtype_out(AtenTensorHandle out, AtenTensorHandle self, double* p, const int64_t* dim, int64_t dim_len_, int32_t keepdim, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Scalar>(p), pointer_to_list<int64_t>(dim, dim_len_), keepdim, static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_norm_out(AtenTensorHandle out, AtenTensorHandle self, double* p, const int64_t* dim, int64_t dim_len_, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Scalar>(p), pointer_to_list<int64_t>(dim, dim_len_), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_resize_as_(AtenTensorHandle self, AtenTensorHandle the_template, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::resize_as_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(the_template), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_zero_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::zero_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rsub_Tensor(AtenTensorHandle self, AtenTensorHandle other, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::rsub(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__sparse_addmm(AtenTensorHandle self, AtenTensorHandle mat1, AtenTensorHandle mat2, double beta, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_sparse_addmm(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat1), *tensor_handle_to_tensor_pointer(mat2), beta, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat1, AtenTensorHandle mat2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::addmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat1), *tensor_handle_to_tensor_pointer(mat2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__addmm_activation_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat1, AtenTensorHandle mat2, double beta, double alpha, int32_t use_gelu) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_addmm_activation_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat1), *tensor_handle_to_tensor_pointer(mat2), beta, alpha, use_gelu
        );
    });
}


AOTITorchError aoti_torch_cpu_sparse_compressed_tensor_comp_plain_value_size(AtenTensorHandle compressed_indices, AtenTensorHandle plain_indices, AtenTensorHandle values, const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sparse_compressed_tensor_symint(
            *tensor_handle_to_tensor_pointer(compressed_indices), *tensor_handle_to_tensor_pointer(plain_indices), *tensor_handle_to_tensor_pointer(values), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sparse_compressed_tensor_comp_plain_value(AtenTensorHandle compressed_indices, AtenTensorHandle plain_indices, AtenTensorHandle values, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sparse_compressed_tensor(
            *tensor_handle_to_tensor_pointer(compressed_indices), *tensor_handle_to_tensor_pointer(plain_indices), *tensor_handle_to_tensor_pointer(values), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sparse_coo_tensor_size(const int64_t* size, int64_t size_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sparse_coo_tensor(
            pointer_to_list<int64_t>(size, size_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sparse_dim(AtenTensorHandle self, int64_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::sparse_dim(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_dense_dim(AtenTensorHandle self, int64_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::dense_dim(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_is_coalesced(AtenTensorHandle self, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::is_coalesced(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_indices(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::indices(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_values(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::values(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_crow_indices(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::crow_indices(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_col_indices(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::col_indices(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_ccol_indices(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::ccol_indices(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_row_indices(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::row_indices(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_sparse_dim(AtenTensorHandle self, int64_t sparse_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse(
            *tensor_handle_to_tensor_pointer(self), sparse_dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse(AtenTensorHandle self, int32_t* layout, const int64_t** blocksize, int64_t blocksize_len_, int64_t* dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_csr(AtenTensorHandle self, int64_t* dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse_csr(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dense_dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_csc(AtenTensorHandle self, int64_t* dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse_csc(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dense_dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_bsr(AtenTensorHandle self, const int64_t* blocksize, int64_t blocksize_len_, int64_t* dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse_bsr(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_bsc(AtenTensorHandle self, const int64_t* blocksize, int64_t blocksize_len_, int64_t* dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_to_sparse_bsc(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_to_mkldnn(AtenTensorHandle self, int32_t* dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::to_mkldnn(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_dynamic(AtenTensorHandle self, int32_t dtype, int32_t reduce_range, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::quantize_per_tensor_dynamic(
            *tensor_handle_to_tensor_pointer(self), static_cast<c10::ScalarType>(dtype), reduce_range
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor(AtenTensorHandle self, double scale, int64_t zero_point, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::quantize_per_tensor(
            *tensor_handle_to_tensor_pointer(self), scale, zero_point, static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_tensor_qparams(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::quantize_per_tensor(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_channel(AtenTensorHandle self, AtenTensorHandle scales, AtenTensorHandle zero_points, int64_t axis, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::quantize_per_channel(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scales), *tensor_handle_to_tensor_pointer(zero_points), axis, static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_dequantize_self(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::dequantize(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__make_per_tensor_quantized_tensor(AtenTensorHandle self, double scale, int64_t zero_point, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_make_per_tensor_quantized_tensor(
            *tensor_handle_to_tensor_pointer(self), scale, zero_point
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__make_per_channel_quantized_tensor(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_make_per_channel_quantized_tensor(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fake_quantize_per_tensor_affine_cachemask(AtenTensorHandle self, double scale, int64_t zero_point, int64_t quant_min, int64_t quant_max, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::fake_quantize_per_tensor_affine_cachemask(
            *tensor_handle_to_tensor_pointer(self), scale, zero_point, quant_min, quant_max
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_per_tensor_affine_cachemask_tensor_qparams(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, AtenTensorHandle fake_quant_enabled, int64_t quant_min, int64_t quant_max, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fake_quantize_per_tensor_affine_cachemask_tensor_qparams(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), *tensor_handle_to_tensor_pointer(fake_quant_enabled), quant_min, quant_max
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_tensor_affine(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t quant_min, int64_t quant_max, double grad_factor, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fake_quantize_learnable_per_tensor_affine(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), quant_min, quant_max, grad_factor
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_tensor_affine_backward(AtenTensorHandle grad, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t quant_min, int64_t quant_max, double grad_factor, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fake_quantize_learnable_per_tensor_affine_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), quant_min, quant_max, grad_factor
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_fake_quantize_per_channel_affine_cachemask(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::fake_quantize_per_channel_affine_cachemask(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis, quant_min, quant_max
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_channel_affine(AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, double grad_factor, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fake_quantize_learnable_per_channel_affine(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis, quant_min, quant_max, grad_factor
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_channel_affine_backward(AtenTensorHandle grad, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, double grad_factor, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fake_quantize_learnable_per_channel_affine_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis, quant_min, quant_max, grad_factor
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fused_moving_avg_obs_fq_helper(AtenTensorHandle self, AtenTensorHandle observer_on, AtenTensorHandle fake_quant_on, AtenTensorHandle running_min, AtenTensorHandle running_max, AtenTensorHandle scale, AtenTensorHandle zero_point, double averaging_const, int64_t quant_min, int64_t quant_max, int64_t ch_axis, int32_t per_row_fake_quant, int32_t symmetric_quant, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fused_moving_avg_obs_fq_helper(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(observer_on), *tensor_handle_to_tensor_pointer(fake_quant_on), *tensor_handle_to_tensor_pointer(running_min), *tensor_handle_to_tensor_pointer(running_max), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), averaging_const, quant_min, quant_max, ch_axis, per_row_fake_quant, symmetric_quant
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__to_copy(AtenTensorHandle self, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, int32_t non_blocking, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_to_copy(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory), non_blocking, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__local_scalar_dense(AtenTensorHandle self, double* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_local_scalar_dense(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = tmp_result.toDouble();
    });
}


AOTITorchError aoti_torch_cpu__pack_padded_sequence(AtenTensorHandle input, AtenTensorHandle lengths, int32_t batch_first, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_pack_padded_sequence(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(lengths), batch_first
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_set__source_Tensor(AtenTensorHandle self, AtenTensorHandle source, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::set_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(source)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_set_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::set_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_lift(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::lift(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_lift_fresh(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::lift_fresh(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_lift_fresh_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::lift_fresh_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_is_set_to(AtenTensorHandle self, AtenTensorHandle tensor, int32_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::is_set_to(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(tensor)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu_masked_fill__Scalar(AtenTensorHandle self, AtenTensorHandle mask, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::masked_fill_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_fill__Tensor(AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::masked_fill_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_fill_Tensor(AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::masked_fill(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_scatter_(AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle source, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::masked_scatter_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(source)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_scatter(AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle source, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::masked_scatter(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(source)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_scatter_backward(AtenTensorHandle grad_output, AtenTensorHandle mask, const int64_t* sizes, int64_t sizes_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::masked_scatter_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(mask), pointer_to_list<c10::SymInt>(sizes, sizes_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__masked_softmax(AtenTensorHandle self, AtenTensorHandle mask, int64_t* dim, int64_t* mask_type, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_masked_softmax(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), pointer_to_optional<int64_t>(dim), pointer_to_optional<int64_t>(mask_type)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__masked_softmax_backward(AtenTensorHandle grad_output, AtenTensorHandle output, AtenTensorHandle mask, int64_t* dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_masked_softmax_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(mask), pointer_to_optional<int64_t>(dim)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view(AtenTensorHandle self, const int64_t* size, int64_t size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::view_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_dtype(AtenTensorHandle self, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::view(
            *tensor_handle_to_tensor_pointer(self), static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_put_(AtenTensorHandle self, AtenTensorHandle index, AtenTensorHandle source, int32_t accumulate, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::put_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source), accumulate
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_put(AtenTensorHandle self, AtenTensorHandle index, AtenTensorHandle source, int32_t accumulate, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::put(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source), accumulate
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_add_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle source, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::index_add_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_index_reduce_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle source, const char* reduce, int32_t include_self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::index_reduce_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source), reduce, include_self
        );
    });
}


AOTITorchError aoti_torch_cpu_index_fill__int_Scalar(AtenTensorHandle self, int64_t dim, AtenTensorHandle index, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::index_fill_(
            *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_fill_int_Scalar(AtenTensorHandle self, int64_t dim, AtenTensorHandle index, double value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::index_fill(
            *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_fill__int_Tensor(AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::index_fill_(
            *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_fill_int_Tensor(AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::index_fill(
            *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(value)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_scatter_src_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle src) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(src)
        );
    });
}


AOTITorchError aoti_torch_cpu_scatter_value_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), value
        );
    });
}


AOTITorchError aoti_torch_cpu_scatter_reduce_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle src, const char* reduce) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(src), reduce
        );
    });
}


AOTITorchError aoti_torch_cpu_scatter_value_reduce_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, double value, const char* reduce) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), value, reduce
        );
    });
}


AOTITorchError aoti_torch_cpu_scatter_add_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle src) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_add_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(src)
        );
    });
}


AOTITorchError aoti_torch_cpu_scatter_reduce_two_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle src, const char* reduce, int32_t include_self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::scatter_reduce_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(src), reduce, include_self
        );
    });
}


AOTITorchError aoti_torch_cpu___irshift___Scalar(AtenTensorHandle self, double other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::__irshift__(
            *tensor_handle_to_tensor_pointer(self), other
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu___irshift___Tensor(AtenTensorHandle self, AtenTensorHandle other, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::__irshift__(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addbmm_(AtenTensorHandle self, AtenTensorHandle batch1, AtenTensorHandle batch2, double beta, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::addbmm_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(batch1), *tensor_handle_to_tensor_pointer(batch2), beta, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_addbmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle batch1, AtenTensorHandle batch2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::addbmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(batch1), *tensor_handle_to_tensor_pointer(batch2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_addbmm(AtenTensorHandle self, AtenTensorHandle batch1, AtenTensorHandle batch2, double beta, double alpha, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::addbmm(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(batch1), *tensor_handle_to_tensor_pointer(batch2), beta, alpha
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_triu_out(AtenTensorHandle out, AtenTensorHandle self, int64_t diagonal) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::triu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), diagonal
        );
    });
}


AOTITorchError aoti_torch_cpu_tril_out(AtenTensorHandle out, AtenTensorHandle self, int64_t diagonal) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::tril_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), diagonal
        );
    });
}


AOTITorchError aoti_torch_cpu_tril_indices(int64_t row, int64_t col, int64_t offset, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::tril_indices(
            row, col, offset, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_triu_indices(int64_t row, int64_t col, int64_t offset, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::triu_indices(
            row, col, offset, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_trace(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::trace(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_take_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::take_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(index)
        );
    });
}


AOTITorchError aoti_torch_cpu_take(AtenTensorHandle self, AtenTensorHandle index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::take(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(index)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_index_select_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::index_select_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index)
        );
    });
}


AOTITorchError aoti_torch_cpu_index_select(AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::index_select(
            *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_masked_select_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::masked_select_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_masked_select(AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::masked_select(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_nonzero_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nonzero_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_nonzero(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nonzero(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_nonzero_static_out(AtenTensorHandle out, AtenTensorHandle self, int64_t size, int64_t fill_value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nonzero_static_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), size, fill_value
        );
    });
}


AOTITorchError aoti_torch_cpu_nonzero_static(AtenTensorHandle self, int64_t size, int64_t fill_value, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nonzero_static(
            *tensor_handle_to_tensor_pointer(self), size, fill_value
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_gather_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, int32_t sparse_grad) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::gather_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), sparse_grad
        );
    });
}


AOTITorchError aoti_torch_cpu_triangular_solve_X(AtenTensorHandle X, AtenTensorHandle M, AtenTensorHandle self, AtenTensorHandle A, int32_t upper, int32_t transpose, int32_t unitriangular) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::triangular_solve_out(
            *tensor_handle_to_tensor_pointer(X), *tensor_handle_to_tensor_pointer(M), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(A), upper, transpose, unitriangular
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_check_errors(AtenTensorHandle info, const char* api_name, int32_t is_matrix) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_linalg_check_errors(
            *tensor_handle_to_tensor_pointer(info), api_name, is_matrix
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_solve_triangular_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle B, int32_t upper, int32_t left, int32_t unitriangular) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_solve_triangular_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(B), upper, left, unitriangular
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_solve_triangular(AtenTensorHandle self, AtenTensorHandle B, int32_t upper, int32_t left, int32_t unitriangular, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::linalg_solve_triangular(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(B), upper, left, unitriangular
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_cholesky_out(AtenTensorHandle out, AtenTensorHandle self, int32_t upper) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::cholesky_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), upper
        );
    });
}


AOTITorchError aoti_torch_cpu_cholesky(AtenTensorHandle self, int32_t upper, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::cholesky(
            *tensor_handle_to_tensor_pointer(self), upper
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_cholesky_solve_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle input2, int32_t upper) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cholesky_solve_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(input2), upper
        );
    });
}


AOTITorchError aoti_torch_cpu_cholesky_solve(AtenTensorHandle self, AtenTensorHandle input2, int32_t upper, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::cholesky_solve(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(input2), upper
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__cholesky_solve_helper(AtenTensorHandle self, AtenTensorHandle A, int32_t upper, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_cholesky_solve_helper(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(A), upper
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_cholesky_inverse(AtenTensorHandle self, int32_t upper, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::cholesky_inverse(
            *tensor_handle_to_tensor_pointer(self), upper
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_cholesky_inverse_out(AtenTensorHandle out, AtenTensorHandle self, int32_t upper) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::cholesky_inverse_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), upper
        );
    });
}


AOTITorchError aoti_torch_cpu_geqrf_a(AtenTensorHandle a, AtenTensorHandle tau, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::geqrf_out(
            *tensor_handle_to_tensor_pointer(a), *tensor_handle_to_tensor_pointer(tau), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_geqrf(AtenTensorHandle self, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::geqrf(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_ormqr_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle input2, AtenTensorHandle input3, int32_t left, int32_t transpose) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::ormqr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(input2), *tensor_handle_to_tensor_pointer(input3), left, transpose
        );
    });
}


AOTITorchError aoti_torch_cpu_ormqr(AtenTensorHandle self, AtenTensorHandle input2, AtenTensorHandle input3, int32_t left, int32_t transpose, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::ormqr(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(input2), *tensor_handle_to_tensor_pointer(input3), left, transpose
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_lu_unpack_out(AtenTensorHandle P, AtenTensorHandle L, AtenTensorHandle U, AtenTensorHandle LU_data, AtenTensorHandle LU_pivots, int32_t unpack_data, int32_t unpack_pivots) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::lu_unpack_out(
            *tensor_handle_to_tensor_pointer(P), *tensor_handle_to_tensor_pointer(L), *tensor_handle_to_tensor_pointer(U), *tensor_handle_to_tensor_pointer(LU_data), *tensor_handle_to_tensor_pointer(LU_pivots), unpack_data, unpack_pivots
        );
    });
}


AOTITorchError aoti_torch_cpu_dist(AtenTensorHandle self, AtenTensorHandle other, double p, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::dist(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), p
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_histc_out(AtenTensorHandle out, AtenTensorHandle self, int64_t bins, double min, double max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::histc_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), bins, min, max
        );
    });
}


AOTITorchError aoti_torch_cpu_histc(AtenTensorHandle self, int64_t bins, double min, double max, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::histc(
            *tensor_handle_to_tensor_pointer(self), bins, min, max
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_histogram_bins_tensor_out(AtenTensorHandle hist, AtenTensorHandle bin_edges, AtenTensorHandle self, AtenTensorHandle bins, AtenTensorHandle* weight, int32_t density) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::histogram_out(
            *tensor_handle_to_tensor_pointer(hist), *tensor_handle_to_tensor_pointer(bin_edges), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(bins), pointer_to_optional<at::Tensor>(weight), density
        );
    });
}


AOTITorchError aoti_torch_cpu_histogram_bins_tensor(AtenTensorHandle self, AtenTensorHandle bins, AtenTensorHandle* weight, int32_t density, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::histogram(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(bins), pointer_to_optional<at::Tensor>(weight), density
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_histogram_bin_ct_out(AtenTensorHandle hist, AtenTensorHandle bin_edges, AtenTensorHandle self, int64_t bins, const double** range, int64_t range_len_, AtenTensorHandle* weight, int32_t density) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::histogram_out(
            *tensor_handle_to_tensor_pointer(hist), *tensor_handle_to_tensor_pointer(bin_edges), *tensor_handle_to_tensor_pointer(self), bins, pointer_to_optional_list<double>(range, range_len_), pointer_to_optional<at::Tensor>(weight), density
        );
    });
}


AOTITorchError aoti_torch_cpu_histogram_bin_ct(AtenTensorHandle self, int64_t bins, const double** range, int64_t range_len_, AtenTensorHandle* weight, int32_t density, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::histogram(
            *tensor_handle_to_tensor_pointer(self), bins, pointer_to_optional_list<double>(range, range_len_), pointer_to_optional<at::Tensor>(weight), density
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__histogramdd_from_bin_cts(AtenTensorHandle self, const int64_t* bins, int64_t bins_len_, const double** range, int64_t range_len_, AtenTensorHandle* weight, int32_t density, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_histogramdd_from_bin_cts(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(bins, bins_len_), pointer_to_optional_list<double>(range, range_len_), pointer_to_optional<at::Tensor>(weight), density
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__histogramdd_from_bin_tensors(AtenTensorHandle self, const AtenTensorHandle* bins, int64_t bins_len_, AtenTensorHandle* weight, int32_t density, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_histogramdd_from_bin_tensors(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<at::Tensor>(bins, bins_len_), pointer_to_optional<at::Tensor>(weight), density
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_min(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::min(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_min_unary_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::min_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_max(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::max(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_max_unary_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_sort_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t dim, int32_t descending) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sort_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), dim, descending
        );
    });
}


AOTITorchError aoti_torch_cpu_sort_values_stable(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int32_t* stable, int64_t dim, int32_t descending) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::sort_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<bool>(stable), dim, descending
        );
    });
}


AOTITorchError aoti_torch_cpu_sort(AtenTensorHandle self, int64_t dim, int32_t descending, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sort(
            *tensor_handle_to_tensor_pointer(self), dim, descending
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_argsort_stable(AtenTensorHandle self, int32_t stable, int64_t dim, int32_t descending, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::argsort(
            *tensor_handle_to_tensor_pointer(self), stable, dim, descending
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_topk_values(AtenTensorHandle values, AtenTensorHandle indices, AtenTensorHandle self, int64_t k, int64_t dim, int32_t largest, int32_t sorted) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::topk_symint_out(
            *tensor_handle_to_tensor_pointer(values), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), k, dim, largest, sorted
        );
    });
}


AOTITorchError aoti_torch_cpu_all_all_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::all_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_any_all_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::any_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_renorm_out(AtenTensorHandle out, AtenTensorHandle self, double p, int64_t dim, double maxnorm) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::renorm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), p, dim, maxnorm
        );
    });
}


AOTITorchError aoti_torch_cpu_unfold(AtenTensorHandle self, int64_t dimension, int64_t size, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::unfold(
            *tensor_handle_to_tensor_pointer(self), dimension, size, step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unfold_backward(AtenTensorHandle grad_in, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t size, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::unfold_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_in), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, size, step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_alias(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::alias(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__amp_foreach_non_finite_check_and_unscale_(const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle found_inf, AtenTensorHandle inv_scale) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_amp_foreach_non_finite_check_and_unscale_(
            pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(found_inf), *tensor_handle_to_tensor_pointer(inv_scale)
        );
    });
}


AOTITorchError aoti_torch_cpu__amp_update_scale_(AtenTensorHandle self, AtenTensorHandle growth_tracker, AtenTensorHandle found_inf, double scale_growth_factor, double scale_backoff_factor, int64_t growth_interval, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_amp_update_scale_(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(growth_tracker), *tensor_handle_to_tensor_pointer(found_inf), scale_growth_factor, scale_backoff_factor, growth_interval
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__foreach_add__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_add_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_add_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_add_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add__Tensor(const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_add_(
            pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sub_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sub_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sub_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_mul_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_mul_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_mul_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul__Tensor(const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_mul_(
            pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_div_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_div_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_div_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div__Tensor(const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_div_(
            pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_max_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_max_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_max_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_min_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_min_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_clamp_min_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_maximum_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_maximum_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_maximum_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum__Scalar(const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_minimum_(
            pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_minimum_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_minimum_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv__Scalar(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcdiv_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), value
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcdiv_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv__Tensor(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, AtenTensorHandle scalars) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcdiv_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), *tensor_handle_to_tensor_pointer(scalars)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul__Scalar(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcmul_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), value
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcmul_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul__Tensor(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, AtenTensorHandle scalars) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_addcmul_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), *tensor_handle_to_tensor_pointer(scalars)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_abs_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_abs_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_acos_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_acos_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_asin_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_asin_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_atan_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_atan_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_ceil_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_ceil_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_cos_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_cos_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_cosh_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_cosh_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_erf_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_erf_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_erfc_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_erfc_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_exp_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_exp_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_expm1_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_expm1_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_floor_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_floor_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_frac_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_frac_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lerp__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensors1, int64_t tensors1_len_, const AtenTensorHandle* weights, int64_t weights_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_lerp_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensors1, tensors1_len_), pointer_to_list<at::Tensor>(weights, weights_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lerp__Scalar(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensors1, int64_t tensors1_len_, double weight) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_lerp_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensors1, tensors1_len_), weight
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lgamma_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_lgamma_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_log_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log10_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_log10_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log1p_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_log1p_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log2_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_log2_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_neg_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_neg_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow__List(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* exponent, int64_t exponent_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_pow_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(exponent, exponent_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow__Scalar(const AtenTensorHandle* self, int64_t self_len_, double exponent) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_pow_(
            pointer_to_list<at::Tensor>(self, self_len_), exponent
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow__ScalarList(const AtenTensorHandle* self, int64_t self_len_, const double* exponent, int64_t exponent_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_pow_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(exponent, exponent_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_reciprocal_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_reciprocal_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_round_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_round_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sigmoid_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sigmoid_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sign_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sign_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sin_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sin_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sinh_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sinh_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sqrt_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_sqrt_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_tan_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_tan_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_tanh_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_tanh_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_trunc_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_trunc_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_zero_(const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_zero_(
            pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_copy_(const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* src, int64_t src_len_, int32_t non_blocking) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_foreach_copy_(
            pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(src, src_len_), non_blocking
        );
    });
}


AOTITorchError aoti_torch_cpu_bucketize_Tensor(AtenTensorHandle self, AtenTensorHandle boundaries, int32_t out_int32, int32_t right, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::bucketize(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(boundaries), out_int32, right
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_bucketize_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle boundaries, int32_t out_int32, int32_t right) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::bucketize_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(boundaries), out_int32, right
        );
    });
}


AOTITorchError aoti_torch_cpu_bucketize_Scalar(double self, AtenTensorHandle boundaries, int32_t out_int32, int32_t right, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::bucketize(
            self, *tensor_handle_to_tensor_pointer(boundaries), out_int32, right
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_searchsorted_Tensor(AtenTensorHandle sorted_sequence, AtenTensorHandle self, int32_t out_int32, int32_t right, const char** side, AtenTensorHandle* sorter, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::searchsorted(
            *tensor_handle_to_tensor_pointer(sorted_sequence), *tensor_handle_to_tensor_pointer(self), out_int32, right, pointer_to_optional<c10::string_view>(side), pointer_to_optional<at::Tensor>(sorter)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_searchsorted_Tensor_out(AtenTensorHandle out, AtenTensorHandle sorted_sequence, AtenTensorHandle self, int32_t out_int32, int32_t right, const char** side, AtenTensorHandle* sorter) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::searchsorted_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(sorted_sequence), *tensor_handle_to_tensor_pointer(self), out_int32, right, pointer_to_optional<c10::string_view>(side), pointer_to_optional<at::Tensor>(sorter)
        );
    });
}


AOTITorchError aoti_torch_cpu_searchsorted_Scalar(AtenTensorHandle sorted_sequence, double self, int32_t out_int32, int32_t right, const char** side, AtenTensorHandle* sorter, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::searchsorted(
            *tensor_handle_to_tensor_pointer(sorted_sequence), self, out_int32, right, pointer_to_optional<c10::string_view>(side), pointer_to_optional<at::Tensor>(sorter)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_searchsorted_Scalar_out(AtenTensorHandle out, AtenTensorHandle sorted_sequence, double self, int32_t out_int32, int32_t right, const char** side, AtenTensorHandle* sorter) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::searchsorted_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(sorted_sequence), self, out_int32, right, pointer_to_optional<c10::string_view>(side), pointer_to_optional<at::Tensor>(sorter)
        );
    });
}


AOTITorchError aoti_torch_cpu__convert_indices_from_coo_to_csr_out(AtenTensorHandle out, AtenTensorHandle self, int64_t size, int32_t out_int32) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_convert_indices_from_coo_to_csr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), size, out_int32
        );
    });
}


AOTITorchError aoti_torch_cpu__convert_indices_from_csr_to_coo_out(AtenTensorHandle out, AtenTensorHandle crow_indices, AtenTensorHandle col_indices, int32_t out_int32, int32_t transpose) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_convert_indices_from_csr_to_coo_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(crow_indices), *tensor_handle_to_tensor_pointer(col_indices), out_int32, transpose
        );
    });
}


AOTITorchError aoti_torch_cpu_mse_loss_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::mse_loss_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_mse_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::mse_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_mse_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::mse_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_multi_margin_loss_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, double p, double margin, AtenTensorHandle* weight, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::multi_margin_loss_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), p, margin, pointer_to_optional<at::Tensor>(weight), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_multi_margin_loss(AtenTensorHandle self, AtenTensorHandle target, double p, double margin, AtenTensorHandle* weight, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::multi_margin_loss(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), p, margin, pointer_to_optional<at::Tensor>(weight), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_multi_margin_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, double p, double margin, AtenTensorHandle* weight, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::multi_margin_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), p, margin, pointer_to_optional<at::Tensor>(weight), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_multi_margin_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, double p, double margin, AtenTensorHandle* weight, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::multi_margin_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), p, margin, pointer_to_optional<at::Tensor>(weight), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_multilabel_margin_loss_forward_output(AtenTensorHandle output, AtenTensorHandle is_target, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::multilabel_margin_loss_forward_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(is_target), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_multilabel_margin_loss_forward(AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::multilabel_margin_loss_forward(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_multilabel_margin_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle is_target) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::multilabel_margin_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, *tensor_handle_to_tensor_pointer(is_target)
        );
    });
}


AOTITorchError aoti_torch_cpu_multilabel_margin_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle is_target, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::multilabel_margin_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, *tensor_handle_to_tensor_pointer(is_target)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_nll_loss_forward_output(AtenTensorHandle output, AtenTensorHandle total_weight, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nll_loss_forward_symint_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(total_weight), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index
        );
    });
}


AOTITorchError aoti_torch_cpu_nll_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index, AtenTensorHandle total_weight) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nll_loss_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index, *tensor_handle_to_tensor_pointer(total_weight)
        );
    });
}


AOTITorchError aoti_torch_cpu_nll_loss2d_forward_output(AtenTensorHandle output, AtenTensorHandle total_weight, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nll_loss2d_forward_symint_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(total_weight), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index
        );
    });
}


AOTITorchError aoti_torch_cpu_nll_loss2d_forward(AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nll_loss2d_forward_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_nll_loss2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index, AtenTensorHandle total_weight) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::nll_loss2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index, *tensor_handle_to_tensor_pointer(total_weight)
        );
    });
}


AOTITorchError aoti_torch_cpu_nll_loss2d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, int64_t reduction, int64_t ignore_index, AtenTensorHandle total_weight, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::nll_loss2d_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), reduction, ignore_index, *tensor_handle_to_tensor_pointer(total_weight)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_smooth_l1_loss_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double beta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::smooth_l1_loss_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, beta
        );
    });
}


AOTITorchError aoti_torch_cpu_smooth_l1_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double beta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::smooth_l1_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, beta
        );
    });
}


AOTITorchError aoti_torch_cpu_smooth_l1_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double beta, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::smooth_l1_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, beta
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_huber_loss_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double delta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::huber_loss_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, delta
        );
    });
}


AOTITorchError aoti_torch_cpu_huber_loss(AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double delta, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::huber_loss(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, delta
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_huber_loss_backward_out(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double delta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::huber_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, delta
        );
    });
}


AOTITorchError aoti_torch_cpu_huber_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, double delta, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::huber_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction, delta
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_soft_margin_loss_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::soft_margin_loss_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_soft_margin_loss(AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::soft_margin_loss(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_soft_margin_loss_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::soft_margin_loss_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_soft_margin_loss_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle target, int64_t reduction, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::soft_margin_loss_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), reduction
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_elu_out(AtenTensorHandle out, AtenTensorHandle self, double alpha, double scale, double input_scale) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::elu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), alpha, scale, input_scale
        );
    });
}


AOTITorchError aoti_torch_cpu_elu_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, double alpha, double scale, double input_scale, int32_t is_result, AtenTensorHandle self_or_result) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::elu_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), alpha, scale, input_scale, is_result, *tensor_handle_to_tensor_pointer(self_or_result)
        );
    });
}


AOTITorchError aoti_torch_cpu_glu_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::glu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_glu_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::glu_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_glu_backward(AtenTensorHandle grad_output, AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::glu_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_glu_jvp(AtenTensorHandle glu, AtenTensorHandle x, AtenTensorHandle dx, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::glu_jvp(
            *tensor_handle_to_tensor_pointer(glu), *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(dx), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_glu_backward_jvp(AtenTensorHandle grad_x, AtenTensorHandle grad_glu, AtenTensorHandle x, AtenTensorHandle dgrad_glu, AtenTensorHandle dx, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::glu_backward_jvp(
            *tensor_handle_to_tensor_pointer(grad_x), *tensor_handle_to_tensor_pointer(grad_glu), *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(dgrad_glu), *tensor_handle_to_tensor_pointer(dx), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardsigmoid_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardsigmoid_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_hardsigmoid_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardsigmoid_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_hardtanh_out(AtenTensorHandle out, AtenTensorHandle self, double min_val, double max_val) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardtanh_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), min_val, max_val
        );
    });
}


AOTITorchError aoti_torch_cpu_hardtanh(AtenTensorHandle self, double min_val, double max_val, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardtanh(
            *tensor_handle_to_tensor_pointer(self), min_val, max_val
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardtanh_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, double min_val, double max_val) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardtanh_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), min_val, max_val
        );
    });
}


AOTITorchError aoti_torch_cpu_hardtanh_backward(AtenTensorHandle grad_output, AtenTensorHandle self, double min_val, double max_val, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardtanh_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), min_val, max_val
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardtanh_(AtenTensorHandle self, double min_val, double max_val, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardtanh_(
            *tensor_handle_to_tensor_pointer(self), min_val, max_val
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardswish_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::hardswish_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_hardswish(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardswish(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardswish_(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardswish_(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_hardswish_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::hardswish_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_leaky_relu_out(AtenTensorHandle out, AtenTensorHandle self, double negative_slope) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::leaky_relu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), negative_slope
        );
    });
}


AOTITorchError aoti_torch_cpu_leaky_relu_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, double negative_slope, int32_t self_is_result) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::leaky_relu_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), negative_slope, self_is_result
        );
    });
}


AOTITorchError aoti_torch_cpu_log_sigmoid_forward_output(AtenTensorHandle output, AtenTensorHandle buffer, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::log_sigmoid_forward_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(buffer), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_log_sigmoid_forward(AtenTensorHandle self, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::log_sigmoid_forward(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_log_sigmoid_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle buffer) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::log_sigmoid_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(buffer)
        );
    });
}


AOTITorchError aoti_torch_cpu_log_sigmoid_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle buffer, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::log_sigmoid_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(buffer)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_rrelu_with_noise_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle noise, double lower, double upper, int32_t training, int32_t self_is_result, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::rrelu_with_noise_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(noise), lower, upper, training, self_is_result
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_softplus_out(AtenTensorHandle out, AtenTensorHandle self, double beta, double threshold) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::softplus_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), beta, threshold
        );
    });
}


AOTITorchError aoti_torch_cpu_softplus_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, double beta, double threshold) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::softplus_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), beta, threshold
        );
    });
}


AOTITorchError aoti_torch_cpu_softshrink_out(AtenTensorHandle out, AtenTensorHandle self, double lambd) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::softshrink_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), lambd
        );
    });
}


AOTITorchError aoti_torch_cpu_softshrink_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, double lambd) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::softshrink_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), lambd
        );
    });
}


AOTITorchError aoti_torch_cpu_adaptive_avg_pool2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_avg_pool2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool2d(AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_adaptive_avg_pool2d_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool2d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_adaptive_avg_pool2d_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_adaptive_avg_pool3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_avg_pool3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool3d(AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_adaptive_avg_pool3d_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_adaptive_avg_pool3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_avg_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool3d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_adaptive_avg_pool3d_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_adaptive_max_pool2d_out(AtenTensorHandle out, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_max_pool2d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_adaptive_max_pool2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_max_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_adaptive_max_pool3d_out(AtenTensorHandle out, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_max_pool3d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_adaptive_max_pool3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::adaptive_max_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_avg_pool2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, int32_t ceil_mode, int32_t count_include_pad, int64_t* divisor_override) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::avg_pool2d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), ceil_mode, count_include_pad, pointer_to_optional<int64_t>(divisor_override)
        );
    });
}


AOTITorchError aoti_torch_cpu_avg_pool2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, int32_t ceil_mode, int32_t count_include_pad, int64_t* divisor_override) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::avg_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), ceil_mode, count_include_pad, pointer_to_optional<int64_t>(divisor_override)
        );
    });
}


AOTITorchError aoti_torch_cpu_avg_pool3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, int32_t ceil_mode, int32_t count_include_pad, int64_t* divisor_override) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::avg_pool3d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), ceil_mode, count_include_pad, pointer_to_optional<int64_t>(divisor_override)
        );
    });
}


AOTITorchError aoti_torch_cpu_avg_pool3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, int32_t ceil_mode, int32_t count_include_pad, int64_t* divisor_override) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::avg_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), ceil_mode, count_include_pad, pointer_to_optional<int64_t>(divisor_override)
        );
    });
}


AOTITorchError aoti_torch_cpu_fractional_max_pool2d_output(AtenTensorHandle output, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle random_samples) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::fractional_max_pool2d_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(output_size, output_size_len_), *tensor_handle_to_tensor_pointer(random_samples)
        );
    });
}


AOTITorchError aoti_torch_cpu_fractional_max_pool2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::fractional_max_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(output_size, output_size_len_), *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_fractional_max_pool3d_output(AtenTensorHandle output, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle random_samples) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::fractional_max_pool3d_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(output_size, output_size_len_), *tensor_handle_to_tensor_pointer(random_samples)
        );
    });
}


AOTITorchError aoti_torch_cpu_fractional_max_pool3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::fractional_max_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(output_size, output_size_len_), *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_fractional_max_pool3d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle indices, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::fractional_max_pool3d_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(output_size, output_size_len_), *tensor_handle_to_tensor_pointer(indices)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_max_pool2d_with_indices_out(AtenTensorHandle out, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_pool2d_with_indices_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_max_pool2d_with_indices_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_pool2d_with_indices_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode, *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_max_pool3d_with_indices_out(AtenTensorHandle out, AtenTensorHandle indices, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_pool3d_with_indices_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_max_pool3d_with_indices(AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::max_pool3d_with_indices(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_max_pool3d_with_indices_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode, AtenTensorHandle indices) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_pool3d_with_indices_backward_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode, *tensor_handle_to_tensor_pointer(indices)
        );
    });
}


AOTITorchError aoti_torch_cpu_max_pool3d_with_indices_backward(AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode, AtenTensorHandle indices, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::max_pool3d_with_indices_backward(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode, *tensor_handle_to_tensor_pointer(indices)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_max_unpool2d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle indices, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_unpool2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_max_unpool2d(AtenTensorHandle self, AtenTensorHandle indices, const int64_t* output_size, int64_t output_size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::max_unpool2d_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_max_unpool3d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle indices, const int64_t* output_size, int64_t output_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::max_unpool3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_max_unpool3d(AtenTensorHandle self, AtenTensorHandle indices, const int64_t* output_size, int64_t output_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::max_unpool3d_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad1d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad1d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad1d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad2d(AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::reflection_pad2d_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad2d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::reflection_pad2d_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_reflection_pad3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::reflection_pad3d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad1d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad1d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad1d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad2d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::replication_pad2d_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_replication_pad3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::replication_pad3d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_replication_pad3d_backward(AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::replication_pad3d_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_upsample_linear1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_linear1d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_linear1d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_linear1d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_bilinear2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_bilinear2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_bilinear2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_bilinear2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_bilinear2d_aa_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_bilinear2d_aa_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_bilinear2d_aa_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_bilinear2d_aa_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_bicubic2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_bicubic2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_bicubic2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_bicubic2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_bicubic2d_aa_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_bicubic2d_aa_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_bicubic2d_aa_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_bicubic2d_aa_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_trilinear3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, int32_t align_corners, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_trilinear3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), align_corners, pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_trilinear3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, int32_t align_corners, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_trilinear3d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), align_corners, pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest1d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact1d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest1d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest1d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact1d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact1d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_upsample_nearest3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::upsample_nearest3d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu__upsample_nearest_exact3d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_output, const int64_t* output_size, int64_t output_size_len_, const int64_t* input_size, int64_t input_size_len_, double* scales_d, double* scales_h, double* scales_w) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_upsample_nearest_exact3d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<c10::SymInt>(input_size, input_size_len_), pointer_to_optional<double>(scales_d), pointer_to_optional<double>(scales_h), pointer_to_optional<double>(scales_w)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_transpose2d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* dilation, int64_t dilation_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::slow_conv_transpose2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_transpose3d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* dilation, int64_t dilation_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::slow_conv_transpose3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_transpose3d(AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* dilation, int64_t dilation_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::slow_conv_transpose3d_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__slow_conv2d_forward_output(AtenTensorHandle output, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_slow_conv2d_forward_symint_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__slow_conv2d_forward(AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_slow_conv2d_forward_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__slow_conv2d_backward_grad_input(AtenTensorHandle grad_input, AtenTensorHandle grad_weight, AtenTensorHandle grad_bias, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_slow_conv2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(grad_input), *tensor_handle_to_tensor_pointer(grad_weight), *tensor_handle_to_tensor_pointer(grad_bias), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__slow_conv2d_backward_output_mask(AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int32_t* output_mask, int64_t output_mask_len_, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_slow_conv2d_backward_symint(
            *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<3>(output_mask)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_slow_conv3d_forward_output(AtenTensorHandle output, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::slow_conv3d_forward_symint_out(
            *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv3d_forward(AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::slow_conv3d_forward_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_dilated2d(AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::slow_conv_dilated2d_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_dilated3d(AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::slow_conv_dilated3d_symint(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_col2im_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* dilation, int64_t dilation_len_, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::col2im_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(dilation, dilation_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_col2im(AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* dilation, int64_t dilation_len_, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::col2im_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(dilation, dilation_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(stride, stride_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_im2col_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* dilation, int64_t dilation_len_, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::im2col_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(dilation, dilation_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_im2col(AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* dilation, int64_t dilation_len_, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::im2col(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(dilation, dilation_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(stride, stride_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fft_fftfreq(int64_t n, double d, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::fft_fftfreq(
            n, d, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fft_fftfreq_out(AtenTensorHandle out, int64_t n, double d) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fft_fftfreq_out(
            *tensor_handle_to_tensor_pointer(out), n, d
        );
    });
}


AOTITorchError aoti_torch_cpu_fft_rfftfreq(int64_t n, double d, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::fft_rfftfreq(
            n, d, pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_fft_rfftfreq_out(AtenTensorHandle out, int64_t n, double d) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fft_rfftfreq_out(
            *tensor_handle_to_tensor_pointer(out), n, d
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_cholesky_ex_L(AtenTensorHandle L, AtenTensorHandle info, AtenTensorHandle self, int32_t upper, int32_t check_errors) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_cholesky_ex_out(
            *tensor_handle_to_tensor_pointer(L), *tensor_handle_to_tensor_pointer(info), *tensor_handle_to_tensor_pointer(self), upper, check_errors
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_cross_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_cross_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_lu_factor_ex_out(AtenTensorHandle LU, AtenTensorHandle pivots, AtenTensorHandle info, AtenTensorHandle A, int32_t pivot, int32_t check_errors) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_lu_factor_ex_out(
            *tensor_handle_to_tensor_pointer(LU), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(info), *tensor_handle_to_tensor_pointer(A), pivot, check_errors
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_lu_out(AtenTensorHandle P, AtenTensorHandle L, AtenTensorHandle U, AtenTensorHandle A, int32_t pivot) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_lu_out(
            *tensor_handle_to_tensor_pointer(P), *tensor_handle_to_tensor_pointer(L), *tensor_handle_to_tensor_pointer(U), *tensor_handle_to_tensor_pointer(A), pivot
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_lu_solve_out(AtenTensorHandle out, AtenTensorHandle LU, AtenTensorHandle pivots, AtenTensorHandle B, int32_t left, int32_t adjoint) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_lu_solve_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(LU), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(B), left, adjoint
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_det_result(AtenTensorHandle result, AtenTensorHandle LU, AtenTensorHandle pivots, AtenTensorHandle A) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_linalg_det_out(
            *tensor_handle_to_tensor_pointer(result), *tensor_handle_to_tensor_pointer(LU), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(A)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_ldl_factor_ex_out(AtenTensorHandle LD, AtenTensorHandle pivots, AtenTensorHandle info, AtenTensorHandle self, int32_t hermitian, int32_t check_errors) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_ldl_factor_ex_out(
            *tensor_handle_to_tensor_pointer(LD), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(info), *tensor_handle_to_tensor_pointer(self), hermitian, check_errors
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_ldl_solve_out(AtenTensorHandle out, AtenTensorHandle LD, AtenTensorHandle pivots, AtenTensorHandle B, int32_t hermitian) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_ldl_solve_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(LD), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(B), hermitian
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_lstsq(AtenTensorHandle self, AtenTensorHandle b, double* rcond, const char** driver, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::linalg_lstsq(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(b), pointer_to_optional<double>(rcond), pointer_to_optional<c10::string_view>(driver)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_linalg_lstsq_out(AtenTensorHandle solution, AtenTensorHandle residuals, AtenTensorHandle rank, AtenTensorHandle singular_values, AtenTensorHandle self, AtenTensorHandle b, double* rcond, const char** driver) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_lstsq_out(
            *tensor_handle_to_tensor_pointer(solution), *tensor_handle_to_tensor_pointer(residuals), *tensor_handle_to_tensor_pointer(rank), *tensor_handle_to_tensor_pointer(singular_values), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(b), pointer_to_optional<double>(rcond), pointer_to_optional<c10::string_view>(driver)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_matrix_exp(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::linalg_matrix_exp(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__linalg_slogdet_sign(AtenTensorHandle sign, AtenTensorHandle logabsdet, AtenTensorHandle LU, AtenTensorHandle pivots, AtenTensorHandle A) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_linalg_slogdet_out(
            *tensor_handle_to_tensor_pointer(sign), *tensor_handle_to_tensor_pointer(logabsdet), *tensor_handle_to_tensor_pointer(LU), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(A)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_eig(AtenTensorHandle self, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::linalg_eig(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu_linalg_eig_out(AtenTensorHandle eigenvalues, AtenTensorHandle eigenvectors, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_eig_out(
            *tensor_handle_to_tensor_pointer(eigenvalues), *tensor_handle_to_tensor_pointer(eigenvectors), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_eigvals(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_linalg_eigvals(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linalg_eigvals_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_eigvals_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_eigh_eigenvalues(AtenTensorHandle eigenvalues, AtenTensorHandle eigenvectors, AtenTensorHandle A, const char* UPLO, int32_t compute_v) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_linalg_eigh_out(
            *tensor_handle_to_tensor_pointer(eigenvalues), *tensor_handle_to_tensor_pointer(eigenvectors), *tensor_handle_to_tensor_pointer(A), UPLO, compute_v
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_householder_product(AtenTensorHandle input, AtenTensorHandle tau, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::linalg_householder_product(
            *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(tau)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linalg_householder_product_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle tau) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_householder_product_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(tau)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_inv_ex_inverse(AtenTensorHandle inverse, AtenTensorHandle info, AtenTensorHandle A, int32_t check_errors) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_inv_ex_out(
            *tensor_handle_to_tensor_pointer(inverse), *tensor_handle_to_tensor_pointer(info), *tensor_handle_to_tensor_pointer(A), check_errors
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_vector_norm_out(AtenTensorHandle out, AtenTensorHandle self, double ord, const int64_t** dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_vector_norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), ord, pointer_to_optional_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_svd_U(AtenTensorHandle U, AtenTensorHandle S, AtenTensorHandle Vh, AtenTensorHandle A, int32_t full_matrices, int32_t compute_uv, const char** driver) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_linalg_svd_out(
            *tensor_handle_to_tensor_pointer(U), *tensor_handle_to_tensor_pointer(S), *tensor_handle_to_tensor_pointer(Vh), *tensor_handle_to_tensor_pointer(A), full_matrices, compute_uv, pointer_to_optional<c10::string_view>(driver)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_pinv_atol_rtol_tensor(AtenTensorHandle self, AtenTensorHandle* atol, AtenTensorHandle* rtol, int32_t hermitian, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::linalg_pinv(
            *tensor_handle_to_tensor_pointer(self), pointer_to_optional<at::Tensor>(atol), pointer_to_optional<at::Tensor>(rtol), hermitian
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_linalg_pinv_atol_rtol_tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle* atol, AtenTensorHandle* rtol, int32_t hermitian) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linalg_pinv_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<at::Tensor>(atol), pointer_to_optional<at::Tensor>(rtol), hermitian
        );
    });
}


AOTITorchError aoti_torch_cpu__linalg_solve_ex_result(AtenTensorHandle result, AtenTensorHandle LU, AtenTensorHandle pivots, AtenTensorHandle info, AtenTensorHandle A, AtenTensorHandle B, int32_t left, int32_t check_errors) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::_linalg_solve_ex_out(
            *tensor_handle_to_tensor_pointer(result), *tensor_handle_to_tensor_pointer(LU), *tensor_handle_to_tensor_pointer(pivots), *tensor_handle_to_tensor_pointer(info), *tensor_handle_to_tensor_pointer(A), *tensor_handle_to_tensor_pointer(B), left, check_errors
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_qr_out(AtenTensorHandle Q, AtenTensorHandle R, AtenTensorHandle A, const char* mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::cpu::linalg_qr_out(
            *tensor_handle_to_tensor_pointer(Q), *tensor_handle_to_tensor_pointer(R), *tensor_handle_to_tensor_pointer(A), mode
        );
    });
}


AOTITorchError aoti_torch_cpu__test_parallel_materialize(AtenTensorHandle self, int64_t num_parallel, int32_t skip_first, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_test_parallel_materialize(
            *tensor_handle_to_tensor_pointer(self), num_parallel, skip_first
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_optional_intlist(AtenTensorHandle values, const int64_t** addends, int64_t addends_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_test_optional_intlist(
            *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<int64_t>(addends, addends_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_optional_filled_intlist(AtenTensorHandle values, const int64_t** addends, int64_t addends_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_test_optional_filled_intlist(
            *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<int64_t>(addends, addends_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_optional_floatlist(AtenTensorHandle values, const double** addends, int64_t addends_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_test_optional_floatlist(
            *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<double>(addends, addends_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_warn_in_autograd(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_test_warn_in_autograd(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_autograd_multiple_dispatch_fullcoverage(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_test_autograd_multiple_dispatch(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_autograd_multiple_dispatch_view(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_test_autograd_multiple_dispatch_view(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__test_autograd_multiple_dispatch_view_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_test_autograd_multiple_dispatch_view_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_segment_reduce(AtenTensorHandle data, const char* reduce, AtenTensorHandle* lengths, AtenTensorHandle* indices, AtenTensorHandle* offsets, int64_t axis, int32_t unsafe, double* initial, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::segment_reduce(
            *tensor_handle_to_tensor_pointer(data), reduce, pointer_to_optional<at::Tensor>(lengths), pointer_to_optional<at::Tensor>(indices), pointer_to_optional<at::Tensor>(offsets), axis, unsafe, pointer_to_optional<c10::Scalar>(initial)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__segment_reduce_backward(AtenTensorHandle grad, AtenTensorHandle output, AtenTensorHandle data, const char* reduce, AtenTensorHandle* lengths, AtenTensorHandle* offsets, int64_t axis, double* initial, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_segment_reduce_backward(
            *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(data), reduce, pointer_to_optional<at::Tensor>(lengths), pointer_to_optional<at::Tensor>(offsets), axis, pointer_to_optional<c10::Scalar>(initial)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_from_tensor_list(const AtenTensorHandle* list, int64_t list_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_nested_tensor_from_tensor_list(
            pointer_to_list<at::Tensor>(list, list_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__fw_primal_copy(AtenTensorHandle self, int64_t level, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_fw_primal_copy(
            *tensor_handle_to_tensor_pointer(self), level
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__make_dual_copy(AtenTensorHandle primal, AtenTensorHandle tangent, int64_t level, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_make_dual_copy(
            *tensor_handle_to_tensor_pointer(primal), *tensor_handle_to_tensor_pointer(tangent), level
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_as_real_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::view_as_real_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_as_complex_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::view_as_complex_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__conj_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_conj_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__neg_view_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_neg_view_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_as_strided_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::as_strided_copy_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__sparse_broadcast_to_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_sparse_broadcast_to_copy(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_diagonal_copy(AtenTensorHandle self, int64_t offset, int64_t dim1, int64_t dim2, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::diagonal_copy(
            *tensor_handle_to_tensor_pointer(self), offset, dim1, dim2
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_expand_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t implicit, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::expand_copy_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), implicit
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_permute_copy(AtenTensorHandle self, const int64_t* dims, int64_t dims_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::permute_copy(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dims, dims_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__reshape_alias_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_reshape_alias_copy_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_select_copy_int(AtenTensorHandle self, int64_t dim, int64_t index, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::select_copy_symint(
            *tensor_handle_to_tensor_pointer(self), dim, index
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_detach_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::detach_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_slice_copy_Tensor(AtenTensorHandle self, int64_t dim, int64_t* start, int64_t* end, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::slice_copy_symint(
            *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::squeeze_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy_dim(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::squeeze_copy(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy_dims(AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::squeeze_copy(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_t_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::t_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_transpose_copy_int(AtenTensorHandle self, int64_t dim0, int64_t dim1, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::transpose_copy(
            *tensor_handle_to_tensor_pointer(self), dim0, dim1
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unsqueeze_copy(AtenTensorHandle self, int64_t dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::unsqueeze_copy(
            *tensor_handle_to_tensor_pointer(self), dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__values_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::_values_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_values_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::values_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_crow_indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::crow_indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_col_indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::col_indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_ccol_indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::ccol_indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_row_indices_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::row_indices_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unbind_copy_int_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unbind_copy_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_split_copy_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, int64_t split_size, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::split_copy_symint_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), split_size, dim
        );
    });
}


AOTITorchError aoti_torch_cpu_split_with_sizes_copy_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, const int64_t* split_sizes, int64_t split_sizes_len_, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::split_with_sizes_copy_symint_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(split_sizes, split_sizes_len_), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_view_copy(AtenTensorHandle self, const int64_t* size, int64_t size_len_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::view_copy_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_view_copy_dtype(AtenTensorHandle self, int32_t dtype, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::view_copy(
            *tensor_handle_to_tensor_pointer(self), static_cast<c10::ScalarType>(dtype)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_unfold_copy(AtenTensorHandle self, int64_t dimension, int64_t size, int64_t step, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::unfold_copy(
            *tensor_handle_to_tensor_pointer(self), dimension, size, step
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_alias_copy(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautogradnonfunctional::alias_copy(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__transformer_encoder_layer_fwd(AtenTensorHandle src, int64_t embed_dim, int64_t num_heads, AtenTensorHandle qkv_weight, AtenTensorHandle qkv_bias, AtenTensorHandle proj_weight, AtenTensorHandle proj_bias, int32_t use_gelu, int32_t norm_first, double eps, AtenTensorHandle norm_weight_1, AtenTensorHandle norm_bias_1, AtenTensorHandle norm_weight_2, AtenTensorHandle norm_bias_2, AtenTensorHandle ffn_weight_1, AtenTensorHandle ffn_bias_1, AtenTensorHandle ffn_weight_2, AtenTensorHandle ffn_bias_2, AtenTensorHandle* mask, int64_t* mask_type, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_transformer_encoder_layer_fwd(
            *tensor_handle_to_tensor_pointer(src), embed_dim, num_heads, *tensor_handle_to_tensor_pointer(qkv_weight), *tensor_handle_to_tensor_pointer(qkv_bias), *tensor_handle_to_tensor_pointer(proj_weight), *tensor_handle_to_tensor_pointer(proj_bias), use_gelu, norm_first, eps, *tensor_handle_to_tensor_pointer(norm_weight_1), *tensor_handle_to_tensor_pointer(norm_bias_1), *tensor_handle_to_tensor_pointer(norm_weight_2), *tensor_handle_to_tensor_pointer(norm_bias_2), *tensor_handle_to_tensor_pointer(ffn_weight_1), *tensor_handle_to_tensor_pointer(ffn_bias_1), *tensor_handle_to_tensor_pointer(ffn_weight_2), *tensor_handle_to_tensor_pointer(ffn_bias_2), pointer_to_optional<at::Tensor>(mask), pointer_to_optional<int64_t>(mask_type)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__native_multi_head_attention(AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, int64_t embed_dim, int64_t num_head, AtenTensorHandle qkv_weight, AtenTensorHandle qkv_bias, AtenTensorHandle proj_weight, AtenTensorHandle proj_bias, AtenTensorHandle* mask, int32_t need_weights, int32_t average_attn_weights, int64_t* mask_type, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_native_multi_head_attention(
            *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), embed_dim, num_head, *tensor_handle_to_tensor_pointer(qkv_weight), *tensor_handle_to_tensor_pointer(qkv_bias), *tensor_handle_to_tensor_pointer(proj_weight), *tensor_handle_to_tensor_pointer(proj_bias), pointer_to_optional<at::Tensor>(mask), need_weights, average_attn_weights, pointer_to_optional<int64_t>(mask_type)
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__fused_sdp_choice(AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, AtenTensorHandle* attn_mask, double dropout_p, int32_t is_causal, double* scale, int64_t* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_fused_sdp_choice(
            *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), pointer_to_optional<at::Tensor>(attn_mask), dropout_p, is_causal, pointer_to_optional<double>(scale)
        );
        *ret0 = tmp_result;
    });
}


AOTITorchError aoti_torch_cpu__scaled_dot_product_flash_attention_for_cpu(AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, double dropout_p, int32_t is_causal, AtenTensorHandle* attn_mask, double* scale, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_scaled_dot_product_flash_attention_for_cpu(
            *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), dropout_p, is_causal, pointer_to_optional<at::Tensor>(attn_mask), pointer_to_optional<double>(scale)
        );
        if (ret0) { *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));; }
        if (ret1) { *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));; }
    });
}


AOTITorchError aoti_torch_cpu__scaled_dot_product_flash_attention_for_cpu_backward(AtenTensorHandle grad_out, AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, AtenTensorHandle out, AtenTensorHandle logsumexp, double dropout_p, int32_t is_causal, AtenTensorHandle* attn_mask, double* scale, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_scaled_dot_product_flash_attention_for_cpu_backward(
            *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(logsumexp), dropout_p, is_causal, pointer_to_optional<at::Tensor>(attn_mask), pointer_to_optional<double>(scale)
        );
        if (ret0) { *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));; }
        if (ret1) { *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));; }
        if (ret2) { *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));; }
    });
}


AOTITorchError aoti_torch_cpu__foobar(AtenTensorHandle self, int32_t arg1, int32_t arg2, int32_t arg3, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::cpu::_foobar(
            *tensor_handle_to_tensor_pointer(self), arg1, arg2, arg3
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__new_zeros_with_same_feature_meta_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other, int64_t self_num_batch_dims) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_new_zeros_with_same_feature_meta_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), self_num_batch_dims
        );
    });
}


AOTITorchError aoti_torch_cpu__cudnn_ctc_loss_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle log_probs, AtenTensorHandle targets, const int64_t* input_lengths, int64_t input_lengths_len_, const int64_t* target_lengths, int64_t target_lengths_len_, int64_t blank, int32_t deterministic, int32_t zero_infinity) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cudnn_ctc_loss_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), pointer_to_list<int64_t>(input_lengths, input_lengths_len_), pointer_to_list<int64_t>(target_lengths, target_lengths_len_), blank, deterministic, zero_infinity
        );
    });
}


AOTITorchError aoti_torch_cpu__cudnn_rnn_flatten_weight_out(AtenTensorHandle out, const AtenTensorHandle* weight_arr, int64_t weight_arr_len_, int64_t weight_stride0, int64_t input_size, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, int32_t batch_first, int32_t bidirectional) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cudnn_rnn_flatten_weight_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(weight_arr, weight_arr_len_), weight_stride0, input_size, mode, hidden_size, proj_size, num_layers, batch_first, bidirectional
        );
    });
}


AOTITorchError aoti_torch_cpu__cudnn_rnn_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle out4, AtenTensorHandle input, const AtenTensorHandle* weight, int64_t weight_len_, int64_t weight_stride0, AtenTensorHandle* weight_buf, AtenTensorHandle hx, AtenTensorHandle* cx, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, int32_t batch_first, double dropout, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, AtenTensorHandle* dropout_state) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cudnn_rnn_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(out4), *tensor_handle_to_tensor_pointer(input), pointer_to_list<at::Tensor>(weight, weight_len_), weight_stride0, pointer_to_optional<at::Tensor>(weight_buf), *tensor_handle_to_tensor_pointer(hx), pointer_to_optional<at::Tensor>(cx), mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, pointer_to_list<c10::SymInt>(batch_sizes, batch_sizes_len_), pointer_to_optional<at::Tensor>(dropout_state)
        );
    });
}


AOTITorchError aoti_torch_cpu__cudnn_rnn_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, const AtenTensorHandle* out3, int64_t out3_len_, AtenTensorHandle input, const AtenTensorHandle* weight, int64_t weight_len_, int64_t weight_stride0, AtenTensorHandle weight_buf, AtenTensorHandle hx, AtenTensorHandle* cx, AtenTensorHandle output, AtenTensorHandle* grad_output, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, int64_t mode, int64_t hidden_size, int64_t proj_size, int64_t num_layers, int32_t batch_first, double dropout, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, AtenTensorHandle* dropout_state, AtenTensorHandle reserve, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cudnn_rnn_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), pointer_to_list<at::Tensor>(out3, out3_len_), *tensor_handle_to_tensor_pointer(input), pointer_to_list<at::Tensor>(weight, weight_len_), weight_stride0, *tensor_handle_to_tensor_pointer(weight_buf), *tensor_handle_to_tensor_pointer(hx), pointer_to_optional<at::Tensor>(cx), *tensor_handle_to_tensor_pointer(output), pointer_to_optional<at::Tensor>(grad_output), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), mode, hidden_size, proj_size, num_layers, batch_first, dropout, train, bidirectional, pointer_to_list<c10::SymInt>(batch_sizes, batch_sizes_len_), pointer_to_optional<at::Tensor>(dropout_state), *tensor_handle_to_tensor_pointer(reserve), pointer_to_list<4>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__cudnn_init_dropout_state_out(AtenTensorHandle out, double dropout, int32_t train, int64_t dropout_seed) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cudnn_init_dropout_state_out(
            *tensor_handle_to_tensor_pointer(out), dropout, train, dropout_seed
        );
    });
}


AOTITorchError aoti_torch_cpu__masked_scale_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, double scale) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_masked_scale_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), scale
        );
    });
}


AOTITorchError aoti_torch_cpu_native_dropout_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, double p, int32_t* train) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_dropout_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), p, pointer_to_optional<bool>(train)
        );
    });
}


AOTITorchError aoti_torch_cpu_native_dropout_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle mask, double scale) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_dropout_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(mask), scale
        );
    });
}


AOTITorchError aoti_torch_cpu__conj_physical_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_conj_physical_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__add_relu_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_add_relu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_add_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::add_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_affine_grid_generator_out(AtenTensorHandle out, AtenTensorHandle theta, const int64_t* size, int64_t size_len_, int32_t align_corners) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::affine_grid_generator_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(theta), pointer_to_list<c10::SymInt>(size, size_len_), align_corners
        );
    });
}


AOTITorchError aoti_torch_cpu__test_functorch_fallback_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_functorch_fallback_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_bartlett_window_out(AtenTensorHandle out, int64_t window_length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bartlett_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length
        );
    });
}


AOTITorchError aoti_torch_cpu_bartlett_window_periodic_out(AtenTensorHandle out, int64_t window_length, int32_t periodic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bartlett_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic
        );
    });
}


AOTITorchError aoti_torch_cpu_quantized_batch_norm_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle mean, AtenTensorHandle var, double eps, double output_scale, int64_t output_zero_point) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantized_batch_norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(var), eps, output_scale, output_zero_point
        );
    });
}


AOTITorchError aoti_torch_cpu_binary_cross_entropy_with_logits_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle target, AtenTensorHandle* weight, AtenTensorHandle* pos_weight, int64_t reduction) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::binary_cross_entropy_with_logits_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(target), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(pos_weight), reduction
        );
    });
}


AOTITorchError aoti_torch_cpu_bincount_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle* weights, int64_t minlength) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bincount_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<at::Tensor>(weights), minlength
        );
    });
}


AOTITorchError aoti_torch_cpu_blackman_window_out(AtenTensorHandle out, int64_t window_length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::blackman_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length
        );
    });
}


AOTITorchError aoti_torch_cpu_blackman_window_periodic_out(AtenTensorHandle out, int64_t window_length, int32_t periodic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::blackman_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic
        );
    });
}


AOTITorchError aoti_torch_cpu_block_diag_out(AtenTensorHandle out, const AtenTensorHandle* tensors, int64_t tensors_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::block_diag_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(tensors, tensors_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_constant_pad_nd_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* pad, int64_t pad_len_, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::constant_pad_nd_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(pad, pad_len_), value
        );
    });
}


AOTITorchError aoti_torch_cpu_convolution_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_convolution_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle weight, const int64_t** bias_sizes, int64_t bias_sizes_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::convolution_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional_list<c10::SymInt>(bias_sizes, bias_sizes_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_convolution_overrideable_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::convolution_overrideable_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_convolution_backward_overrideable_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle weight, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::convolution_backward_overrideable_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__convolution_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t transposed, const int64_t* output_padding, int64_t output_padding_len_, int64_t groups, int32_t benchmark, int32_t deterministic, int32_t cudnn_enabled, int32_t allow_tf32) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), transposed, pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), groups, benchmark, deterministic, cudnn_enabled, allow_tf32
        );
    });
}


AOTITorchError aoti_torch_cpu_conv_tbc_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle bias, int64_t pad) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::conv_tbc_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(bias), pad
        );
    });
}


AOTITorchError aoti_torch_cpu_copy_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, int32_t non_blocking) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), non_blocking
        );
    });
}


AOTITorchError aoti_torch_cpu__copy_from_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle dst, int32_t non_blocking) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_copy_from_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(dst), non_blocking
        );
    });
}


AOTITorchError aoti_torch_cpu__copy_from_and_resize_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle dst) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_copy_from_and_resize_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(dst)
        );
    });
}


AOTITorchError aoti_torch_cpu_count_nonzero_dim_IntList_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::count_nonzero_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_count_nonzero_out(AtenTensorHandle out, AtenTensorHandle self, int64_t* dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::count_nonzero_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dim)
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_affine_grid_generator_out(AtenTensorHandle out, AtenTensorHandle theta, int64_t N, int64_t C, int64_t H, int64_t W) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_affine_grid_generator_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(theta), N, C, H, W
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_affine_grid_generator_backward_out(AtenTensorHandle out, AtenTensorHandle grad, int64_t N, int64_t C, int64_t H, int64_t W) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_affine_grid_generator_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), N, C, H, W
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_batch_norm_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, int32_t training, double exponential_average_factor, double epsilon) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_batch_norm_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), training, exponential_average_factor, epsilon
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_batch_norm_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, AtenTensorHandle grad_output, AtenTensorHandle weight, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, AtenTensorHandle* save_mean, AtenTensorHandle* save_var, double epsilon, AtenTensorHandle reserveSpace) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_batch_norm_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), pointer_to_optional<at::Tensor>(save_mean), pointer_to_optional<at::Tensor>(save_var), epsilon, *tensor_handle_to_tensor_pointer(reserveSpace)
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_convolution_transpose_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, int32_t benchmark, int32_t deterministic, int32_t allow_tf32) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_convolution_transpose_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, benchmark, deterministic, allow_tf32
        );
    });
}


AOTITorchError aoti_torch_cpu__mps_convolution_transpose_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_mps_convolution_transpose_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_mps_convolution_transpose_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, AtenTensorHandle grad_output, AtenTensorHandle weight, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mps_convolution_transpose_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, pointer_to_list<2>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_convolution_relu_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_convolution_relu_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_convolution_add_relu_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle z, double* alpha, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_convolution_add_relu_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(z), pointer_to_optional<c10::Scalar>(alpha), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_grid_sampler_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle grid) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_grid_sampler_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grid)
        );
    });
}


AOTITorchError aoti_torch_cpu_cudnn_grid_sampler_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, AtenTensorHandle grid, AtenTensorHandle grad_output) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::cudnn_grid_sampler_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grid), *tensor_handle_to_tensor_pointer(grad_output)
        );
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle log_probs, AtenTensorHandle targets, const int64_t* input_lengths, int64_t input_lengths_len_, const int64_t* target_lengths, int64_t target_lengths_len_, int64_t blank, int32_t zero_infinity) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_ctc_loss_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), pointer_to_list<int64_t>(input_lengths, input_lengths_len_), pointer_to_list<int64_t>(target_lengths, target_lengths_len_), blank, zero_infinity
        );
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_Tensor_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle log_probs, AtenTensorHandle targets, AtenTensorHandle input_lengths, AtenTensorHandle target_lengths, int64_t blank, int32_t zero_infinity) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_ctc_loss_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), *tensor_handle_to_tensor_pointer(input_lengths), *tensor_handle_to_tensor_pointer(target_lengths), blank, zero_infinity
        );
    });
}


AOTITorchError aoti_torch_cpu__ctc_loss_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle log_probs, AtenTensorHandle targets, const int64_t* input_lengths, int64_t input_lengths_len_, const int64_t* target_lengths, int64_t target_lengths_len_, AtenTensorHandle neg_log_likelihood, AtenTensorHandle log_alpha, int64_t blank, int32_t zero_infinity) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_ctc_loss_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(log_probs), *tensor_handle_to_tensor_pointer(targets), pointer_to_list<int64_t>(input_lengths, input_lengths_len_), pointer_to_list<int64_t>(target_lengths, target_lengths_len_), *tensor_handle_to_tensor_pointer(neg_log_likelihood), *tensor_handle_to_tensor_pointer(log_alpha), blank, zero_infinity
        );
    });
}


AOTITorchError aoti_torch_cpu_diag_embed_out(AtenTensorHandle out, AtenTensorHandle self, int64_t offset, int64_t dim1, int64_t dim2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::diag_embed_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), offset, dim1, dim2
        );
    });
}


AOTITorchError aoti_torch_cpu_diagonal_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t offset, int64_t dim1, int64_t dim2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::diagonal_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), offset, dim1, dim2
        );
    });
}


AOTITorchError aoti_torch_cpu_div_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::div_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other
        );
    });
}


AOTITorchError aoti_torch_cpu_div_Scalar_mode_out(AtenTensorHandle out, AtenTensorHandle self, double other, const char** rounding_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::div_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other, pointer_to_optional<c10::string_view>(rounding_mode)
        );
    });
}


AOTITorchError aoti_torch_cpu_embedding_out(AtenTensorHandle out, AtenTensorHandle weight, AtenTensorHandle indices, int64_t padding_idx, int32_t scale_grad_by_freq, int32_t sparse) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::embedding_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), padding_idx, scale_grad_by_freq, sparse
        );
    });
}


AOTITorchError aoti_torch_cpu_embedding_dense_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle indices, int64_t num_weights, int64_t padding_idx, int32_t scale_grad_by_freq) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::embedding_dense_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(indices), num_weights, padding_idx, scale_grad_by_freq
        );
    });
}


AOTITorchError aoti_torch_cpu_embedding_renorm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle indices, double max_norm, double norm_type) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::embedding_renorm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), max_norm, norm_type
        );
    });
}


AOTITorchError aoti_torch_cpu_embedding_renorm(AtenTensorHandle self, AtenTensorHandle indices, double max_norm, double norm_type, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::embedding_renorm(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(indices), max_norm, norm_type
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_forward_only_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, int32_t scale_grad_by_freq, int64_t mode, int32_t sparse, AtenTensorHandle* per_sample_weights, int32_t include_last_offset, int64_t padding_idx) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_embedding_bag_forward_only_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), scale_grad_by_freq, mode, sparse, pointer_to_optional<at::Tensor>(per_sample_weights), include_last_offset, padding_idx
        );
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, int32_t scale_grad_by_freq, int64_t mode, int32_t sparse, AtenTensorHandle* per_sample_weights, int32_t include_last_offset, int64_t padding_idx) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_embedding_bag_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), scale_grad_by_freq, mode, sparse, pointer_to_optional<at::Tensor>(per_sample_weights), include_last_offset, padding_idx
        );
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_dense_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle indices, AtenTensorHandle offset2bag, AtenTensorHandle bag_size, AtenTensorHandle maximum_indices, int64_t num_weights, int32_t scale_grad_by_freq, int64_t mode, AtenTensorHandle* per_sample_weights, int64_t padding_idx) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_embedding_bag_dense_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offset2bag), *tensor_handle_to_tensor_pointer(bag_size), *tensor_handle_to_tensor_pointer(maximum_indices), num_weights, scale_grad_by_freq, mode, pointer_to_optional<at::Tensor>(per_sample_weights), padding_idx
        );
    });
}


AOTITorchError aoti_torch_cpu__embedding_bag_per_sample_weights_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle weight, AtenTensorHandle indices, AtenTensorHandle offsets, AtenTensorHandle offset2bag, int64_t mode, int64_t padding_idx) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_embedding_bag_per_sample_weights_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(weight), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(offsets), *tensor_handle_to_tensor_pointer(offset2bag), mode, padding_idx
        );
    });
}


AOTITorchError aoti_torch_cpu_empty_permuted_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, const int64_t* physical_layout, int64_t physical_layout_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::empty_permuted_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<int64_t>(physical_layout, physical_layout_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_new_empty_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::new_empty_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_new_empty_strided_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::new_empty_strided_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_new_full_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, double fill_value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::new_full_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), fill_value
        );
    });
}


AOTITorchError aoti_torch_cpu_new_zeros_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::new_zeros_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_new_ones_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::new_ones_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__empty_affine_quantized_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, double scale, int64_t zero_point, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_empty_affine_quantized_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_), scale, zero_point, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu__empty_per_channel_affine_quantized_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, AtenTensorHandle scales, AtenTensorHandle zero_points, int64_t axis, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_empty_per_channel_affine_quantized_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_), *tensor_handle_to_tensor_pointer(scales), *tensor_handle_to_tensor_pointer(zero_points), axis, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_resize_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::resize_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_resize(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::resize_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__resize_output_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t device, int32_t device_index_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_resize_output_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), c10::Device(static_cast<c10::DeviceType>(device), static_cast<c10::DeviceIndex>(device_index_))
        );
    });
}


AOTITorchError aoti_torch_cpu__resize_output(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t device, int32_t device_index_, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_resize_output_symint(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), c10::Device(static_cast<c10::DeviceType>(device), static_cast<c10::DeviceIndex>(device_index_))
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_empty_quantized_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, AtenTensorHandle qtensor, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::empty_quantized_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<int64_t>(size, size_len_), *tensor_handle_to_tensor_pointer(qtensor), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_empty_like_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::empty_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_empty_strided_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::empty_strided_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_fill_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), value
        );
    });
}


AOTITorchError aoti_torch_cpu_fill_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(value)
        );
    });
}


AOTITorchError aoti_torch_cpu_floor_divide_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::floor_divide_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other
        );
    });
}


AOTITorchError aoti_torch_cpu_full_like_out(AtenTensorHandle out, AtenTensorHandle self, double fill_value, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::full_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), fill_value, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_from_file_out(AtenTensorHandle out, const char* filename, int32_t* shared, int64_t* size) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::from_file_out(
            *tensor_handle_to_tensor_pointer(out), filename, pointer_to_optional<bool>(shared), pointer_to_optional<int64_t>(size)
        );
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_2d_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::grid_sampler_2d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_2d_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::grid_sampler_2d_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners, pointer_to_list<2>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__grid_sampler_2d_cpu_fallback_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_grid_sampler_2d_cpu_fallback_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_3d_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::grid_sampler_3d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners
        );
    });
}


AOTITorchError aoti_torch_cpu_grid_sampler_3d_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle grid, int64_t interpolation_mode, int64_t padding_mode, int32_t align_corners, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::grid_sampler_3d_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grid), interpolation_mode, padding_mode, align_corners, pointer_to_list<2>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_hann_window_out(AtenTensorHandle out, int64_t window_length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hann_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length
        );
    });
}


AOTITorchError aoti_torch_cpu_hann_window_periodic_out(AtenTensorHandle out, int64_t window_length, int32_t periodic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hann_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic
        );
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_out(AtenTensorHandle out, int64_t window_length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hamming_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length
        );
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic_out(AtenTensorHandle out, int64_t window_length, int32_t periodic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hamming_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic
        );
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic_alpha_out(AtenTensorHandle out, int64_t window_length, int32_t periodic, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hamming_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_hamming_window_periodic_alpha_beta_out(AtenTensorHandle out, int64_t window_length, int32_t periodic, double alpha, double beta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hamming_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic, alpha, beta
        );
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window_out(AtenTensorHandle out, int64_t window_length) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::kaiser_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length
        );
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window_periodic_out(AtenTensorHandle out, int64_t window_length, int32_t periodic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::kaiser_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic
        );
    });
}


AOTITorchError aoti_torch_cpu_kaiser_window_beta_out(AtenTensorHandle out, int64_t window_length, int32_t periodic, double beta) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::kaiser_window_out(
            *tensor_handle_to_tensor_pointer(out), window_length, periodic, beta
        );
    });
}


AOTITorchError aoti_torch_cpu_native_group_norm_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, int64_t N, int64_t C, int64_t HxW, int64_t group, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_group_norm_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), N, C, HxW, group, eps
        );
    });
}


AOTITorchError aoti_torch_cpu_native_group_norm_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle rstd, AtenTensorHandle* weight, int64_t N, int64_t C, int64_t HxW, int64_t group, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_group_norm_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(rstd), pointer_to_optional<at::Tensor>(weight), N, C, HxW, group, pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_index_put_out(AtenTensorHandle out, AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::index_put_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate
        );
    });
}


AOTITorchError aoti_torch_cpu__index_put_impl_out(AtenTensorHandle out, AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, int32_t unsafe) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_index_put_impl_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate, unsafe
        );
    });
}


AOTITorchError aoti_torch_cpu__index_put_impl(AtenTensorHandle self, const AtenTensorHandle** indices, int64_t indices_len_, AtenTensorHandle values, int32_t accumulate, int32_t unsafe, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_index_put_impl(
            *tensor_handle_to_tensor_pointer(self), c10::List<c10::optional<at::Tensor>>(c10::ArrayRef<c10::optional<at::Tensor>>(pointer_to_list<c10::optional<at::Tensor>>(indices, indices_len_))), *tensor_handle_to_tensor_pointer(values), accumulate, unsafe
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_isnan_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::isnan_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_native_layer_norm_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, const int64_t* normalized_shape, int64_t normalized_shape_len_, AtenTensorHandle* weight, AtenTensorHandle* bias, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_layer_norm_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), pointer_to_list<c10::SymInt>(normalized_shape, normalized_shape_len_), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), eps
        );
    });
}


AOTITorchError aoti_torch_cpu_native_layer_norm_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_out, AtenTensorHandle input, const int64_t* normalized_shape, int64_t normalized_shape_len_, AtenTensorHandle mean, AtenTensorHandle rstd, AtenTensorHandle* weight, AtenTensorHandle* bias, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_layer_norm_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), pointer_to_list<c10::SymInt>(normalized_shape, normalized_shape_len_), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(rstd), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_linear_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, AtenTensorHandle grad_output, AtenTensorHandle weight, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linear_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_linear_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_linear_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_linear_backward_input_out(AtenTensorHandle out, const int64_t* input_size, int64_t input_size_len_, AtenTensorHandle grad_output, AtenTensorHandle weight) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_linear_backward_input_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<int64_t>(input_size, input_size_len_), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_linear_backward_weights_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle grad_output, AtenTensorHandle input, AtenTensorHandle weight, int32_t bias_defined) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_linear_backward_weights_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), bias_defined
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_linear_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, AtenTensorHandle grad_output, AtenTensorHandle weight, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_linear_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_matmul_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle grad, AtenTensorHandle self, AtenTensorHandle other, const int32_t* mask, int64_t mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::matmul_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), pointer_to_list<2>(mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__aminmax_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_aminmax_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__aminmax_dim_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, int64_t dim, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_aminmax_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), dim, keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_max_pool2d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::max_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_max_pool2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_max_pool2d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_max_pool2d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, AtenTensorHandle input, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_max_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(input), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_max_pool3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_max_pool3d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_max_pool3d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, AtenTensorHandle input, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_max_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(input), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_quantized_max_pool1d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantized_max_pool1d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_quantized_max_pool2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantized_max_pool2d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_quantized_max_pool3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_, int32_t ceil_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantized_max_pool3d_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(kernel_size, kernel_size_len_), pointer_to_list<int64_t>(stride, stride_len_), pointer_to_list<int64_t>(padding, padding_len_), pointer_to_list<int64_t>(dilation, dilation_len_), ceil_mode
        );
    });
}


AOTITorchError aoti_torch_cpu_median_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::median_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_nanmedian_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::nanmedian_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__mps_convolution_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_mps_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_mps_convolution_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, AtenTensorHandle grad_output, AtenTensorHandle weight, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mps_convolution_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_convolution_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_rnn_layer_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle input, AtenTensorHandle weight0, AtenTensorHandle weight1, AtenTensorHandle weight2, AtenTensorHandle weight3, AtenTensorHandle hx_, AtenTensorHandle cx_, int32_t reverse, const int64_t* batch_sizes, int64_t batch_sizes_len_, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t has_biases, int32_t bidirectional, int32_t batch_first, int32_t train) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_rnn_layer_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight0), *tensor_handle_to_tensor_pointer(weight1), *tensor_handle_to_tensor_pointer(weight2), *tensor_handle_to_tensor_pointer(weight3), *tensor_handle_to_tensor_pointer(hx_), *tensor_handle_to_tensor_pointer(cx_), reverse, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), mode, hidden_size, num_layers, has_biases, bidirectional, batch_first, train
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_rnn_layer_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle out4, AtenTensorHandle out5, AtenTensorHandle out6, AtenTensorHandle input, AtenTensorHandle weight1, AtenTensorHandle weight2, AtenTensorHandle weight3, AtenTensorHandle weight4, AtenTensorHandle hx_, AtenTensorHandle cx_tmp, AtenTensorHandle output, AtenTensorHandle hy_, AtenTensorHandle cy_, AtenTensorHandle* grad_output, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, int32_t reverse, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t has_biases, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, int32_t batch_first, AtenTensorHandle workspace) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_rnn_layer_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(out4), *tensor_handle_to_tensor_pointer(out5), *tensor_handle_to_tensor_pointer(out6), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight1), *tensor_handle_to_tensor_pointer(weight2), *tensor_handle_to_tensor_pointer(weight3), *tensor_handle_to_tensor_pointer(weight4), *tensor_handle_to_tensor_pointer(hx_), *tensor_handle_to_tensor_pointer(cx_tmp), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(hy_), *tensor_handle_to_tensor_pointer(cy_), pointer_to_optional<at::Tensor>(grad_output), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), reverse, mode, hidden_size, num_layers, has_biases, train, bidirectional, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), batch_first, *tensor_handle_to_tensor_pointer(workspace)
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_batch_norm_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, int32_t training, double exponential_average_factor, double epsilon) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_batch_norm_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), training, exponential_average_factor, epsilon
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_batch_norm_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, AtenTensorHandle grad_output, AtenTensorHandle weight, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, AtenTensorHandle* save_mean, AtenTensorHandle* save_var, double epsilon) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_batch_norm_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), pointer_to_optional<at::Tensor>(save_mean), pointer_to_optional<at::Tensor>(save_var), epsilon
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_convolution_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, int32_t benchmark, int32_t deterministic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, benchmark, deterministic
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_convolution_transpose_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* output_padding, int64_t output_padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, int32_t benchmark, int32_t deterministic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_convolution_transpose_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(output_padding, output_padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, benchmark, deterministic
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_depthwise_convolution_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, int32_t benchmark, int32_t deterministic) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_depthwise_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, benchmark, deterministic
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_rnn_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle out4, AtenTensorHandle input, const AtenTensorHandle* weight, int64_t weight_len_, int64_t weight_stride0, AtenTensorHandle hx, AtenTensorHandle* cx, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t batch_first, double dropout, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, AtenTensorHandle* dropout_state) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_rnn_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(out4), *tensor_handle_to_tensor_pointer(input), pointer_to_list<at::Tensor>(weight, weight_len_), weight_stride0, *tensor_handle_to_tensor_pointer(hx), pointer_to_optional<at::Tensor>(cx), mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), pointer_to_optional<at::Tensor>(dropout_state)
        );
    });
}


AOTITorchError aoti_torch_cpu_miopen_rnn_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, const AtenTensorHandle* out3, int64_t out3_len_, AtenTensorHandle input, const AtenTensorHandle* weight, int64_t weight_len_, int64_t weight_stride0, AtenTensorHandle weight_buf, AtenTensorHandle hx, AtenTensorHandle* cx, AtenTensorHandle output, AtenTensorHandle* grad_output, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, int64_t mode, int64_t hidden_size, int64_t num_layers, int32_t batch_first, double dropout, int32_t train, int32_t bidirectional, const int64_t* batch_sizes, int64_t batch_sizes_len_, AtenTensorHandle* dropout_state, AtenTensorHandle reserve, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::miopen_rnn_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), pointer_to_list<at::Tensor>(out3, out3_len_), *tensor_handle_to_tensor_pointer(input), pointer_to_list<at::Tensor>(weight, weight_len_), weight_stride0, *tensor_handle_to_tensor_pointer(weight_buf), *tensor_handle_to_tensor_pointer(hx), pointer_to_optional<at::Tensor>(cx), *tensor_handle_to_tensor_pointer(output), pointer_to_optional<at::Tensor>(grad_output), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), mode, hidden_size, num_layers, batch_first, dropout, train, bidirectional, pointer_to_list<int64_t>(batch_sizes, batch_sizes_len_), pointer_to_optional<at::Tensor>(dropout_state), *tensor_handle_to_tensor_pointer(reserve), pointer_to_list<4>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_sparse_matmul_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_sparse_matmul_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_mul_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mul_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other
        );
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_functional(AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle running_mean, AtenTensorHandle running_var, int32_t training, double momentum, double eps, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3, AtenTensorHandle* ret4) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_native_batch_norm_legit_functional(
            *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(running_mean), *tensor_handle_to_tensor_pointer(running_var), training, momentum, eps
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
        *ret4 = new_tensor_handle(std::move(std::get<4>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__native_batch_norm_legit_no_training_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* bias, AtenTensorHandle running_mean, AtenTensorHandle running_var, double momentum, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_native_batch_norm_legit_no_training_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(bias), *tensor_handle_to_tensor_pointer(running_mean), *tensor_handle_to_tensor_pointer(running_var), momentum, eps
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_stats_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, double eps) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_stats_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), eps
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_gather_stats_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle invstd, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, double momentum, double eps, int64_t count) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_gather_stats_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(invstd), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), momentum, eps, count
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_gather_stats_with_counts_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle invstd, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, double momentum, double eps, AtenTensorHandle counts) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_gather_stats_with_counts_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(invstd), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), momentum, eps, *tensor_handle_to_tensor_pointer(counts)
        );
    });
}


AOTITorchError aoti_torch_cpu_native_batch_norm_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle* weight, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, AtenTensorHandle* save_mean, AtenTensorHandle* save_invstd, int32_t train, double eps, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_batch_norm_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(weight), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), pointer_to_optional<at::Tensor>(save_mean), pointer_to_optional<at::Tensor>(save_invstd), train, eps, pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_backward_reduce_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle invstd, AtenTensorHandle* weight, int32_t input_g, int32_t weight_g, int32_t bias_g) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_backward_reduce_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(invstd), pointer_to_optional<at::Tensor>(weight), input_g, weight_g, bias_g
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_backward_elemt_out(AtenTensorHandle out, AtenTensorHandle grad_out, AtenTensorHandle input, AtenTensorHandle mean, AtenTensorHandle invstd, AtenTensorHandle* weight, AtenTensorHandle sum_dy, AtenTensorHandle sum_dy_xmu, AtenTensorHandle count) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_backward_elemt_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(mean), *tensor_handle_to_tensor_pointer(invstd), pointer_to_optional<at::Tensor>(weight), *tensor_handle_to_tensor_pointer(sum_dy), *tensor_handle_to_tensor_pointer(sum_dy_xmu), *tensor_handle_to_tensor_pointer(count)
        );
    });
}


AOTITorchError aoti_torch_cpu_batch_norm_update_stats_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, AtenTensorHandle* running_mean, AtenTensorHandle* running_var, double momentum) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::batch_norm_update_stats_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), pointer_to_optional<at::Tensor>(running_mean), pointer_to_optional<at::Tensor>(running_var), momentum
        );
    });
}


AOTITorchError aoti_torch_cpu__nnpack_spatial_convolution_out(AtenTensorHandle out, AtenTensorHandle input, AtenTensorHandle weight, AtenTensorHandle* bias, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nnpack_spatial_convolution_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(weight), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_ones_like_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::ones_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu__euclidean_dist_out(AtenTensorHandle out, AtenTensorHandle x1, AtenTensorHandle x2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_euclidean_dist_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2)
        );
    });
}


AOTITorchError aoti_torch_cpu__cdist_forward_out(AtenTensorHandle out, AtenTensorHandle x1, AtenTensorHandle x2, double p, int64_t* compute_mode) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cdist_forward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2), p, pointer_to_optional<int64_t>(compute_mode)
        );
    });
}


AOTITorchError aoti_torch_cpu__cdist_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle x1, AtenTensorHandle x2, double p, AtenTensorHandle cdist) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cdist_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(x1), *tensor_handle_to_tensor_pointer(x2), p, *tensor_handle_to_tensor_pointer(cdist)
        );
    });
}


AOTITorchError aoti_torch_cpu__pdist_forward_out(AtenTensorHandle out, AtenTensorHandle self, double p) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_pdist_forward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), p
        );
    });
}


AOTITorchError aoti_torch_cpu__pdist_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle self, double p, AtenTensorHandle pdist) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_pdist_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), p, *tensor_handle_to_tensor_pointer(pdist)
        );
    });
}


AOTITorchError aoti_torch_cpu_pixel_shuffle_out(AtenTensorHandle out, AtenTensorHandle self, int64_t upscale_factor) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::pixel_shuffle_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), upscale_factor
        );
    });
}


AOTITorchError aoti_torch_cpu_pixel_unshuffle_out(AtenTensorHandle out, AtenTensorHandle self, int64_t downscale_factor) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::pixel_unshuffle_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), downscale_factor
        );
    });
}


AOTITorchError aoti_torch_cpu_channel_shuffle_out(AtenTensorHandle out, AtenTensorHandle self, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::channel_shuffle_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), groups
        );
    });
}


AOTITorchError aoti_torch_cpu__pin_memory_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* device, int32_t device_index_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_pin_memory_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_device(device, device_index_)
        );
    });
}


AOTITorchError aoti_torch_cpu_scalar_tensor_out(AtenTensorHandle out, double s) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::scalar_tensor_out(
            *tensor_handle_to_tensor_pointer(out), s
        );
    });
}


AOTITorchError aoti_torch_cpu_rand_like_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rand_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_randint_like_out(AtenTensorHandle out, AtenTensorHandle self, int64_t high, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randint_like_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), high, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_randint_like_low_dtype_out(AtenTensorHandle out, AtenTensorHandle self, int64_t low, int64_t high, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randint_like_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), low, high, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_randn_like_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::randn_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_repeat_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* repeats, int64_t repeats_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::repeat_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(repeats, repeats_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_repeat_interleave_Tensor_out(AtenTensorHandle out, AtenTensorHandle repeats, int64_t* output_size) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::repeat_interleave_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(repeats), pointer_to_optional<c10::SymInt>(output_size)
        );
    });
}


AOTITorchError aoti_torch_cpu__mkldnn_reshape_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* shape, int64_t shape_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_mkldnn_reshape_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(shape, shape_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_relu_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::relu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_select_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::select_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, index
        );
    });
}


AOTITorchError aoti_torch_cpu_celu_out(AtenTensorHandle out, AtenTensorHandle self, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::celu_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_slice_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t start, int64_t end, int64_t step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::slice_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, start, end, step
        );
    });
}


AOTITorchError aoti_torch_cpu_slice_scatter_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, int64_t dim, int64_t* start, int64_t* end, int64_t step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::slice_scatter_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
    });
}


AOTITorchError aoti_torch_cpu_select_scatter_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, int64_t dim, int64_t index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::select_scatter_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), dim, index
        );
    });
}


AOTITorchError aoti_torch_cpu_diagonal_scatter_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, int64_t offset, int64_t dim1, int64_t dim2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::diagonal_scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), offset, dim1, dim2
        );
    });
}


AOTITorchError aoti_torch_cpu_as_strided_scatter_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::as_strided_scatter_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
    });
}


AOTITorchError aoti_torch_cpu_unsafe_split_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, int64_t split_size, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unsafe_split_symint_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), split_size, dim
        );
    });
}


AOTITorchError aoti_torch_cpu_unsafe_split_with_sizes_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, const int64_t* split_sizes, int64_t split_sizes_len_, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unsafe_split_with_sizes_symint_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(split_sizes, split_sizes_len_), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_sum_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_std_mean_correction_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::std_mean_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu_prod_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::prod_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__mkldnn_transpose_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim0, int64_t dim1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_mkldnn_transpose_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim0, dim1
        );
    });
}


AOTITorchError aoti_torch_cpu_flip_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dims, int64_t dims_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::flip_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dims, dims_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_roll_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* shifts, int64_t shifts_len_, const int64_t* dims, int64_t dims_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::roll_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(shifts, shifts_len_), pointer_to_list<int64_t>(dims, dims_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_rot90_out(AtenTensorHandle out, AtenTensorHandle self, int64_t k, const int64_t* dims, int64_t dims_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rot90_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), k, pointer_to_list<int64_t>(dims, dims_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__transform_bias_rescale_qkv_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle qkv, AtenTensorHandle qkv_bias, int64_t num_heads) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_transform_bias_rescale_qkv_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(qkv), *tensor_handle_to_tensor_pointer(qkv_bias), num_heads
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_from_mask_out(AtenTensorHandle out, AtenTensorHandle t, AtenTensorHandle mask, int32_t mask_check) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_tensor_from_mask_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(t), *tensor_handle_to_tensor_pointer(mask), mask_check
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_from_padded_out(AtenTensorHandle out, AtenTensorHandle padded, AtenTensorHandle cpu_nested_shape_example, int32_t fuse_transform_0213) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_from_padded_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(padded), *tensor_handle_to_tensor_pointer(cpu_nested_shape_example), fuse_transform_0213
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_size_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_tensor_size_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_strides_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_tensor_strides_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_storage_offsets_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_tensor_storage_offsets_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_from_padded_and_nested_example_out(AtenTensorHandle out, AtenTensorHandle padded, AtenTensorHandle nt_example) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_from_padded_and_nested_example_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(padded), *tensor_handle_to_tensor_pointer(nt_example)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_view_from_buffer_copy_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle nested_size, AtenTensorHandle nested_strides, AtenTensorHandle offsets) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_view_from_buffer_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(nested_size), *tensor_handle_to_tensor_pointer(nested_strides), *tensor_handle_to_tensor_pointer(offsets)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_view_from_jagged_copy_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle offsets, AtenTensorHandle dummy, AtenTensorHandle* lengths, int64_t ragged_idx) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_view_from_jagged_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(offsets), *tensor_handle_to_tensor_pointer(dummy), pointer_to_optional<at::Tensor>(lengths), ragged_idx
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_get_values_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_get_values_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__trilinear_out(AtenTensorHandle out, AtenTensorHandle i1, AtenTensorHandle i2, AtenTensorHandle i3, const int64_t* expand1, int64_t expand1_len_, const int64_t* expand2, int64_t expand2_len_, const int64_t* expand3, int64_t expand3_len_, const int64_t* sumdim, int64_t sumdim_len_, int64_t unroll_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_trilinear_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(i1), *tensor_handle_to_tensor_pointer(i2), *tensor_handle_to_tensor_pointer(i3), pointer_to_list<int64_t>(expand1, expand1_len_), pointer_to_list<int64_t>(expand2, expand2_len_), pointer_to_list<int64_t>(expand3, expand3_len_), pointer_to_list<int64_t>(sumdim, sumdim_len_), unroll_dim
        );
    });
}


AOTITorchError aoti_torch_cpu__unique_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, int32_t sorted, int32_t return_inverse) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_unique_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), sorted, return_inverse
        );
    });
}


AOTITorchError aoti_torch_cpu_unique_dim_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, int64_t dim, int32_t sorted, int32_t return_inverse, int32_t return_counts) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unique_dim_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), dim, sorted, return_inverse, return_counts
        );
    });
}


AOTITorchError aoti_torch_cpu_unique_consecutive_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, int32_t return_inverse, int32_t return_counts, int64_t* dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unique_consecutive_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), return_inverse, return_counts, pointer_to_optional<int64_t>(dim)
        );
    });
}


AOTITorchError aoti_torch_cpu_unique_dim_consecutive_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, int64_t dim, int32_t return_inverse, int32_t return_counts) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unique_dim_consecutive_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), dim, return_inverse, return_counts
        );
    });
}


AOTITorchError aoti_torch_cpu__unique2_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle self, int32_t sorted, int32_t return_inverse, int32_t return_counts) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_unique2_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(self), sorted, return_inverse, return_counts
        );
    });
}


AOTITorchError aoti_torch_cpu__unsafe_view_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_unsafe_view_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_var_mean_correction_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, const int64_t** dim, int64_t dim_len_, double* correction, int32_t keepdim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::var_mean_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), pointer_to_optional_list<int64_t>(dim, dim_len_), pointer_to_optional<c10::Scalar>(correction), keepdim
        );
    });
}


AOTITorchError aoti_torch_cpu__weight_norm_interface_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle v, AtenTensorHandle g, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_weight_norm_interface_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(v), *tensor_handle_to_tensor_pointer(g), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__weight_norm_interface_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle grad_w, AtenTensorHandle saved_v, AtenTensorHandle saved_g, AtenTensorHandle saved_norms, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_weight_norm_interface_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(grad_w), *tensor_handle_to_tensor_pointer(saved_v), *tensor_handle_to_tensor_pointer(saved_g), *tensor_handle_to_tensor_pointer(saved_norms), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__efficientzerotensor_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_efficientzerotensor_symint_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_zeros_like_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::zeros_like_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu__standard_gamma_grad_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle output) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_standard_gamma_grad_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(output)
        );
    });
}


AOTITorchError aoti_torch_cpu__dirichlet_grad_out(AtenTensorHandle out, AtenTensorHandle x, AtenTensorHandle alpha, AtenTensorHandle total) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_dirichlet_grad_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(alpha), *tensor_handle_to_tensor_pointer(total)
        );
    });
}


AOTITorchError aoti_torch_cpu_native_norm_out(AtenTensorHandle out, AtenTensorHandle self, double p) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), p
        );
    });
}


AOTITorchError aoti_torch_cpu_native_norm_ScalarOpt_dim_dtype_out(AtenTensorHandle out, AtenTensorHandle self, double* p, const int64_t* dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::native_norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Scalar>(p), pointer_to_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_sum_dim_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_sum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_sum_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_sum_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_csr_sum_dim_dtype_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_csr_sum_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_csr_prod_dim_dtype_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_, int32_t keepdim, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_csr_prod_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_), keepdim, pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_softmax_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t half_to_float) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, half_to_float
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_softmax_backward_data_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, int64_t dim, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_softmax_backward_data_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), dim, *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_log_softmax_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int32_t half_to_float) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_log_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, half_to_float
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_log_softmax_backward_data_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, int64_t dim, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_log_softmax_backward_data_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), dim, *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__spdiags_out(AtenTensorHandle out, AtenTensorHandle diagonals, AtenTensorHandle offsets, const int64_t* shape, int64_t shape_len_, int32_t* layout) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_spdiags_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(diagonals), *tensor_handle_to_tensor_pointer(offsets), pointer_to_list<int64_t>(shape, shape_len_), pointer_to_optional<c10::Layout>(layout)
        );
    });
}


AOTITorchError aoti_torch_cpu_norm_ScalarOpt_dtype_out(AtenTensorHandle out, AtenTensorHandle self, double* p, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Scalar>(p), static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_norm_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double p) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::norm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), p
        );
    });
}


AOTITorchError aoti_torch_cpu_clone_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::clone_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_resize_as_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle the_template, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::resize_as_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(the_template), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu_resize_as(AtenTensorHandle self, AtenTensorHandle the_template, int32_t* memory_format, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::resize_as(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(the_template), pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_resize_as_sparse_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle the_template) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::resize_as_sparse_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(the_template)
        );
    });
}


AOTITorchError aoti_torch_cpu_resize_as_sparse(AtenTensorHandle self, AtenTensorHandle the_template, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::resize_as_sparse(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(the_template)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_zero_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::zero_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_zero(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::zero(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sub_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sub_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_rsub_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rsub_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_rsub_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rsub_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_addmm_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mat1, AtenTensorHandle mat2, double beta, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_addmm_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mat1), *tensor_handle_to_tensor_pointer(mat2), beta, alpha
        );
    });
}


AOTITorchError aoti_torch_cpu_sparse_coo_tensor_size_out(AtenTensorHandle out, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sparse_coo_tensor_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<int64_t>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_coo_tensor_with_dims_out(AtenTensorHandle out, int64_t sparse_dim, int64_t dense_dim, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_coo_tensor_with_dims_out(
            *tensor_handle_to_tensor_pointer(out), sparse_dim, dense_dim, pointer_to_list<int64_t>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_coo_tensor_with_dims_and_tensors_out(AtenTensorHandle out, int64_t sparse_dim, int64_t dense_dim, const int64_t* size, int64_t size_len_, AtenTensorHandle indices, AtenTensorHandle values, int32_t* is_coalesced) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_coo_tensor_with_dims_and_tensors_symint_out(
            *tensor_handle_to_tensor_pointer(out), sparse_dim, dense_dim, pointer_to_list<c10::SymInt>(size, size_len_), *tensor_handle_to_tensor_pointer(indices), *tensor_handle_to_tensor_pointer(values), pointer_to_optional<bool>(is_coalesced)
        );
    });
}


AOTITorchError aoti_torch_cpu_sparse_resize_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, int64_t sparse_dim, int64_t dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sparse_resize_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_), sparse_dim, dense_dim
        );
    });
}


AOTITorchError aoti_torch_cpu_sparse_resize(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int64_t sparse_dim, int64_t dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sparse_resize(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_), sparse_dim, dense_dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sparse_resize_and_clear_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, int64_t sparse_dim, int64_t dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sparse_resize_and_clear_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_), sparse_dim, dense_dim
        );
    });
}


AOTITorchError aoti_torch_cpu_sparse_resize_and_clear(AtenTensorHandle self, const int64_t* size, int64_t size_len_, int64_t sparse_dim, int64_t dense_dim, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::sparse_resize_and_clear(
            *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_), sparse_dim, dense_dim
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_sparse_mask_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::sparse_mask_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_mask_projection_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, int32_t accumulate_matches) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_mask_projection_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), accumulate_matches
        );
    });
}


AOTITorchError aoti_torch_cpu__to_dense_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* dtype, int32_t* masked_grad) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_dense_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<bool>(masked_grad)
        );
    });
}


AOTITorchError aoti_torch_cpu__coalesce_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_coalesce_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__coalesced_out(AtenTensorHandle out, AtenTensorHandle self, int32_t coalesced) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_coalesced_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), coalesced
        );
    });
}


AOTITorchError aoti_torch_cpu__coalesced(AtenTensorHandle self, int32_t coalesced, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_coalesced(
            *tensor_handle_to_tensor_pointer(self), coalesced
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_copy_sparse_to_sparse_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle src, int32_t non_blocking) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::copy_sparse_to_sparse_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), non_blocking
        );
    });
}


AOTITorchError aoti_torch_cpu_copy_sparse_to_sparse(AtenTensorHandle self, AtenTensorHandle src, int32_t non_blocking, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::copy_sparse_to_sparse(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(src), non_blocking
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_sparse_dim_out(AtenTensorHandle out, AtenTensorHandle self, int64_t sparse_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), sparse_dim
        );
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* layout, const int64_t** blocksize, int64_t blocksize_len_, int64_t* dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_csr_out(AtenTensorHandle out, AtenTensorHandle self, int64_t* dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_csr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dense_dim)
        );
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_csc_out(AtenTensorHandle out, AtenTensorHandle self, int64_t* dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_csc_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<int64_t>(dense_dim)
        );
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_bsr_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* blocksize, int64_t blocksize_len_, int64_t* dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_bsr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
    });
}


AOTITorchError aoti_torch_cpu__to_sparse_bsc_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* blocksize, int64_t blocksize_len_, int64_t* dense_dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_sparse_bsc_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(blocksize, blocksize_len_), pointer_to_optional<int64_t>(dense_dim)
        );
    });
}


AOTITorchError aoti_torch_cpu_to_mkldnn_out(AtenTensorHandle out, AtenTensorHandle self, int32_t* dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::to_mkldnn_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_optional<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_reorder_conv2d_weight_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups, const int64_t** input_size, int64_t input_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_reorder_conv2d_weight_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups, pointer_to_optional_list<c10::SymInt>(input_size, input_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_reorder_conv3d_weight_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* padding, int64_t padding_len_, const int64_t* stride, int64_t stride_len_, const int64_t* dilation, int64_t dilation_len_, int64_t groups) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_reorder_conv3d_weight_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_), groups
        );
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_dynamic_out(AtenTensorHandle out, AtenTensorHandle self, int32_t dtype, int32_t reduce_range) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantize_per_tensor_dynamic_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), static_cast<c10::ScalarType>(dtype), reduce_range
        );
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_out(AtenTensorHandle out, AtenTensorHandle self, double scale, int64_t zero_point, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantize_per_tensor_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), scale, zero_point, static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_tensor_qparams_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantize_per_tensor_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_tensor_tensors_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* tensors, int64_t tensors_len_, AtenTensorHandle scales, AtenTensorHandle zero_points, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantize_per_tensor_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(tensors, tensors_len_), *tensor_handle_to_tensor_pointer(scales), *tensor_handle_to_tensor_pointer(zero_points), static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_quantize_per_channel_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle scales, AtenTensorHandle zero_points, int64_t axis, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::quantize_per_channel_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scales), *tensor_handle_to_tensor_pointer(zero_points), axis, static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_dequantize_self_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::dequantize_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_dequantize_tensors_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* tensors, int64_t tensors_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::dequantize_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(tensors, tensors_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_q_per_channel_scales_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::q_per_channel_scales_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_q_per_channel_zero_points_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::q_per_channel_zero_points_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_int_repr_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::int_repr_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__make_per_tensor_quantized_tensor_out(AtenTensorHandle out, AtenTensorHandle self, double scale, int64_t zero_point) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_make_per_tensor_quantized_tensor_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), scale, zero_point
        );
    });
}


AOTITorchError aoti_torch_cpu__make_per_channel_quantized_tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_make_per_channel_quantized_tensor_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis
        );
    });
}


AOTITorchError aoti_torch_cpu_fake_quantize_per_tensor_affine_cachemask_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, double scale, int64_t zero_point, int64_t quant_min, int64_t quant_max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fake_quantize_per_tensor_affine_cachemask_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), scale, zero_point, quant_min, quant_max
        );
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_per_tensor_affine_cachemask_tensor_qparams_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, AtenTensorHandle fake_quant_enabled, int64_t quant_min, int64_t quant_max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fake_quantize_per_tensor_affine_cachemask_tensor_qparams_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), *tensor_handle_to_tensor_pointer(fake_quant_enabled), quant_min, quant_max
        );
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_tensor_affine_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t quant_min, int64_t quant_max, double grad_factor) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fake_quantize_learnable_per_tensor_affine_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), quant_min, quant_max, grad_factor
        );
    });
}


AOTITorchError aoti_torch_cpu_fake_quantize_per_channel_affine_cachemask_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, int64_t quant_min, int64_t quant_max) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::fake_quantize_per_channel_affine_cachemask_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis, quant_min, quant_max
        );
    });
}


AOTITorchError aoti_torch_cpu__fake_quantize_learnable_per_channel_affine_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle scale, AtenTensorHandle zero_point, int64_t axis, int64_t quant_min, int64_t quant_max, double grad_factor) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fake_quantize_learnable_per_channel_affine_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), axis, quant_min, quant_max, grad_factor
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_moving_avg_obs_fq_helper_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle self, AtenTensorHandle observer_on, AtenTensorHandle fake_quant_on, AtenTensorHandle running_min, AtenTensorHandle running_max, AtenTensorHandle scale, AtenTensorHandle zero_point, double averaging_const, int64_t quant_min, int64_t quant_max, int64_t ch_axis, int32_t per_row_fake_quant, int32_t symmetric_quant) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_moving_avg_obs_fq_helper_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(observer_on), *tensor_handle_to_tensor_pointer(fake_quant_on), *tensor_handle_to_tensor_pointer(running_min), *tensor_handle_to_tensor_pointer(running_max), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), averaging_const, quant_min, quant_max, ch_axis, per_row_fake_quant, symmetric_quant
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_moving_avg_obs_fq_helper_functional(AtenTensorHandle self, AtenTensorHandle observer_on, AtenTensorHandle fake_quant_on, AtenTensorHandle running_min, AtenTensorHandle running_max, AtenTensorHandle scale, AtenTensorHandle zero_point, double averaging_const, int64_t quant_min, int64_t quant_max, int64_t ch_axis, int32_t per_row_fake_quant, int32_t symmetric_quant, AtenTensorHandle* ret0, AtenTensorHandle* ret1, AtenTensorHandle* ret2, AtenTensorHandle* ret3, AtenTensorHandle* ret4, AtenTensorHandle* ret5) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_fused_moving_avg_obs_fq_helper_functional(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(observer_on), *tensor_handle_to_tensor_pointer(fake_quant_on), *tensor_handle_to_tensor_pointer(running_min), *tensor_handle_to_tensor_pointer(running_max), *tensor_handle_to_tensor_pointer(scale), *tensor_handle_to_tensor_pointer(zero_point), averaging_const, quant_min, quant_max, ch_axis, per_row_fake_quant, symmetric_quant
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
        *ret2 = new_tensor_handle(std::move(std::get<2>(tmp_result)));;
        *ret3 = new_tensor_handle(std::move(std::get<3>(tmp_result)));;
        *ret4 = new_tensor_handle(std::move(std::get<4>(tmp_result)));;
        *ret5 = new_tensor_handle(std::move(std::get<5>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__to_copy_out(AtenTensorHandle out, AtenTensorHandle self, int32_t non_blocking, int32_t* memory_format) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_to_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), non_blocking, pointer_to_optional<c10::MemoryFormat>(memory_format)
        );
    });
}


AOTITorchError aoti_torch_cpu__lstm_mps_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle out4, AtenTensorHandle out5, AtenTensorHandle input, const AtenTensorHandle* hx, int64_t hx_len_, const AtenTensorHandle* params, int64_t params_len_, int32_t has_biases, int64_t num_layers, double dropout, int32_t train, int32_t bidirectional, int32_t batch_first) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_lstm_mps_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(out4), *tensor_handle_to_tensor_pointer(out5), *tensor_handle_to_tensor_pointer(input), pointer_to_list<at::Tensor>(hx, hx_len_), pointer_to_list<at::Tensor>(params, params_len_), has_biases, num_layers, dropout, train, bidirectional, batch_first
        );
    });
}


AOTITorchError aoti_torch_cpu_lstm_mps_backward_out(AtenTensorHandle out0, const AtenTensorHandle* out1, int64_t out1_len_, const AtenTensorHandle* out2, int64_t out2_len_, AtenTensorHandle* grad_y, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, AtenTensorHandle z_state, AtenTensorHandle cell_state_fwd, AtenTensorHandle input, AtenTensorHandle layersOutputs, const AtenTensorHandle* hx, int64_t hx_len_, const AtenTensorHandle* params, int64_t params_len_, int32_t has_biases, int64_t num_layers, double dropout, int32_t train, int32_t bidirectional, int32_t batch_first) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::lstm_mps_backward_out(
            *tensor_handle_to_tensor_pointer(out0), pointer_to_list<at::Tensor>(out1, out1_len_), pointer_to_list<at::Tensor>(out2, out2_len_), pointer_to_optional<at::Tensor>(grad_y), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), *tensor_handle_to_tensor_pointer(z_state), *tensor_handle_to_tensor_pointer(cell_state_fwd), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(layersOutputs), pointer_to_list<at::Tensor>(hx, hx_len_), pointer_to_list<at::Tensor>(params, params_len_), has_biases, num_layers, dropout, train, bidirectional, batch_first
        );
    });
}


AOTITorchError aoti_torch_cpu__thnn_fused_lstm_cell_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle input_gates, AtenTensorHandle hidden_gates, AtenTensorHandle cx, AtenTensorHandle* input_bias, AtenTensorHandle* hidden_bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_thnn_fused_lstm_cell_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(input_gates), *tensor_handle_to_tensor_pointer(hidden_gates), *tensor_handle_to_tensor_pointer(cx), pointer_to_optional<at::Tensor>(input_bias), pointer_to_optional<at::Tensor>(hidden_bias)
        );
    });
}


AOTITorchError aoti_torch_cpu__thnn_fused_lstm_cell_backward_impl_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle* grad_hy, AtenTensorHandle* grad_cy, AtenTensorHandle cx, AtenTensorHandle cy, AtenTensorHandle workspace, int32_t has_bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_thnn_fused_lstm_cell_backward_impl_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), pointer_to_optional<at::Tensor>(grad_hy), pointer_to_optional<at::Tensor>(grad_cy), *tensor_handle_to_tensor_pointer(cx), *tensor_handle_to_tensor_pointer(cy), *tensor_handle_to_tensor_pointer(workspace), has_bias
        );
    });
}


AOTITorchError aoti_torch_cpu__thnn_fused_gru_cell_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input_gates, AtenTensorHandle hidden_gates, AtenTensorHandle hx, AtenTensorHandle* input_bias, AtenTensorHandle* hidden_bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_thnn_fused_gru_cell_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input_gates), *tensor_handle_to_tensor_pointer(hidden_gates), *tensor_handle_to_tensor_pointer(hx), pointer_to_optional<at::Tensor>(input_bias), pointer_to_optional<at::Tensor>(hidden_bias)
        );
    });
}


AOTITorchError aoti_torch_cpu__thnn_fused_gru_cell_backward_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle out3, AtenTensorHandle out4, AtenTensorHandle grad_hy, AtenTensorHandle workspace, int32_t has_bias) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_thnn_fused_gru_cell_backward_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(out3), *tensor_handle_to_tensor_pointer(out4), *tensor_handle_to_tensor_pointer(grad_hy), *tensor_handle_to_tensor_pointer(workspace), has_bias
        );
    });
}


AOTITorchError aoti_torch_cpu__pack_padded_sequence_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle input, AtenTensorHandle lengths, int32_t batch_first) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_pack_padded_sequence_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(input), *tensor_handle_to_tensor_pointer(lengths), batch_first
        );
    });
}


AOTITorchError aoti_torch_cpu_set_source_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle source) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::set_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(source)
        );
    });
}


AOTITorchError aoti_torch_cpu_set_source_Tensor(AtenTensorHandle self, AtenTensorHandle source, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::set(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(source)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_set_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::set_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_set(AtenTensorHandle self, AtenTensorHandle* ret0) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::set(
            *tensor_handle_to_tensor_pointer(self)
        );
        *ret0 = new_tensor_handle(std::move(tmp_result));;
    });
}


AOTITorchError aoti_torch_cpu_lift_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::lift_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_lift_fresh_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::lift_fresh_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_masked_fill_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::masked_fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), value
        );
    });
}


AOTITorchError aoti_torch_cpu_masked_fill_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::masked_fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(value)
        );
    });
}


AOTITorchError aoti_torch_cpu_masked_scatter_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, AtenTensorHandle source) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::masked_scatter_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), *tensor_handle_to_tensor_pointer(source)
        );
    });
}


AOTITorchError aoti_torch_cpu__masked_softmax_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle mask, int64_t* dim, int64_t* mask_type) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_masked_softmax_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(mask), pointer_to_optional<int64_t>(dim), pointer_to_optional<int64_t>(mask_type)
        );
    });
}


AOTITorchError aoti_torch_cpu__masked_softmax_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle output, AtenTensorHandle mask, int64_t* dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_masked_softmax_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(mask), pointer_to_optional<int64_t>(dim)
        );
    });
}


AOTITorchError aoti_torch_cpu_put_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle index, AtenTensorHandle source, int32_t accumulate) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::put_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(source), accumulate
        );
    });
}


AOTITorchError aoti_torch_cpu_index_fill_int_Scalar_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::index_fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), value
        );
    });
}


AOTITorchError aoti_torch_cpu_index_fill_int_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, AtenTensorHandle index, AtenTensorHandle value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::index_fill_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, *tensor_handle_to_tensor_pointer(index), *tensor_handle_to_tensor_pointer(value)
        );
    });
}


AOTITorchError aoti_torch_cpu_bitwise_and_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bitwise_and_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_bitwise_or_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bitwise_or_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_bitwise_xor_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bitwise_xor_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu___lshift___Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::__lshift___out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other
        );
    });
}


AOTITorchError aoti_torch_cpu___lshift___Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::__lshift___out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_bitwise_left_shift_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bitwise_left_shift_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu___rshift___Scalar_out(AtenTensorHandle out, AtenTensorHandle self, double other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::__rshift___out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), other
        );
    });
}


AOTITorchError aoti_torch_cpu___rshift___Tensor_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::__rshift___out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_bitwise_right_shift_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bitwise_right_shift_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_tril_indices_out(AtenTensorHandle out, int64_t row, int64_t col, int64_t offset) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::tril_indices_out(
            *tensor_handle_to_tensor_pointer(out), row, col, offset
        );
    });
}


AOTITorchError aoti_torch_cpu_triu_indices_out(AtenTensorHandle out, int64_t row, int64_t col, int64_t offset) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::triu_indices_out(
            *tensor_handle_to_tensor_pointer(out), row, col, offset
        );
    });
}


AOTITorchError aoti_torch_cpu_trace_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::trace_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__cholesky_solve_helper_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle A, int32_t upper) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_cholesky_solve_helper_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(A), upper
        );
    });
}


AOTITorchError aoti_torch_cpu_dist_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle other, double p) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::dist_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(other), p
        );
    });
}


AOTITorchError aoti_torch_cpu__histogramdd_bin_edges_out(const AtenTensorHandle* out, int64_t out_len_, AtenTensorHandle self, const int64_t* bins, int64_t bins_len_, const double** range, int64_t range_len_, AtenTensorHandle* weight, int32_t density) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_histogramdd_bin_edges_out(
            pointer_to_list<at::Tensor>(out, out_len_), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(bins, bins_len_), pointer_to_optional_list<double>(range, range_len_), pointer_to_optional<at::Tensor>(weight), density
        );
    });
}


AOTITorchError aoti_torch_cpu__histogramdd_from_bin_cts_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* bins, int64_t bins_len_, const double** range, int64_t range_len_, AtenTensorHandle* weight, int32_t density) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_histogramdd_from_bin_cts_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(bins, bins_len_), pointer_to_optional_list<double>(range, range_len_), pointer_to_optional<at::Tensor>(weight), density
        );
    });
}


AOTITorchError aoti_torch_cpu__histogramdd_from_bin_tensors_out(AtenTensorHandle out, AtenTensorHandle self, const AtenTensorHandle* bins, int64_t bins_len_, AtenTensorHandle* weight, int32_t density) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_histogramdd_from_bin_tensors_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<at::Tensor>(bins, bins_len_), pointer_to_optional<at::Tensor>(weight), density
        );
    });
}


AOTITorchError aoti_torch_cpu_remainder_Scalar_Tensor_out(AtenTensorHandle out, double self, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::remainder_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu_argsort_stable_out(AtenTensorHandle out, AtenTensorHandle self, int32_t stable, int64_t dim, int32_t descending) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::argsort_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), stable, dim, descending
        );
    });
}


AOTITorchError aoti_torch_cpu_unfold_backward_out(AtenTensorHandle out, AtenTensorHandle grad_in, const int64_t* input_sizes, int64_t input_sizes_len_, int64_t dim, int64_t size, int64_t step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unfold_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_in), pointer_to_list<c10::SymInt>(input_sizes, input_sizes_len_), dim, size, step
        );
    });
}


AOTITorchError aoti_torch_cpu__amp_foreach_non_finite_check_and_unscale_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle found_inf, AtenTensorHandle inv_scale) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_amp_foreach_non_finite_check_and_unscale_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(found_inf), *tensor_handle_to_tensor_pointer(inv_scale)
        );
    });
}


AOTITorchError aoti_torch_cpu__amp_update_scale_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle growth_tracker, AtenTensorHandle found_inf, double scale_growth_factor, double scale_backoff_factor, int64_t growth_interval) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_amp_update_scale_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(growth_tracker), *tensor_handle_to_tensor_pointer(found_inf), scale_growth_factor, scale_backoff_factor, growth_interval
        );
    });
}


AOTITorchError aoti_torch_cpu__amp_update_scale(AtenTensorHandle self, AtenTensorHandle growth_tracker, AtenTensorHandle found_inf, double scale_growth_factor, double scale_backoff_factor, int64_t growth_interval, AtenTensorHandle* ret0, AtenTensorHandle* ret1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        auto tmp_result = at::compositeexplicitautograd::_amp_update_scale(
            *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(growth_tracker), *tensor_handle_to_tensor_pointer(found_inf), scale_growth_factor, scale_backoff_factor, growth_interval
        );
        *ret0 = new_tensor_handle(std::move(std::get<0>(tmp_result)));;
        *ret1 = new_tensor_handle(std::move(std::get<1>(tmp_result)));;
    });
}


AOTITorchError aoti_torch_cpu__foreach_add_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_add_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_add_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_add_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_add_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_add_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sub_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_, double alpha) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sub_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_), alpha
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sub_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sub_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_mul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_mul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_mul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_mul_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_mul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_div_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_div_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_div_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_div_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, AtenTensorHandle other) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_div_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), *tensor_handle_to_tensor_pointer(other)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_max_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_max_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_max_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_max_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_min_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_min_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_clamp_min_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_clamp_min_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_maximum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_maximum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_maximum_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_maximum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double scalar) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_minimum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), scalar
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* other, int64_t other_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_minimum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(other, other_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_minimum_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_minimum_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcdiv_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), value
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcdiv_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcdiv_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, AtenTensorHandle scalars) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcdiv_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), *tensor_handle_to_tensor_pointer(scalars)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, double value) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcmul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), value
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, const double* scalars, int64_t scalars_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcmul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), pointer_to_list<c10::Scalar>(scalars, scalars_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_addcmul_Tensor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensor1, int64_t tensor1_len_, const AtenTensorHandle* tensor2, int64_t tensor2_len_, AtenTensorHandle scalars) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_addcmul_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensor1, tensor1_len_), pointer_to_list<at::Tensor>(tensor2, tensor2_len_), *tensor_handle_to_tensor_pointer(scalars)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_abs_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_abs_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_acos_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_acos_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_asin_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_asin_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_atan_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_atan_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_ceil_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_ceil_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_cos_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_cos_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_cosh_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_cosh_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_erf_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_erf_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_erfc_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_erfc_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_exp_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_exp_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_expm1_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_expm1_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_floor_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_floor_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_frac_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_frac_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lerp_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensors1, int64_t tensors1_len_, const AtenTensorHandle* weights, int64_t weights_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_lerp_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensors1, tensors1_len_), pointer_to_list<at::Tensor>(weights, weights_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lerp_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* tensors1, int64_t tensors1_len_, double weight) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_lerp_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(tensors1, tensors1_len_), weight
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_lgamma_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_lgamma_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_log_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log10_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_log10_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log1p_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_log1p_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_log2_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_log2_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_neg_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_neg_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_norm_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double ord) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_norm_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), ord
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow_List_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* exponent, int64_t exponent_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_pow_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(exponent, exponent_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow_Scalar_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, double exponent) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_pow_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), exponent
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_pow_ScalarList_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const double* exponent, int64_t exponent_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_pow_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<c10::Scalar>(exponent, exponent_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_reciprocal_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_reciprocal_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_round_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_round_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sigmoid_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sigmoid_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sign_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sign_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sin_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sin_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sinh_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sinh_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_sqrt_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_sqrt_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_tan_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_tan_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_tanh_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_tanh_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_trunc_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_trunc_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_zero_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_zero_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__foreach_copy_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* src, int64_t src_len_, int32_t non_blocking) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foreach_copy_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(src, src_len_), non_blocking
        );
    });
}


AOTITorchError aoti_torch_cpu_bucketize_Scalar_out(AtenTensorHandle out, double self, AtenTensorHandle boundaries, int32_t out_int32, int32_t right) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::bucketize_out(
            *tensor_handle_to_tensor_pointer(out), self, *tensor_handle_to_tensor_pointer(boundaries), out_int32, right
        );
    });
}


AOTITorchError aoti_torch_cpu_glu_jvp_out(AtenTensorHandle out, AtenTensorHandle glu, AtenTensorHandle x, AtenTensorHandle dx, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::glu_jvp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(glu), *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(dx), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_glu_backward_jvp_out(AtenTensorHandle out, AtenTensorHandle grad_x, AtenTensorHandle grad_glu, AtenTensorHandle x, AtenTensorHandle dgrad_glu, AtenTensorHandle dx, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::glu_backward_jvp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_x), *tensor_handle_to_tensor_pointer(grad_glu), *tensor_handle_to_tensor_pointer(x), *tensor_handle_to_tensor_pointer(dgrad_glu), *tensor_handle_to_tensor_pointer(dx), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_hardswish_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::hardswish_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_rrelu_with_noise_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle noise, double lower, double upper, int32_t training, int32_t self_is_result) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::rrelu_with_noise_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(noise), lower, upper, training, self_is_result
        );
    });
}


AOTITorchError aoti_torch_cpu_mkldnn_adaptive_avg_pool2d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::mkldnn_adaptive_avg_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool2d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_adaptive_avg_pool2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool2d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_adaptive_avg_pool2d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool3d_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_adaptive_avg_pool3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__adaptive_avg_pool3d_backward_out(AtenTensorHandle out, AtenTensorHandle grad_output, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_adaptive_avg_pool3d_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__slow_conv2d_backward_output_mask_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle out2, AtenTensorHandle grad_output, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int32_t* output_mask, int64_t output_mask_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_slow_conv2d_backward_symint_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(out2), *tensor_handle_to_tensor_pointer(grad_output), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<3>(output_mask)
        );
    });
}


AOTITorchError aoti_torch_cpu_conv_depthwise3d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::conv_depthwise3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_dilated2d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::slow_conv_dilated2d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_slow_conv_dilated3d_out(AtenTensorHandle out, AtenTensorHandle self, AtenTensorHandle weight, const int64_t* kernel_size, int64_t kernel_size_len_, AtenTensorHandle* bias, const int64_t* stride, int64_t stride_len_, const int64_t* padding, int64_t padding_len_, const int64_t* dilation, int64_t dilation_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::slow_conv_dilated3d_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), *tensor_handle_to_tensor_pointer(weight), pointer_to_list<c10::SymInt>(kernel_size, kernel_size_len_), pointer_to_optional<at::Tensor>(bias), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_list<c10::SymInt>(padding, padding_len_), pointer_to_list<c10::SymInt>(dilation, dilation_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_isinf_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::isinf_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_linalg_matrix_exp_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::linalg_matrix_exp_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_optional_intlist_out(AtenTensorHandle out, AtenTensorHandle values, const int64_t** addends, int64_t addends_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_optional_intlist_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<int64_t>(addends, addends_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_optional_filled_intlist_out(AtenTensorHandle out, AtenTensorHandle values, const int64_t** addends, int64_t addends_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_optional_filled_intlist_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<int64_t>(addends, addends_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_optional_floatlist_out(AtenTensorHandle out, AtenTensorHandle values, const double** addends, int64_t addends_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_optional_floatlist_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(values), pointer_to_optional_list<double>(addends, addends_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_warn_in_autograd_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_warn_in_autograd_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_autograd_multiple_dispatch_fullcoverage_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_autograd_multiple_dispatch_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__test_autograd_multiple_dispatch_view_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_test_autograd_multiple_dispatch_view_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_segment_reduce_out(AtenTensorHandle out, AtenTensorHandle data, const char* reduce, AtenTensorHandle* lengths, AtenTensorHandle* indices, AtenTensorHandle* offsets, int64_t axis, int32_t unsafe, double* initial) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::segment_reduce_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(data), reduce, pointer_to_optional<at::Tensor>(lengths), pointer_to_optional<at::Tensor>(indices), pointer_to_optional<at::Tensor>(offsets), axis, unsafe, pointer_to_optional<c10::Scalar>(initial)
        );
    });
}


AOTITorchError aoti_torch_cpu__segment_reduce_backward_out(AtenTensorHandle out, AtenTensorHandle grad, AtenTensorHandle output, AtenTensorHandle data, const char* reduce, AtenTensorHandle* lengths, AtenTensorHandle* offsets, int64_t axis, double* initial) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_segment_reduce_backward_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(grad), *tensor_handle_to_tensor_pointer(output), *tensor_handle_to_tensor_pointer(data), reduce, pointer_to_optional<at::Tensor>(lengths), pointer_to_optional<at::Tensor>(offsets), axis, pointer_to_optional<c10::Scalar>(initial)
        );
    });
}


AOTITorchError aoti_torch_cpu__nested_tensor_from_tensor_list_out(AtenTensorHandle out, const AtenTensorHandle* list, int64_t list_len_, int32_t* dtype, int32_t* layout, int32_t* device, int32_t device_index_, int32_t* pin_memory) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_nested_tensor_from_tensor_list_out(
            *tensor_handle_to_tensor_pointer(out), pointer_to_list<at::Tensor>(list, list_len_), pointer_to_optional<c10::ScalarType>(dtype), pointer_to_optional<c10::Layout>(layout), pointer_to_optional_device(device, device_index_), pointer_to_optional<bool>(pin_memory)
        );
    });
}


AOTITorchError aoti_torch_cpu__fw_primal_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t level) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fw_primal_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), level
        );
    });
}


AOTITorchError aoti_torch_cpu__make_dual_copy_out(AtenTensorHandle out, AtenTensorHandle primal, AtenTensorHandle tangent, int64_t level) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_make_dual_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(primal), *tensor_handle_to_tensor_pointer(tangent), level
        );
    });
}


AOTITorchError aoti_torch_cpu_view_as_real_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::view_as_real_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_view_as_complex_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::view_as_complex_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__conj_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_conj_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__neg_view_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_neg_view_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_as_strided_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_, int64_t* storage_offset) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::as_strided_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_), pointer_to_optional<c10::SymInt>(storage_offset)
        );
    });
}


AOTITorchError aoti_torch_cpu__sparse_broadcast_to_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_sparse_broadcast_to_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_diagonal_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t offset, int64_t dim1, int64_t dim2) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::diagonal_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), offset, dim1, dim2
        );
    });
}


AOTITorchError aoti_torch_cpu_expand_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, int32_t implicit) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::expand_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), implicit
        );
    });
}


AOTITorchError aoti_torch_cpu_permute_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dims, int64_t dims_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::permute_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dims, dims_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__reshape_alias_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_, const int64_t* stride, int64_t stride_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_reshape_alias_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_), pointer_to_list<c10::SymInt>(stride, stride_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_select_copy_int_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int64_t index) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::select_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, index
        );
    });
}


AOTITorchError aoti_torch_cpu_detach_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::detach_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_slice_copy_Tensor_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim, int64_t* start, int64_t* end, int64_t step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::slice_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim, pointer_to_optional<c10::SymInt>(start), pointer_to_optional<c10::SymInt>(end), step
        );
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::squeeze_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy_dim_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::squeeze_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu_squeeze_copy_dims_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* dim, int64_t dim_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::squeeze_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<int64_t>(dim, dim_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_t_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::t_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_transpose_copy_int_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim0, int64_t dim1) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::transpose_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim0, dim1
        );
    });
}


AOTITorchError aoti_torch_cpu_unsqueeze_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dim) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unsqueeze_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dim
        );
    });
}


AOTITorchError aoti_torch_cpu__indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu__values_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_values_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_values_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::values_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_crow_indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::crow_indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_col_indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::col_indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_ccol_indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::ccol_indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_row_indices_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::row_indices_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_view_copy_out(AtenTensorHandle out, AtenTensorHandle self, const int64_t* size, int64_t size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::view_copy_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), pointer_to_list<c10::SymInt>(size, size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu_view_copy_dtype_out(AtenTensorHandle out, AtenTensorHandle self, int32_t dtype) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::view_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), static_cast<c10::ScalarType>(dtype)
        );
    });
}


AOTITorchError aoti_torch_cpu_unfold_copy_out(AtenTensorHandle out, AtenTensorHandle self, int64_t dimension, int64_t size, int64_t step) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::unfold_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), dimension, size, step
        );
    });
}


AOTITorchError aoti_torch_cpu_alias_copy_out(AtenTensorHandle out, AtenTensorHandle self) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::alias_copy_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self)
        );
    });
}


AOTITorchError aoti_torch_cpu_to_padded_tensor_out(AtenTensorHandle out, AtenTensorHandle self, double padding, const int64_t** output_size, int64_t output_size_len_) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::to_padded_tensor_symint_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), padding, pointer_to_optional_list<c10::SymInt>(output_size, output_size_len_)
        );
    });
}


AOTITorchError aoti_torch_cpu__transformer_encoder_layer_fwd_out(AtenTensorHandle out, AtenTensorHandle src, int64_t embed_dim, int64_t num_heads, AtenTensorHandle qkv_weight, AtenTensorHandle qkv_bias, AtenTensorHandle proj_weight, AtenTensorHandle proj_bias, int32_t use_gelu, int32_t norm_first, double eps, AtenTensorHandle norm_weight_1, AtenTensorHandle norm_bias_1, AtenTensorHandle norm_weight_2, AtenTensorHandle norm_bias_2, AtenTensorHandle ffn_weight_1, AtenTensorHandle ffn_bias_1, AtenTensorHandle ffn_weight_2, AtenTensorHandle ffn_bias_2, AtenTensorHandle* mask, int64_t* mask_type) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_transformer_encoder_layer_fwd_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(src), embed_dim, num_heads, *tensor_handle_to_tensor_pointer(qkv_weight), *tensor_handle_to_tensor_pointer(qkv_bias), *tensor_handle_to_tensor_pointer(proj_weight), *tensor_handle_to_tensor_pointer(proj_bias), use_gelu, norm_first, eps, *tensor_handle_to_tensor_pointer(norm_weight_1), *tensor_handle_to_tensor_pointer(norm_bias_1), *tensor_handle_to_tensor_pointer(norm_weight_2), *tensor_handle_to_tensor_pointer(norm_bias_2), *tensor_handle_to_tensor_pointer(ffn_weight_1), *tensor_handle_to_tensor_pointer(ffn_bias_1), *tensor_handle_to_tensor_pointer(ffn_weight_2), *tensor_handle_to_tensor_pointer(ffn_bias_2), pointer_to_optional<at::Tensor>(mask), pointer_to_optional<int64_t>(mask_type)
        );
    });
}


AOTITorchError aoti_torch_cpu__native_multi_head_attention_out(AtenTensorHandle out0, AtenTensorHandle out1, AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, int64_t embed_dim, int64_t num_head, AtenTensorHandle qkv_weight, AtenTensorHandle qkv_bias, AtenTensorHandle proj_weight, AtenTensorHandle proj_bias, AtenTensorHandle* mask, int32_t need_weights, int32_t average_attn_weights, int64_t* mask_type) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_native_multi_head_attention_out(
            *tensor_handle_to_tensor_pointer(out0), *tensor_handle_to_tensor_pointer(out1), *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), embed_dim, num_head, *tensor_handle_to_tensor_pointer(qkv_weight), *tensor_handle_to_tensor_pointer(qkv_bias), *tensor_handle_to_tensor_pointer(proj_weight), *tensor_handle_to_tensor_pointer(proj_bias), pointer_to_optional<at::Tensor>(mask), need_weights, average_attn_weights, pointer_to_optional<int64_t>(mask_type)
        );
    });
}


AOTITorchError aoti_torch_cpu__triton_scaled_dot_attention_out(AtenTensorHandle out, AtenTensorHandle q, AtenTensorHandle k, AtenTensorHandle v, double dropout_p) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_triton_scaled_dot_attention_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(q), *tensor_handle_to_tensor_pointer(k), *tensor_handle_to_tensor_pointer(v), dropout_p
        );
    });
}


AOTITorchError aoti_torch_cpu__triton_multi_head_attention_out(AtenTensorHandle out, AtenTensorHandle query, AtenTensorHandle key, AtenTensorHandle value, int64_t embed_dim, int64_t num_head, AtenTensorHandle qkv_weight, AtenTensorHandle qkv_bias, AtenTensorHandle proj_weight, AtenTensorHandle proj_bias, AtenTensorHandle* mask) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_triton_multi_head_attention_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(query), *tensor_handle_to_tensor_pointer(key), *tensor_handle_to_tensor_pointer(value), embed_dim, num_head, *tensor_handle_to_tensor_pointer(qkv_weight), *tensor_handle_to_tensor_pointer(qkv_bias), *tensor_handle_to_tensor_pointer(proj_weight), *tensor_handle_to_tensor_pointer(proj_bias), pointer_to_optional<at::Tensor>(mask)
        );
    });
}


AOTITorchError aoti_torch_cpu__foobar_out(AtenTensorHandle out, AtenTensorHandle self, int32_t arg1, int32_t arg2, int32_t arg3) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_foobar_out(
            *tensor_handle_to_tensor_pointer(out), *tensor_handle_to_tensor_pointer(self), arg1, arg2, arg3
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_adam_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* exp_avgs, int64_t exp_avgs_len_, const AtenTensorHandle* exp_avg_sqs, int64_t exp_avg_sqs_len_, const AtenTensorHandle* max_exp_avg_sqs, int64_t max_exp_avg_sqs_len_, const AtenTensorHandle* state_steps, int64_t state_steps_len_, double lr, double beta1, double beta2, double weight_decay, double eps, int32_t amsgrad, int32_t maximize, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_adam_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(exp_avgs, exp_avgs_len_), pointer_to_list<at::Tensor>(exp_avg_sqs, exp_avg_sqs_len_), pointer_to_list<at::Tensor>(max_exp_avg_sqs, max_exp_avg_sqs_len_), pointer_to_list<at::Tensor>(state_steps, state_steps_len_), lr, beta1, beta2, weight_decay, eps, amsgrad, maximize, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_adam_tensor_lr_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* exp_avgs, int64_t exp_avgs_len_, const AtenTensorHandle* exp_avg_sqs, int64_t exp_avg_sqs_len_, const AtenTensorHandle* max_exp_avg_sqs, int64_t max_exp_avg_sqs_len_, const AtenTensorHandle* state_steps, int64_t state_steps_len_, AtenTensorHandle lr, double beta1, double beta2, double weight_decay, double eps, int32_t amsgrad, int32_t maximize, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_adam_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(exp_avgs, exp_avgs_len_), pointer_to_list<at::Tensor>(exp_avg_sqs, exp_avg_sqs_len_), pointer_to_list<at::Tensor>(max_exp_avg_sqs, max_exp_avg_sqs_len_), pointer_to_list<at::Tensor>(state_steps, state_steps_len_), *tensor_handle_to_tensor_pointer(lr), beta1, beta2, weight_decay, eps, amsgrad, maximize, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_adamw_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* exp_avgs, int64_t exp_avgs_len_, const AtenTensorHandle* exp_avg_sqs, int64_t exp_avg_sqs_len_, const AtenTensorHandle* max_exp_avg_sqs, int64_t max_exp_avg_sqs_len_, const AtenTensorHandle* state_steps, int64_t state_steps_len_, double lr, double beta1, double beta2, double weight_decay, double eps, int32_t amsgrad, int32_t maximize, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_adamw_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(exp_avgs, exp_avgs_len_), pointer_to_list<at::Tensor>(exp_avg_sqs, exp_avg_sqs_len_), pointer_to_list<at::Tensor>(max_exp_avg_sqs, max_exp_avg_sqs_len_), pointer_to_list<at::Tensor>(state_steps, state_steps_len_), lr, beta1, beta2, weight_decay, eps, amsgrad, maximize, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_adamw_tensor_lr_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* exp_avgs, int64_t exp_avgs_len_, const AtenTensorHandle* exp_avg_sqs, int64_t exp_avg_sqs_len_, const AtenTensorHandle* max_exp_avg_sqs, int64_t max_exp_avg_sqs_len_, const AtenTensorHandle* state_steps, int64_t state_steps_len_, AtenTensorHandle lr, double beta1, double beta2, double weight_decay, double eps, int32_t amsgrad, int32_t maximize, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_adamw_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(exp_avgs, exp_avgs_len_), pointer_to_list<at::Tensor>(exp_avg_sqs, exp_avg_sqs_len_), pointer_to_list<at::Tensor>(max_exp_avg_sqs, max_exp_avg_sqs_len_), pointer_to_list<at::Tensor>(state_steps, state_steps_len_), *tensor_handle_to_tensor_pointer(lr), beta1, beta2, weight_decay, eps, amsgrad, maximize, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_sgd_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* momentum_buffer_list, int64_t momentum_buffer_list_len_, double weight_decay, double momentum, double lr, double dampening, int32_t nesterov, int32_t maximize, int32_t is_first_step, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_sgd_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(momentum_buffer_list, momentum_buffer_list_len_), weight_decay, momentum, lr, dampening, nesterov, maximize, is_first_step, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


AOTITorchError aoti_torch_cpu__fused_sgd_tensor_lr_out(const AtenTensorHandle* out, int64_t out_len_, const AtenTensorHandle* self, int64_t self_len_, const AtenTensorHandle* grads, int64_t grads_len_, const AtenTensorHandle* momentum_buffer_list, int64_t momentum_buffer_list_len_, double weight_decay, double momentum, AtenTensorHandle lr, double dampening, int32_t nesterov, int32_t maximize, int32_t is_first_step, AtenTensorHandle* grad_scale, AtenTensorHandle* found_inf) {
    AOTI_TORCH_CONVERT_EXCEPTION_TO_ERROR_CODE({
        at::compositeexplicitautograd::_fused_sgd_out(
            pointer_to_list<at::Tensor>(out, out_len_), pointer_to_list<at::Tensor>(self, self_len_), pointer_to_list<at::Tensor>(grads, grads_len_), pointer_to_list<at::Tensor>(momentum_buffer_list, momentum_buffer_list_len_), weight_decay, momentum, *tensor_handle_to_tensor_pointer(lr), dampening, nesterov, maximize, is_first_step, pointer_to_optional<at::Tensor>(grad_scale), pointer_to_optional<at::Tensor>(found_inf)
        );
    });
}


